﻿using LoongCAD.Geometry;
using LoongCAD.STC.Plugins;
using LoongCAD.Util;
using LoongCAD.STC.Object3D;
using System.Collections.Generic;
using System.Linq;
using LoongCAD.STC;
using System;

namespace BeamSideEndPlate209
{
    public class PlateTools
    {
        public static void SetChamfer(ChamferCtrlPoint point, int type, double lenX, double lenY, PartBase retPlate)
        {
            if (retPlate == null)
                return;
            Define.CornerCutType chamferType;
            switch (type)
            {
                case 1:
                    //无折角
                    chamferType = Define.CornerCutType.CORNER_CUT_NONE;
                    break;
                case 3:
                    //凸弧折角
                    chamferType = Define.CornerCutType.CORNER_CUT_ROUND;
                    break;
                case 4:
                    //凹弧折角
                    chamferType = Define.CornerCutType.CORNER_CUT_INV_ROUND;
                    break;
                case 0:
                default:
                    //线折角
                    chamferType = Define.CornerCutType.CORNER_CUT_LINE;
                    break;
            }

            if (point != null)
            {
                point.CutX = lenX;
                point.CutY = lenY;
                point.CutType = chamferType;
                point.Flush();
                retPlate.Flush();
            }
        }

        public static void SetChamfer(ChamferCtrlPoint point, Define.CornerCutType type, double lenX, double lenY, PartBase retPlate)
        {
            if (retPlate == null)
                return;

            if (point != null)
            {
                point.CutX = lenX;
                point.CutY = lenY;
                point.CutType = type;
                point.Flush();
                retPlate.Flush();
            }
        }
    }
}
