﻿using LoongCAD.UI.Component;

namespace BoltedGusset_11_.Main
{
    public static class ParamNames
    {
        //标签页相关

        #region 图形标签页
        /// <summary>
        /// 节点板到主零件的间隙距离
        /// </summary>
        public static readonly string PIC_GAP_BETWEEN_GUSSET_PLATE_AND_MAIN_PART = "pic_gap_between_gusset_plate_and_main_part";
        /// <summary>
        /// 主零件到支撑的距离
        /// </summary>
        public static readonly string PIC_DISTANCE_BETWEEN_MAIN_PART_AND_BRACE = "pic_distance_between_main_part_and_brace";
        /// <summary>
        /// 支撑之间的最小距离
        /// </summary>
        public static readonly string PIC_MIN_DISTANCE_BETWEEN_THE_BRACES = "pic_min_distance_between_the_braces";
        /// <summary>
        /// 节点板拐角角度，顶部拐角(UI中为上方输入框)
        /// </summary>
        public static readonly string PIC_THE_GUSSET_PLATE_CORNER_ANGLE_TOP = "pic_the_gusset_plate_corner_angle_top";
        /// <summary>
        /// 节点板拐角角度，顶部拐角(UI中为下方输入框)
        /// </summary>
        public static readonly string PIC_THE_GUSSET_PLATE_CORNER_ANGLE_BOTTOM= "pic_the_gusset_plate_corner_angle_bottom";
        /// <summary>
        /// 节点板拐角边缘长度，顶部支撑外侧
        /// </summary>
        public static readonly string PIC_LENGTH_EDGE_OF_THE_GUSSET_PLATE_TOP_OUTSIDE = "pic_length_edge_of_the_gusset_plate_top_outside";
        /// <summary>
        /// 节点板拐角边缘长度，顶部支撑内侧
        /// </summary>
        public static readonly string PIC_LENGTH_EDGE_OF_THE_GUSSET_PLATE_TOP_INSIDE = "pic_length_edge_of_the_gusset_plate_top_inside";
        /// <summary>
        /// 节点板拐角边缘长度，底部支撑外侧
        /// </summary>
        public static readonly string PIC_LENGTH_EDGE_OF_THE_GUSSET_PLATE_BOTTOM_OUTSIDE = "pic_length_edge_of_the_gusset_plate_bottom_outside";
        /// <summary>
        /// 节点板拐角边缘长度，底部支撑内侧
        /// </summary>
        public static readonly string PIC_LENGTH_EDGE_OF_THE_GUSSET_PLATE_BOTTOM_INSIDE = "pic_length_edge_of_the_gusset_plate_bottom_inside";
        /// <summary>
        /// 连接部分到节点板顶部的距离
        /// </summary>
        public static readonly string PIC_TOP_DISTANCE_BETWEEN_CONNECTION_PART_AND_GUSSET_PLATE_EDGE = "pic_top_distance_between_connection_part_and_gusset_plate_edge";
        
        #endregion
        #region 节点板标签页
        /// <summary>
        /// 节点板的配置信息
        /// </summary>
        public static readonly string GUSSET_GUSSET_PLATE = "gusset_gusset_plate";
        /// <summary>
        /// 连接板的配置信息
        /// </summary>
        public static readonly string GUSSET_CONNECTION_PLATE= "gusset_connection_plate";
        /// <summary>
        /// L型截面的配置信息
        /// </summary>
        public static readonly string GUSSET_L_PROFILE_PLATE = "gusset_l_profile_plate";
        /// <summary>
        /// 节点板在组件Y轴方向的偏移
        /// </summary>
        public static readonly string GUSSET_GUSSET_PLATE_Y_DIRECTION_OFFSET = "gusset_gusset_plate_y_direction_offset";
        /// <summary>
        /// 节点板在组件Z轴方向的偏移
        /// </summary>
        public static readonly string GUSSET_GUSSET_PLATE_Z_DIRECTION_OFFSET = "gusset_gusset_plate_z_direction_offset";
        /// <summary>
        /// 节点板的形状选项
        /// </summary>
        public static readonly string GUSSET_GUSSET_PLATE_SHAPE_SELECT = "gusset_gusset_plate_shape_select";
        /// <summary>
        /// 节点板在支撑上的位置
        /// </summary>
        public static readonly string GUSSET_GUSSET_PLATE_POSITION_ON_BRACE_SELECT = "gusset_gusset_plate_position_on_brace_select";
        /// <summary>
        /// 选择创建连接板还是L截面板
        /// </summary>
        public static readonly string GUSSET_SELECT_CONNECTION_OR_CLIP_ANGLES = "gusset_select_connection_or_clip_angles";
        /// <summary>
        /// 选择L截面的对齐方向
        /// </summary>
        public static readonly string GUSSET_SELECT_CLIP_ANGLE_ORIENTATION = "gusset_select_clip_angle_orientation";

        /// <summary>
        /// 节点板的顶部边缘化延长距离
        /// </summary>
        public static readonly string GUSSET_MAIN_PART_EDGE_EXTENSION_DISTANCE = "gusset_main_part_edge_extension_distance";
        /// <summary>
        /// 节点板的底部边缘延长距离
        /// </summary>
        public static readonly string GUSSET_TOP_BOTTOM_EDGE_EXTENSION_DISTANCE = "gusset_top_bottom_edge_extension_distance";
        #endregion
        #region 节点板螺栓标签页
        /// <summary>
        /// 节点板螺栓的基本属性
        /// </summary>
        public static readonly string GUSSET_BOLTS_BOLT_BASIC_PROPERTIES = "gusset_bolts_bolt_basic_properties";
        /// <summary>
        /// 节点板螺栓的槽孔属性
        /// </summary>
        public static readonly string GUSSET_BOLTS_SLOTTED_HOLES = "gusset_bolts_slotted_holes";
        /// <summary>
        /// 节点板螺栓的螺栓装配
        /// </summary>
        public static readonly string GUSSET_BOLTS_BOLT_ASSEMBLY = "gusset_bolts_bolt_assembly";
        /// <summary>
        /// 节点板螺栓的长度增加
        /// </summary>
        public static readonly string GUSSET_BOLTS_BOLT_LENGTH_INCREASE = "gusset_bolts_bolt_length_increase";
        /// <summary>
        /// 节点板螺栓的交错
        /// </summary>
        public static readonly string GUSSET_BOLTS_STAGGERING_OF_BOLTS = "gusset_bolts_staggering_of_bolts";
        #region 水平方向相关 组件方向的x方向
        public static readonly string GUSSET_BOLTS_HORIZONTAL_BOLTS_NUMBER = "gusset_bolts_horizontal_bolts_number";
        public static readonly string GUSSET_BOLTS_HORIZONTAL_BOLTS_SPACING = "gusset_bolts_horizontal_bolts_spacing";
        public static readonly string GUSSET_BOLTS_HORIZONTAL_BOLTS_TOP_EDGE_DIST= "gusset_bolts_horizontal_bolts_top_edge_dist";
        public static readonly string GUSSET_BOLTS_HORIZONTAL_BOLTS_BOTTOM_EDGE_DIST= "gusset_bolts_horizontal_bolts_bottom_edge_dist";
        #endregion
        #region 垂直方向相关 组件方向的y方向
        public static readonly string GUSSET_BOLTS_VERTICAL_BOLTS_NUMBER = "gusset_bolts_vertical_bolts_number";
        public static readonly string GUSSET_BOLTS_VERTICAL_BOLTS_SPACING = "gusset_bolts_vertical_bolts_spacing";
        public static readonly string GUSSET_BOLTS_VERTICAL_BOLTS_NEAR_EDGE_DIST= "gusset_bolts_vertical_bolts_near_edge_dist";
        #endregion
        #region 特殊延长板的螺栓配置
        public static readonly string GUSSET_BOLTS_EXTENDED_VERTICAL_BOLTS_TOP_EDGE_DIST = "gusset_bolts_extended_vertical_bolts_top_edge_dist";
        public static readonly string GUSSET_BOLTS_EXTENDED_VERTICAL_BOLTS_NUMBER = "gusset_bolts_extended_vertical_bolts_number";
        public static readonly string GUSSET_BOLTS_EXTENDED_VERTICAL_BOLTS_SPACING= "gusset_bolts_extended_vertical_bolts_spacing";
        /// <summary>
        /// 延长模式螺栓到远端面的距离
        /// </summary>
        public static readonly string GUSSET_BOLTS_EXTENDED_HORIZONTAL_BOLTS_FAR_EDGE_DIST = "gusset_bolts_extended_horizontal_bolts_far_edge_dist";
        public static readonly string GUSSET_BOLTS_EXTENDED_HORIZONTAL_BOLTS_NUMBER = "gusset_bolts_extended_horizontal_bolts_number";
        public static readonly string GUSSET_BOLTS_EXTENDED_HORIZONTAL_BOLTS_SPACING= "gusset_bolts_extended_horizontal_bolts_spacing";
        #endregion
        #region 螺栓的其余配置
        /// <summary>
        /// 节点板和连接零件的螺栓制作配置
        /// </summary>
        public static readonly string GUSSET_BOLTS_SELECT_LINKED_PART_BOLTS_MADE_TYPE = "gusset_bolts_select_linked_part_bolts_made_type";
        /// <summary>
        /// 主零件和连接零件的螺栓制作配置。
        /// </summary>
        public static readonly string GUSSET_BOLTS_SELECT_MAIN_PART_BOLTS_MADE_TYPE = "gusset_bolts_select_main_part_bolts_made_type";
        /// <summary>
        /// 主零件和连接零件的螺栓对中心的偏移距离 
        /// </summary>
        public static readonly string GUSSET_BOLTS_MAIN_PART_BOLTS_CENTER_EDGE_DIST = "gusset_bolts_main_part_bolts_center_edge_dist";
        public static readonly string GUSSET_BOLTS_MAIN_PART_BOLTS_NUMBER = "gusset_bolts_main_part_bolts_number";
        public static readonly string GUSSET_BOLTS_MAIN_PART_BOLTS_SPACING= "gusset_bolts_main_part_bolts_spacing";
        #endregion
        /// <summary>
        /// 选择不适用L截面时，是否使用螺栓将节点板连接到主零件
        /// </summary>
        public static readonly string GUSSET_BOLTS_SELECT_BOLTS_ON_GUSSET_PLATE = "gusset_bolts_select_bolts_on_gusset_plate";
        /// <summary>
        /// 角钢连接类型，同时会影响不使用角钢时的螺栓和焊接选择
        /// </summary>
        public static readonly string GUSSET_BOLTS_SELECT_CLIP_ANGLE_ATTACHMENT_TYPE = "gusset_bolts_select_clip_angle_attachment_type";
        #endregion
        #region 支柱螺栓1 标签页
        /// <summary>
        /// 支柱螺栓1的基本属性
        /// </summary>
        public static readonly string BRACE_BOLTS_1_BOLT_BASIC_PROPERTIES = "brace_bolts_1_bolt_basic_properties";
        /// <summary>
        /// 支柱螺栓1的槽孔属性
        /// </summary>
        public static readonly string BRACE_BOLTS_1_SLOTTED_HOLES = "brace_bolts_1_slotted_holes";
        /// <summary>
        /// 支柱螺栓1的螺栓装配
        /// </summary>
        public static readonly string BRACE_BOLTS_1_BOLT_ASSEMBLY = "brace_bolts_1_bolt_assembly";
        /// <summary>
        /// 支柱螺栓1的长度增加
        /// </summary>
        public static readonly string BRACE_BOLTS_1_BOLT_LENGTH_INCREASE = "brace_bolts_1_bolt_length_increase";
        /// <summary>
        /// 支柱螺栓1的交错
        /// </summary>
        public static readonly string BRACE_BOLTS_1_STAGGERING_OF_BOLTS = "brace_bolts_1_staggering_of_bolts";
        /// <summary>
        /// 支柱螺栓1的水平螺栓数目
        /// </summary>
        public static readonly string BRACE_BOLTS_1_HORIZONTAL_BOLTS_NUMBER = "brace_bolts_1_horizontal_bolts_number";
        /// <summary>
        /// 支柱螺栓1的水平螺栓间距
        /// </summary>
        public static readonly string BRACE_BOLTS_1_HORIZONTAL_BOLTS_SPACING = "brace_bolts_1_horizontal_bolts_spacing";
        /// <summary>
        /// 支柱螺栓1的垂直螺栓数目
        /// </summary>
        public static readonly string BRACE_BOLTS_1_VERTICAL_BOLTS_NUMBER = "brace_bolts_1_vertical_bolts_number";
        /// <summary>
        /// 支柱螺栓1的垂直螺栓间距
        /// </summary>
        public static readonly string BRACE_BOLTS_1_VERTICAL_BOLTS_SPACING = "brace_bolts_1_vertical_bolts_spacing";
        /// <summary>
        /// 支柱螺栓1的垂直螺栓的近端边距
        /// </summary>
        public static readonly string BRACE_BOLTS_1_VERTICAL_BOLTS_NEAR_EDGE_DIST = "brace_bolts_1_vertical_bolts_near_edge_dist";
        /// <summary>
        /// 支柱螺栓1的垂直螺栓的远端边距
        /// </summary>
        public static readonly string BRACE_BOLTS_1_VERTICAL_BOLTS_FAR_EDGE_DIST = "brace_bolts_1_vertical_bolts_far_edge_dist";
        /// <summary>
        /// 支柱螺栓1的垂直螺栓组的测量方式
        /// </summary>
        public static readonly string BRACE_BOLTS_1_VERTICAL_BOLTS_SELECT_MEASURE_METHOD = "brace_bolts_1_vertical_bolts_select_measure_method";
        /// <summary>
        /// 支柱螺栓1的垂直螺栓组的在测量方式下的偏移
        /// </summary>
        public static readonly string BRACE_BOLTS_1_VERTICAL_BOLTS_MEASURE_OFFSET = "brace_bolts_1_vertical_bolts_measure_offset";
        #endregion
        #region 支柱螺栓2 标签页
        /// <summary>
        /// 支柱螺栓2的基本属性
        /// </summary>
        public static readonly string BRACE_BOLTS_2_BOLT_BASIC_PROPERTIES = "brace_bolts_2_bolt_basic_properties";
        /// <summary>
        /// 支柱螺栓2的槽孔属性
        /// </summary>
        public static readonly string BRACE_BOLTS_2_SLOTTED_HOLES = "brace_bolts_2_slotted_holes";
        /// <summary>
        /// 支柱螺栓2的螺栓装配
        /// </summary>
        public static readonly string BRACE_BOLTS_2_BOLT_ASSEMBLY = "brace_bolts_2_bolt_assembly";
        /// <summary>
        /// 支柱螺栓2的长度增加
        /// </summary>
        public static readonly string BRACE_BOLTS_2_BOLT_LENGTH_INCREASE = "brace_bolts_2_bolt_length_increase";
        /// <summary>
        /// 支柱螺栓2的交错
        /// </summary>
        public static readonly string BRACE_BOLTS_2_STAGGERING_OF_BOLTS = "brace_bolts_2_staggering_of_bolts";
        /// <summary>
        /// 支柱螺栓2的水平螺栓数目
        /// </summary>
        public static readonly string BRACE_BOLTS_2_HORIZONTAL_BOLTS_NUMBER = "brace_bolts_2_horizontal_bolts_number";
        /// <summary>
        /// 支柱螺栓2的水平螺栓间距
        /// </summary>
        public static readonly string BRACE_BOLTS_2_HORIZONTAL_BOLTS_SPACING = "brace_bolts_2_horizontal_bolts_spacing";
        /// <summary>
        /// 支柱螺栓2的垂直螺栓数目
        /// </summary>
        public static readonly string BRACE_BOLTS_2_VERTICAL_BOLTS_NUMBER = "brace_bolts_2_vertical_bolts_number";
        /// <summary>
        /// 支柱螺栓2的垂直螺栓间距
        /// </summary>
        public static readonly string BRACE_BOLTS_2_VERTICAL_BOLTS_SPACING = "brace_bolts_2_vertical_bolts_spacing";
        /// <summary>
        /// 支柱螺栓2的垂直螺栓的以对齐面为参考的近端边距
        /// </summary>
        public static readonly string BRACE_BOLTS_2_VERTICAL_BOLTS_NEAR_EDGE_DIST = "brace_bolts_2_vertical_bolts_near_edge_dist";
        /// <summary>
        /// 支柱螺栓2的垂直螺栓的以对齐面为参考的远端边距
        /// </summary>
        public static readonly string BRACE_BOLTS_2_VERTICAL_BOLTS_FAR_EDGE_DIST = "brace_bolts_2_vertical_bolts_far_edge_dist";
        /// <summary>
        /// 支柱螺栓2的垂直螺栓组的测量方式
        /// </summary>
        public static readonly string BRACE_BOLTS_2_VERTICAL_BOLTS_SELECT_MEASURE_METHOD = "brace_bolts_2_vertical_bolts_select_measure_method";
        /// <summary>
        /// 支柱螺栓2的垂直螺栓组的在测量方式下的偏移
        /// </summary>
        public static readonly string BRACE_BOLTS_2_VERTICAL_BOLTS_MEASURE_OFFSET = "brace_bolts_2_vertical_bolts_measure_offset";
        #endregion
        #region 支柱螺栓3 标签页
        /// <summary>
        /// 支柱螺栓3的基本属性
        /// </summary>
        public static readonly string BRACE_BOLTS_3_BOLT_BASIC_PROPERTIES = "brace_bolts_3_bolt_basic_properties";
        /// <summary>
        /// 支柱螺栓3的槽孔属性
        /// </summary>
        public static readonly string BRACE_BOLTS_3_SLOTTED_HOLES = "brace_bolts_3_slotted_holes";
        /// <summary>
        /// 支柱螺栓3的螺栓装配
        /// </summary>
        public static readonly string BRACE_BOLTS_3_BOLT_ASSEMBLY = "brace_bolts_3_bolt_assembly";
        /// <summary>
        /// 支柱螺栓3的长度增加
        /// </summary>
        public static readonly string BRACE_BOLTS_3_BOLT_LENGTH_INCREASE = "brace_bolts_3_bolt_length_increase";
        /// <summary>
        /// 支柱螺栓3的交错
        /// </summary>
        public static readonly string BRACE_BOLTS_3_STAGGERING_OF_BOLTS = "brace_bolts_3_staggering_of_bolts";
        /// <summary>
        /// 支柱螺栓3的水平螺栓数目
        /// </summary>
        public static readonly string BRACE_BOLTS_3_HORIZONTAL_BOLTS_NUMBER = "brace_bolts_3_horizontal_bolts_number";
        /// <summary>
        /// 支柱螺栓3的水平螺栓间距
        /// </summary>
        public static readonly string BRACE_BOLTS_3_HORIZONTAL_BOLTS_SPACING = "brace_bolts_3_horizontal_bolts_spacing";
        /// <summary>
        /// 支柱螺栓3的垂直螺栓数目
        /// </summary>
        public static readonly string BRACE_BOLTS_3_VERTICAL_BOLTS_NUMBER = "brace_bolts_3_vertical_bolts_number";
        /// <summary>
        /// 支柱螺栓3的垂直螺栓间距
        /// </summary>
        public static readonly string BRACE_BOLTS_3_VERTICAL_BOLTS_SPACING = "brace_bolts_3_vertical_bolts_spacing";
        /// <summary>
        /// 支柱螺栓3的垂直螺栓的近端边距
        /// </summary>
        public static readonly string BRACE_BOLTS_3_VERTICAL_BOLTS_NEAR_EDGE_DIST = "brace_bolts_3_vertical_bolts_near_edge_dist";
        /// <summary>
        /// 支柱螺栓3的垂直螺栓的远端边距
        /// </summary>
        public static readonly string BRACE_BOLTS_3_VERTICAL_BOLTS_FAR_EDGE_DIST = "brace_bolts_3_vertical_bolts_far_edge_dist";
        /// <summary>
        /// 支柱螺栓3的垂直螺栓组的测量方式
        /// </summary>
        public static readonly string BRACE_BOLTS_3_VERTICAL_BOLTS_SELECT_MEASURE_METHOD = "brace_bolts_3_vertical_bolts_select_measure_method";
        /// <summary>
        /// 支柱螺栓3的垂直螺栓组的在测量方式下的偏移
        /// </summary>
        public static readonly string BRACE_BOLTS_3_VERTICAL_BOLTS_MEASURE_OFFSET = "brace_bolts_3_vertical_bolts_measure_offset";
        #endregion

        #region 附加控制
        public static readonly string  PIC_BRACE_1_ALIGN_DIST = "pic_brace_1_align_dist"; 
        public static readonly string  PIC_BRACE_2_ALIGN_DIST = "pic_brace_2_align_dist";
        public static readonly string  PIC_BRACE_3_ALIGN_DIST = "pic_brace_3_align_dist";
        
        public static readonly string   BRACE_BOLTS_1_SELECT_WELD_ON_GUSSET_PLATE= "brace_bolts_1_select_weld_on_gusset_plate";
        public static readonly string   BRACE_BOLTS_2_SELECT_WELD_ON_GUSSET_PLATE= "brace_bolts_2_select_weld_on_gusset_plate";
        public static readonly string   BRACE_BOLTS_3_SELECT_WELD_ON_GUSSET_PLATE= "brace_bolts_3_select_weld_on_gusset_plate";
        
        #endregion

        /// <summary>
        ///焊缝数组 
        /// </summary>
        public static readonly string[] WELD_PROPS_LIST = {
            "weld_props0",
            "weld_props1",
            "weld_props2",
            "weld_props3",
            "weld_props4",
#if Example 
            "weld_props0",
            //"weld_props1",  | 以这种固定的名称形式添加
#endif
        };
    }
}