﻿using System;
using BoltedGusset_11_.Main;

namespace BoltedGusset_11_.Running
{
    public class BuildBraceNotch:RunningBaseClass
    {
        public BuildBraceNotch(ComponentInstanceContext context, ParserSubPart subPart) : base(context)
        {
            m_subPart = subPart;
        }

        private readonly ParserSubPart m_subPart;
        
        /// <summary>
        /// 执行支撑对齐操作
        /// </summary>
        private bool ExecuteAlignment()
        {
            foreach (var sub in m_subPart.SubData)
            {
                var cutPlane = m_context.TargetComp.CreateAlignPlane(sub.Beam, 
                    sub.NearAlignPlane, true);
                if (cutPlane == null)
                {
                    Console.WriteLine(@"CreateAlignPlane fail");
                    return false;
                }
            }
            return true;
        }

        public override bool Execute()
        {
            if (!ExecuteAlignment())
            {
                return false;
            }
            return true;
        }
    }
}