﻿using BoltedGusset_11_.Main;
using LoongCAD.STC.Plugins;

namespace BoltedGusset_11_.Running
{
    public class PublicParamData:RunningBaseClass
    {
        public PublicParamData(ComponentInstanceContext context) : base(context)
        {
            m_context.PublicParamData = this;
        }


        /// <summary>
        /// 构建连接板和L截面板的选择
        /// </summary>
        public int SelectConnectionPlateOrLProfile { get; set; }
        /// <summary>
        /// 选择L截面的对齐方式
        /// </summary>
        public int SelectClipAngleOrientation { get; set; }
        
        /// <summary>
        /// 节点板的形状选择
        /// </summary>
        public int ShapeSelect { get; set; }
        /// <summary>
        /// 节点板的解析器
        /// </summary>
        internal PlateProperties GussetPlatePro { get; set; } = new PlateProperties();
        
        /// <summary>
        /// 连接板的解析器
        /// </summary>
        public PlateProperties ConnectionPlatePro { get; set; } = new PlateProperties();
        
        /// <summary>
        /// 节点板、主零件与连接件的连接方式。
        /// </summary>
        public int SelectClipAngleAttachmentType { get; private set; }
        
        /// <summary>
        /// 底部的延迟距离
        /// </summary>
        public double TopBottomExtendedDist { get; set; }
        
        public override bool Init()
        {
            var handler = m_context.ParamsHandler;
            SelectConnectionPlateOrLProfile = handler.GetIntValue(ParamNames.GUSSET_SELECT_CONNECTION_OR_CLIP_ANGLES);
            ShapeSelect = handler.GetIntValue(ParamNames.GUSSET_GUSSET_PLATE_SHAPE_SELECT);
            GussetPlatePro.SetProps(handler.GetDObjectValue(ParamNames.GUSSET_GUSSET_PLATE));
            SelectClipAngleOrientation = handler.GetIntValue(ParamNames.GUSSET_SELECT_CLIP_ANGLE_ORIENTATION);
            ConnectionPlatePro.SetProps (handler.GetDObjectValue(ParamNames.GUSSET_CONNECTION_PLATE));
            SelectClipAngleAttachmentType = handler.GetIntValue (ParamNames.GUSSET_BOLTS_SELECT_CLIP_ANGLE_ATTACHMENT_TYPE);
            TopBottomExtendedDist= handler.GetDoubleValue(ParamNames.GUSSET_TOP_BOTTOM_EDGE_EXTENSION_DISTANCE);
            return true;
        }
    }
}