﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using LoongCAD.UI.Component;
using LoongCAD.Util;

namespace ColdRolledOverlap1
{
    public class ParamsHandler : LoongCAD.STC.Plugins.ParamsHandlerBase
    {
        /// <summary>
        /// 属性空值全局总表
        /// </summary>
        /// <remarks><b>此静态变量可直接复制到其他组件代码中使用</b></remarks>
        protected static DObject g_emptyValues = null;

        /// <summary>
        /// 属性内置默认值全局总表
        /// </summary>
        /// <remarks><b>此静态变量可直接复制到其他组件代码中使用</b></remarks>
        protected static DObject g_builtinDefaults = null;

        /// <summary>
        /// 默认构造函数
        /// </summary>
        /// <remarks><b>此方法需要复制到其他组件代码中使用</b></remarks>
        public ParamsHandler()
            : base(ParamsHandler.EmptyValues, ParamsHandler.BuiltinDefautls)
        {

        }

        public static void IntializeEmptyDefaults()
        {
            g_emptyValues = new DObject();
            g_builtinDefaults = new DObject();

            //图形页
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.PURLIN_ALIGN_GAP, double.MaxValue, 10.0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.PURLIN_ALIGN_MARGIN, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.CLEAT_HEIGHT, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.CLEAT_WIDTH, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.PURLIN_ALIGN_PLANE_OFFSET, double.MaxValue, 0d);

            //夹板页
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.CLEAT_PROFILE, BeamPropertyPanel.EmptyValue, (DObject)new object[] {
                    BeamPropertyPanel.ParamNames.NoPrefix, "",
                    BeamPropertyPanel.ParamNames.NoStartPostfix, "1",
                    BeamPropertyPanel.ParamNames.AssNoPrefix, "",
                    BeamPropertyPanel.ParamNames.AssNoStartPostfix, "1",
                    BeamPropertyPanel.ParamNames.Material, "Q235B",
                    BeamPropertyPanel.ParamNames.Name, "檩托板",
                    BeamPropertyPanel.ParamNames.Profile, ""
                });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.CLEAT_STIFF_PROPS, PlatePropertyPanel.EmptyValue, (DObject)new object[] {
                    PlatePropertyPanel.ParamNames.NoPrefix, "",
                    PlatePropertyPanel.ParamNames.NoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.AssNoPrefix, "",
                    PlatePropertyPanel.ParamNames.AssNoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.Material, "Q235B",
                    PlatePropertyPanel.ParamNames.Name, "加劲肋",
                    PlatePropertyPanel.ParamNames.Thickness, 6.0
                });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.CLEAT_MODE, 0, 0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.CREATE_ORIENT, 0, 0); //默认朝向，自动
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.CLEAT_RAFTER_CONNECT_MODE, 0, 0); 
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.CLEAT_STIFF_TOP_CHAMFER_X, double.MaxValue, 10.0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.CLEAT_STIFF_TOP_CHAMFER_Y, double.MaxValue, 10.0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.CLEAT_STIFF_BOTTOM_INSIDE_CHAMFER_X, double.MaxValue, 10.0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.CLEAT_STIFF_BOTTOM_INSIDE_CHAMFER_Y, double.MaxValue, 10.0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.CLEAT_STIFF_BOTTOM_OUTSIDE_CHAMFER_X, double.MaxValue, 10.0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.CLEAT_STIFF_BOTTOM_OUTSIDE_CHAMFER_Y, double.MaxValue, 10.0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.CLEAT_RAFTER_BOLT_GAP_HORI, double.MaxValue, double.MaxValue);//
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.CLEAT_RAFTER_BOLT_COUNT_VERT, int.MaxValue, 1);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.CLEAT_RAFTER_BOLT_STRIDE_VERT, new double[] { }, new double[] { 60 });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.CLEAT_RAFTER_BOLT_INSIDE_MARGIN_VERT, double.MaxValue, 40);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.CREATE_PLANE_OFFSET, double.MaxValue, 0d);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.CLEAT_RAFTER_BOLT_BASIC_PROPS, BoltBasicPropertyPanel.EmptyValue, (DObject)new object[] {
                    BoltBasicPropertyPanel.ParamNames.BoltStandard, "TS10.9",
                    BoltBasicPropertyPanel.ParamNames.BoltSize, 20,
                    BoltBasicPropertyPanel.ParamNames.ThreadInMtrl, 1, // false
                    BoltBasicPropertyPanel.ParamNames.MadeType0, 1, // Site
                });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.CLEAT_RAFTER_BOLT_CONTENT_PROPS, null, (DObject)new object[]
{
                BoltContentPanel.ParamNames.PartWasherUp, false,
                BoltContentPanel.ParamNames.PartWasherDown0, false,
                BoltContentPanel.ParamNames.PartWasherDown1, true,
                BoltContentPanel.ParamNames.PartNut0, true,
                BoltContentPanel.ParamNames.PartNut1, false,
});
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.CLEAT_STIFF_MARGIN_TOP, double.MaxValue, 10.0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.CLEAT_STIFF_MARGIN_INSIDE, double.MaxValue, 50.0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.CLEAT_STIFF_MARGIN_TOP, double.MaxValue, 0d);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.CLEAT_NOTCH_OPEN, 0, 2);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.NOTCH_MARGIN_CENTER, double.MaxValue, 0d);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.NOTCH_MARGIN_SIDE, double.MaxValue, 10.0);

            //拉条页
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.STAY_PROFILE, BeamPropertyPanel.EmptyValue, (DObject)new object[] {
                    BeamPropertyPanel.ParamNames.NoPrefix, "",
                    BeamPropertyPanel.ParamNames.NoStartPostfix, "1",
                    BeamPropertyPanel.ParamNames.AssNoPrefix, "",
                    BeamPropertyPanel.ParamNames.AssNoStartPostfix, "1",
                    BeamPropertyPanel.ParamNames.Material, "Q235B",
                    BeamPropertyPanel.ParamNames.Name, "隅撑",
                    BeamPropertyPanel.ParamNames.Profile, "L60*6"
                });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.STAY_STIFF_PROPS, PlatePropertyPanel.EmptyValue, (DObject)new object[] {
                    PlatePropertyPanel.ParamNames.NoPrefix, "",
                    PlatePropertyPanel.ParamNames.NoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.AssNoPrefix, "",
                    PlatePropertyPanel.ParamNames.AssNoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.Material, "Q235B",
                    PlatePropertyPanel.ParamNames.Name, "下连接板",
                    PlatePropertyPanel.ParamNames.Thickness, 6.0,
                    PlatePropertyPanel.ParamNames.Width, double.MaxValue,
                    PlatePropertyPanel.ParamNames.Heigth, double.MaxValue
                });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.STAY_TOP_STIFF_PROPS, PlatePropertyPanel.EmptyValue, (DObject)new object[] {
                    PlatePropertyPanel.ParamNames.NoPrefix, "",
                    PlatePropertyPanel.ParamNames.NoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.AssNoPrefix, "",
                    PlatePropertyPanel.ParamNames.AssNoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.Material, "Q235B",
                    PlatePropertyPanel.ParamNames.Name, "上连接板",
                    PlatePropertyPanel.ParamNames.Thickness, 6.0,
                    PlatePropertyPanel.ParamNames.Width, double.MaxValue,
                    PlatePropertyPanel.ParamNames.Heigth, double.MaxValue
                });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.STAY_STIFF_VERT_OFFSET, double.MaxValue, 0d);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.STAY_STIFF_CHAMFER_X, double.MaxValue, 15.0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.STAY_STIFF_CHAMFER_Y, double.MaxValue, 15.0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.STAY_STIFF_CHAMFER_TYPE, 0, 1);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.STAY_PLACE, 0, 1);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.PURIN_WEB_HOLE, 0, 1);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.STAY_ANGLE, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.STAY_BOTTOM_BOLT_HORI_OFFSET, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.STAY_BOTTOM_BOLT_VERT_OFFSET, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.STAY_TOP_BOLT_VERT_OFFSET, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.STAY_TOP_BOLT_VERT_ALIGN_MODE, 0, 3);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.STAY_TOP_BOLT_HORI_OFFSET_LEFT, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.STAY_TOP_BOLT_HORI_OFFSET_RIGHT, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.STAY_BOLT_SIDE_MARGIN_LEFT, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.STAY_BOLT_SIDE_MARGIN_RIGHT, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.STAY_BOLT_BOTTOM_MARGIN, double.MaxValue, 40.0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.STAY_BOLT_TOP_MARGIN, double.MaxValue, 40.0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.STAY_PURLIN_BOLT_BASIC_PROPS, BoltBasicPropertyPanel.EmptyValue, (DObject)new object[] {
                    BoltBasicPropertyPanel.ParamNames.BoltStandard, "TS10.9",
                    BoltBasicPropertyPanel.ParamNames.BoltSize, 20,
                    BoltBasicPropertyPanel.ParamNames.ThreadInMtrl, 1, // false
                    BoltBasicPropertyPanel.ParamNames.MadeType0, 1, // Site
                });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.STAY_RAFTER_BOLT_BASIC_PROPS, BoltBasicPropertyPanel.EmptyValue, (DObject)new object[] {
                    BoltBasicPropertyPanel.ParamNames.BoltStandard, "TS10.9",
                    BoltBasicPropertyPanel.ParamNames.BoltSize, 20,
                    BoltBasicPropertyPanel.ParamNames.ThreadInMtrl, 1, // false
                    BoltBasicPropertyPanel.ParamNames.MadeType0, 1, // Site
                });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.STAY_PURLIN_BOLT_COUNT, int.MaxValue, 1);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.STAY_PURLIN_BOLT_STRIDE, new double[] { }, new double[] { 60.0 });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.STAY_STIFF_BOLT_COUNT, int.MaxValue, 1);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.STAY_STIFF_BOLT_STRIDE, new double[] { }, new double[] { 60.0 });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.STAY_TOP_STIFF_OPEN, 0, 1);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.STAY_TOP_STIFF_WIDTH, double.MaxValue, 100.0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.STAY_TOP_STIFF_HEIGHT, double.MaxValue, 100.0);


            //螺栓页
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.CLEAT_BOLT_BASIC_PROPS, BoltBasicPropertyPanel.EmptyValue, (DObject)new object[] {
                    BoltBasicPropertyPanel.ParamNames.BoltStandard, "TS10.9",
                    BoltBasicPropertyPanel.ParamNames.BoltSize, 20,
                    BoltBasicPropertyPanel.ParamNames.ThreadInMtrl, 1, // false
                    BoltBasicPropertyPanel.ParamNames.MadeType0, 1, // Site
                });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.CLEAT_BOLT_HOLE_PROPS, BoltHolePanel.EmptyValue, (DObject)new object[] {
                BoltHolePanel.ParamNames.HoleX, 0.0,
                BoltHolePanel.ParamNames.HoleY, 0.0,
                BoltHolePanel.ParamNames.HoleType, 2,
                BoltHolePanel.ParamNames.RotSlot, 3,
                BoltHolePanel.ParamNames.SlotIn, 4
            });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.CLEAT_BOLT_CONTENT_PROPS, null, (DObject)new object[]
            {
                BoltContentPanel.ParamNames.PartWasherUp, false,
                BoltContentPanel.ParamNames.PartWasherDown0, false,
                BoltContentPanel.ParamNames.PartWasherDown1, true,
                BoltContentPanel.ParamNames.PartNut0, true,
                BoltContentPanel.ParamNames.PartNut1, false,
            });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.CLEAT_BOLT_EXTEND_PROPS, BoltExtendPanel.EmptyValue, (DObject)new object[]
            {
                BoltExtendPanel.ParamNames.ExtLength, 0.0,
            });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.CLEAT_BOLT_PURLIN_MARGIN_TOP, double.MaxValue, double.MaxValue);//垂直
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.CLEAT_BOLT_PURLIN_MARGIN_BOTTOM, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.CLEAT_BOLT_PURLIN_STRIDE_VERT, new double[] { }, new double[] { });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.CLEAT_BOLT_PURLIN_COUNT_VERT, int.MaxValue, int.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.CLEAT_BOLT_PURLIN_MARGIN_LEFT, double.MaxValue, double.MaxValue);//水平
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.CLEAT_BOLT_PURLIN_MARGIN_RIGHT, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.CLEAT_BOLT_PURLIN_STRIDE_HORI, new double[] { }, new double[] { });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.CLEAT_BOLT_PURLIN_COUNT_HORI, int.MaxValue, int.MaxValue);

            //檩条重叠
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.OVERLAP_MODE, 0, 2);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.OVERLAP_OFFSET, double.MaxValue, 0d);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.OVERLAP_BOLT_GAP, double.MaxValue, 800.0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.OVERLAP_BOLT_MARGIN, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.OVERLAP_BOLT_MARGIN_TOP, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.OVERLAP_BOLT_MARGIN_BOTTOM, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.OVERLAP_BOLT_VERT_GAP, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.OVERLAP_BOLT_HOLE, 0, 1);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.OVERLAP_BOLT_PLACE, 0, 1);

            // 焊缝
            for (int i = 0; i < ParamNames.WELD_PROPS_LIST.Length; ++i)
            {
                AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.WELD_PROPS_LIST[i], WeldPropertyPanel.EmptyValue, new DObject {
                    { WeldPropertyPanel.ParamNames.SizeUp, 6 },
                    { WeldPropertyPanel.ParamNames.WeldTypeUp, 1 }, // None
                    { WeldPropertyPanel.ParamNames.GrooveAngleUp, 0.0 },
                    { WeldPropertyPanel.ParamNames.WeldContourUp,  1}, // None
                    { WeldPropertyPanel.ParamNames.WeldFinishUp, 1 }, // None
                    { WeldPropertyPanel.ParamNames.LengthUp, 0.0 },
                    { WeldPropertyPanel.ParamNames.PitchUp, 0.0 },
                    { WeldPropertyPanel.ParamNames.RootFaceUp, 0.0 },
                    { WeldPropertyPanel.ParamNames.EffectiveThroatUp, 0.0 },
                    { WeldPropertyPanel.ParamNames.RootGapUp, 0.0 },

                    { WeldPropertyPanel.ParamNames.SizeDown, 6 },
                    { WeldPropertyPanel.ParamNames.WeldTypeDown, 1 }, // None
                    { WeldPropertyPanel.ParamNames.GrooveAngleDown, 0.0 },
                    { WeldPropertyPanel.ParamNames.WeldContourDown,  1}, // None
                    { WeldPropertyPanel.ParamNames.WeldFinishDown, 1 }, // None
                    { WeldPropertyPanel.ParamNames.LengthDown, 0.0 },
                    { WeldPropertyPanel.ParamNames.PitchDown, 0.0 },
                    { WeldPropertyPanel.ParamNames.RootFaceDown, 0.0 },
                    { WeldPropertyPanel.ParamNames.EffectiveThroatDown, 0.0 },
                    { WeldPropertyPanel.ParamNames.RootGapDown, 0.0 },

                    { WeldPropertyPanel.ParamNames.EdgeAround, 1 }, // Edge
                    { WeldPropertyPanel.ParamNames.MadeType, 2 }, // Workshop
                    { WeldPropertyPanel.ParamNames.StitchWeld, 1 }, // false
                    { WeldPropertyPanel.ParamNames.RefText, "" }
                });
            }
        }

        /// <summary>
        /// 组件公用属性空值表
        /// </summary>
        /// <remarks><b>此方法可直接复制到其他组件代码中使用</b></remarks>
        public static DObject EmptyValues
        {
            get
            {
                if (g_emptyValues == null)
                {
                    IntializeEmptyDefaults();
                }
                return g_emptyValues;
            }
        }

        /// <summary>
        /// 组件公用内置默认值接口
        /// </summary>
        /// <remarks><b>此方法可直接复制到其他组件代码中使用</b></remarks>
        public static DObject BuiltinDefautls
        {
            get
            {
                if (g_builtinDefaults == null)
                {
                    IntializeEmptyDefaults();
                }
                return g_builtinDefaults;
            }
        }

        /// <summary>
        /// 初始化默认值
        /// </summary>
        /// <param name="defaultConfig">从默认值配置加载的默认值</param>
        /// <remarks><b>此方法可直接复制到其他组件代码中使用</b></remarks>
        public override LoongCAD.Util.DObject InitializeDefaultValues(DObject defaultConfig)
        {
            m_defaultValues = new DObject();
            m_defaultValues.CopyFrom(defaultConfig);

            var emptyValues = ParamsHandler.EmptyValues;
            var builtinDefaults = ParamsHandler.BuiltinDefautls;
            if (emptyValues == null || builtinDefaults == null)
            {
                Console.WriteLine("ParamsHandler.InitializeDefaultValues: [Warning] EmptyValue/BuiltinDefaults is null!");
                return m_defaultValues;
            }

            this.TryCompleteDObjectValues(m_defaultValues, builtinDefaults, emptyValues);
            return m_defaultValues;
        }



    }
}
