﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using LoongCAD.STC.Object3D;
using LoongCAD.STC.Plugins;
using LoongCAD.UI;
using LoongCAD.Util;

namespace ColumnSplice42
{
    public partial class Form_PluginMain : LoongCAD.UI.Component.Form_ConnectionComponentProps
    {
        private DObject m_rootUIProps = new DObject();
        private ComponentPlugin m_refPlugin = null;
        public Form_PluginMain(ComponentPlugin refPlugin)
        {
            InitializeComponent();
            m_refPlugin = refPlugin;
            this.OnPostIntialize();
        }
        public override ComponentPlugin ReferencePlugin => m_refPlugin;

        private void OnPostIntialize()
        {
            // 设置窗口标题
            this.Text = "柱接合42";

            foreach (TabPage curPage in this.tab_main.TabPages)
            {
                curPage.AutoScroll = true;
            }

            this.tb_arg_hole_mode.ClearItems();
            this.tb_arg_hole_mode.AddIntegerItems(0, 0, 3);
            this.tb_arg_hole_mode.UpdateItems();

            this.tb_arg_share_nums.ClearItems();
            this.tb_arg_share_nums.AddIntegerItems(0, 0, 4);
            this.tb_arg_share_nums.UpdateItems();

            //工厂螺栓选项
            this.tb_factory_mode_web_top.ClearItems();
            this.tb_factory_mode_web_top.AddItem(0, "默认");
            this.tb_factory_mode_web_top.AddItem(1, "工地");
            this.tb_factory_mode_web_top.AddItem(2, "车间");
            this.tb_factory_mode_web_top.UpdateItems();

            this.tb_factory_mode_web_bottom.ClearItems();
            this.tb_factory_mode_web_bottom.AddItem(0, "默认");
            this.tb_factory_mode_web_bottom.AddItem(1, "工地");
            this.tb_factory_mode_web_bottom.AddItem(2, "车间");
            this.tb_factory_mode_web_bottom.UpdateItems();

            //
            this.panel_web_bolt_basic_property.BoltStandardChanged += this.bolt_web_ContentPanel.AdaptBoltContents;
            //this.panel_flange_bolt_basic_property.BoltStandardChanged += this.flange_bolt_content_props.AdaptBoltContents;

        }
        public override void ClearUI(Control root = null)
        {
            // 刷新螺栓基础面板
            this.panel_web_bolt_basic_property.RefreshControls();
            this.panel_flange_bolt_basic_property.RefreshControls();
            base.ClearUI(root);
        }
        protected override void UpdatePlaceholders(DObject compProps, DObject defaultValues)
        {
            // 螺栓垫片设置
            defaultValues = ParamsHandlerBase.SelectDefaultsByEmpty(compProps, defaultValues, ParamsHandler.EmptyValues);
            this.SetPlaceholders(defaultValues);
        }

        private void tb_arg_hole_mode_SelectedIndexChanged(object sender, EventArgs e)
        {
            int select = tb_arg_hole_mode.SelectedIntKey;
            if (select == 0 || select == 1)
            {
                this.act_arg_hole_gap_h.Enabled = false;
                this.tb_arg_hole_gap_h.Enabled = false;
                this.tb_arg_hole_r.Enabled = false;
                this.act_arg_hole_r.Enabled = false;
                this.tb_arg_hole_gap_v.Enabled = false;
                this.act_arg_hole_gap_v.Enabled = false;
            }
            else
            {
                this.act_arg_hole_gap_h.Enabled = true;
                this.tb_arg_hole_gap_h.Enabled = true;
                this.tb_arg_hole_r.Enabled = true;
                this.act_arg_hole_r.Enabled = true;
                this.tb_arg_hole_gap_v.Enabled = true;
                this.act_arg_hole_gap_v.Enabled = true;

            }
        }

        private void tabPage4_Click(object sender, EventArgs e)
        {

        }
    }
}
