﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ColumnWithStiffeners182
{
    
    public enum EndCutMode
    {
        DEFAULT = 0,
        AUTOMATIC = 1,
        SQUARE = 2,
        BEVEL = 3,
        SQUARE_AND_CLOSER = 4,
        CLIPPED_FLANGE = 5,
    }

    public enum WebEndCutMode
    {
        DEFAULT = 0,
        BEVEL = 1,
        SQUARE = 2,
    }

    public enum FlangeEndCutMode
    {
        DEFAULT = 0,
        BEVEL = 1,
        SQUARE = 2,
    }

    public enum BoltOffsetMode
    {
        TOP = 1,
        MIDDLE = 2,
        BOTTOM = 3
    }

    public enum PlateOpenMode
    {
        AUTO = 1,
        FRONT = 2,
        BOTH = 3,
        BACK = 4
    }

    public enum BoltArrangeMode
    {
        AUTO = 1,

        /// <summary>
        /// 竖直方向平行于主零件，水平方向平行于次零件
        /// </summary>
        MIX = 2,

        /// <summary>
        /// 垂直于柱排列（水平排列）
        /// </summary>
        PARALLEL_MAIN = 3,

        /// <summary>
        /// 平行于次零件排列
        /// </summary>
        PARALLEL_SUB = 4,
    }

    public enum PlateOrient
    {
        AUTO = 1,

        /// <summary>
        /// 板末端平行于次梁
        /// </summary>
        PARALLEL_SUB = 2,

        /// <summary>
        /// 垂直于柱（水平方向）
        /// </summary>
        PARALLEL_MAIN = 3

    }

    public enum HaunchOpen
    {
        AUTO = 1,
        OPEN = 2,
        CLOSE = 3
    }

    public enum WeldReadyMode
    {
        AUTO = 0,
        OPEN = 1,
        CLOSE = 2
    }

    /// <summary>
    /// 接头板形状，凸形或方形
    /// </summary>
    public enum ConnPlateShape
    {
        CONVEX = 0,
        SQUARE = 1
    }

    /// <summary>
    /// 次梁对齐边界还是腹板
    /// </summary>
    public enum BeamAlignPlane
    {
        ALIGN_WEB = 0,
        ALIGN_BOUND = 1
    }

    public enum StiffCreationMode
    {
        DEFAULT = 0,
        AUTO = 1,
        CLOSE = 2,
        OPEN = 3
    }

    public enum StiffShape
    {
        DEFAULT = 0,
        AUTO = 1,
        CLOSE_CHAMFER = 2,
        OPEN_CHAMFER = 3
    }

    public enum ChamferType
    {
        DEFAULT = 0,
        NONE = 1,
        LINE = 2,
        ROUND = 3,
        INV_ROUND = 4
    }
}
