﻿using LoongCAD.UI.Component;
using LoongCAD.Util;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ConnectingPlates14
{
    public class ParamsHandler : LoongCAD.STC.Plugins.ParamsHandlerBase
    {

        /// <summary>
        /// 属性空值全局总表
        /// </summary>
        /// <remarks><b>此静态变量可直接复制到其他组件代码中使用</b></remarks>
        protected static DObject g_emptyValues = null;

        /// <summary>
        /// 属性内置默认值全局总表
        /// </summary>
        /// <remarks><b>此静态变量可直接复制到其他组件代码中使用</b></remarks>
        protected static DObject g_builtinDefaults = null;

        /// <summary>
        /// 默认构造函数
        /// </summary>
        /// <remarks><b>此方法需要复制到其他组件代码中使用</b></remarks>
        public ParamsHandler()
            : base(ParamsHandler.EmptyValues, ParamsHandler.BuiltinDefautls)
        {

        }

        /// <summary>
        /// 初始化组件所有实例公用的属性空值、属性内置默认值
        /// </summary>
        /// <remarks><b>每个组件需要分别实现此方法</b></remarks>
        public static void IntializeEmptyDefaults()
        {
            g_emptyValues = new DObject();
            g_builtinDefaults = new DObject();

            // 图形页
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.PIC_A_TOP_MARGIN, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.PIC_A_BOTTOM_MARGIN, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.PIC_B_TOP_MARGIN, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.PIC_B_BOTTOM_MARGIN, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.PIC_SARKING_MARGIN, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.PIC_SARKING_GAP, double.MaxValue, 0.0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.PIC_STIFF_GAP, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.PIC_A_EAR_MARGIN, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.PIC_A_EAR_MARGIN_SIDE, double.MaxValue, 0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.MAIN_HAUNCH_SHAPE, 0, 2);//主（翼缘）——折角参数
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.MAIN_HAUNCH_INSIDE_CHAMFER_CUTX, double.MaxValue, 0.0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.MAIN_HAUNCH_INSIDE_CHAMFER_CUTY, double.MaxValue, 0.0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.MAIN_HAUNCH_OUTSIDE_CHAMFER_CUTX, double.MaxValue, 0.0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.MAIN_HAUNCH_OUTSIDE_CHAMFER_CUTY, double.MaxValue, 0.0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.MAIN_WEB_HAUNCH_SHAPE, 0, 0);//主（腹板）
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.MAIN_WEB_HAUNCH_OUTSIDE_CHAMFER_CUTX, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.MAIN_WEB_HAUNCH_OUTSIDE_CHAMFER_CUTY, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.MAIN_WEB_HAUNCH_INSIDE_CHAMFER_CUTX, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.MAIN_WEB_HAUNCH_INSIDE_CHAMFER_CUTY, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.SUB_HAUNCH_SHAPE, 0, 0);//次（翼缘）
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.SUB_HAUNCH_INSIDE_CHAMFER_CUTX, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.SUB_HAUNCH_INSIDE_CHAMFER_CUTY, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.SUB_HAUNCH_OUTSIDE_CHAMFER_CUTX, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.SUB_HAUNCH_OUTSIDE_CHAMFER_CUTY, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.SUB_WEB_HAUNCH_SHAPE, 0, 0);//次（腹板）
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.SUB_WEB_HAUNCH_OUTSIDE_CHAMFER_CUTX, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.SUB_WEB_HAUNCH_OUTSIDE_CHAMFER_CUTY, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.SUB_WEB_HAUNCH_INSIDE_CHAMFER_CUTX, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.SUB_WEB_HAUNCH_INSIDE_CHAMFER_CUTY, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.SUB_WEB_STIFF_MARGIN_TOP, double.MaxValue, double.MaxValue);//
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.SUB_WEB_STIFF_COUNT, int.MaxValue, int.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.SUB_WEB_STIFF_STRIDE, new double[] { }, new double[] { double.MaxValue });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.MAIN_WEB_STIFF_MARGIN_TOP, double.MaxValue, double.MaxValue);//
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.MAIN_WEB_STIFF_COUNT, int.MaxValue, 2);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.MAIN_WEB_STIFF_STRIDE, new double[] { }, new double[] { double.MaxValue });

            // 零件页
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.MAIN_PLATE_PROPS, PlatePropertyPanel.EmptyValue, (DObject)new object[] {
                    PlatePropertyPanel.ParamNames.Thickness, 10.0,
                    PlatePropertyPanel.ParamNames.NoPrefix, "",
                    PlatePropertyPanel.ParamNames.NoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.AssNoPrefix, "",
                    PlatePropertyPanel.ParamNames.AssNoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.Material, "Q235B",
                    PlatePropertyPanel.ParamNames.Name, "板",
                    PlatePropertyPanel.ParamNames.Width, double.MaxValue,
                    PlatePropertyPanel.ParamNames.Heigth, double.MaxValue
                });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.SUB_PLATE_PROPS, PlatePropertyPanel.EmptyValue, (DObject)new object[] {
                    PlatePropertyPanel.ParamNames.Thickness, 10.0,
                    PlatePropertyPanel.ParamNames.NoPrefix, "",
                    PlatePropertyPanel.ParamNames.NoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.AssNoPrefix, "",
                    PlatePropertyPanel.ParamNames.AssNoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.Material, "Q235B",
                    PlatePropertyPanel.ParamNames.Name, "板",
                    PlatePropertyPanel.ParamNames.Width, double.MaxValue,
                    PlatePropertyPanel.ParamNames.Heigth, double.MaxValue
                });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.SHIM_SLOT_MODE, 0, 1);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.TOP_HAUNCH_PLATES_PROPS, PlatePropertyPanel.EmptyValue, (DObject)new object[] {
                    PlatePropertyPanel.ParamNames.Thickness, 0.0,
                    PlatePropertyPanel.ParamNames.NoPrefix, "",
                    PlatePropertyPanel.ParamNames.NoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.AssNoPrefix, "",
                    PlatePropertyPanel.ParamNames.AssNoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.Material, "Q235B",
                    PlatePropertyPanel.ParamNames.Name, "上加劲板",
                    PlatePropertyPanel.ParamNames.Width, double.MaxValue,
                    PlatePropertyPanel.ParamNames.Heigth, double.MaxValue
                }); //腋板
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.BOTTOM_HAUNCH_PLATES_PROPS, PlatePropertyPanel.EmptyValue, (DObject)new object[] {
                    PlatePropertyPanel.ParamNames.Thickness, double.MaxValue,
                    PlatePropertyPanel.ParamNames.NoPrefix, "",
                    PlatePropertyPanel.ParamNames.NoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.AssNoPrefix, "",
                    PlatePropertyPanel.ParamNames.AssNoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.Material, "Q235B",
                    PlatePropertyPanel.ParamNames.Name, "下加劲板",
                    PlatePropertyPanel.ParamNames.Width, double.MaxValue,
                    PlatePropertyPanel.ParamNames.Heigth, double.MaxValue
                });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.WEB_STIFF_PROPS, PlatePropertyPanel.EmptyValue, (DObject)new object[] {
                    PlatePropertyPanel.ParamNames.Thickness, 0.0,
                    PlatePropertyPanel.ParamNames.NoPrefix, "",
                    PlatePropertyPanel.ParamNames.NoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.AssNoPrefix, "",
                    PlatePropertyPanel.ParamNames.AssNoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.Material, "Q235B",
                    PlatePropertyPanel.ParamNames.Name, "腹板加劲板",
                    PlatePropertyPanel.ParamNames.Width, double.MaxValue,
                    PlatePropertyPanel.ParamNames.Heigth, double.MaxValue
                }); //腹板加劲板

            // ...其他主板和子板

            string[] padPropNames = new string[]
            {
                    ParamNames.PAD_1_PLATE_PROPS, ParamNames.PAD_2_PLATE_PROPS, ParamNames.PAD_3_PLATE_PROPS
            };
            foreach (var propName in padPropNames)
            {
                AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, propName, PlatePropertyPanel.EmptyValue, (DObject)new object[] {
                    PlatePropertyPanel.ParamNames.Thickness, 0.0,
                    PlatePropertyPanel.ParamNames.NoPrefix, "",
                    PlatePropertyPanel.ParamNames.NoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.AssNoPrefix, "",
                    PlatePropertyPanel.ParamNames.AssNoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.Material, "Q235B",
                    PlatePropertyPanel.ParamNames.Name, "板"
                });
            }
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.PAD_1_PLATE_NUM, int.MaxValue, 1);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.PAD_2_PLATE_NUM, int.MaxValue, 1);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.PAD_3_PLATE_NUM, int.MaxValue, 1);

            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.MAIN_STIFF_PLATE_PROPS, PlatePropertyPanel.EmptyValue, (DObject)new object[] {
                    PlatePropertyPanel.ParamNames.Thickness, 0.0,
                    PlatePropertyPanel.ParamNames.NoPrefix, "",
                    PlatePropertyPanel.ParamNames.NoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.AssNoPrefix, "",
                    PlatePropertyPanel.ParamNames.AssNoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.Material, "Q235B",
                    PlatePropertyPanel.ParamNames.Name, "板",
                    PlatePropertyPanel.ParamNames.Width, 80,
                    PlatePropertyPanel.ParamNames.Heigth, double.MaxValue
                });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.SUB_STIFF_PLATE_PROPS, PlatePropertyPanel.EmptyValue, (DObject)new object[] {
                    PlatePropertyPanel.ParamNames.Thickness, 0.0,
                    PlatePropertyPanel.ParamNames.NoPrefix, "",
                    PlatePropertyPanel.ParamNames.NoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.AssNoPrefix, "",
                    PlatePropertyPanel.ParamNames.AssNoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.Material, "Q235B",
                    PlatePropertyPanel.ParamNames.Name, "板",
                    PlatePropertyPanel.ParamNames.Width, 80,
                    PlatePropertyPanel.ParamNames.Heigth, double.MaxValue
                });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.PAD_BOLT_BOTTOM_MARGIN, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.PAD_BOLT_RIGHT_MARGIN, double.MaxValue, double.MaxValue);
            //AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.PAD_CENTER_GAP, double.MaxValue, 10.0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.PAD_BOLT_SIZE, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.SHIM_WELD_MODE, 0, 0);

            // 耳板配置
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.EAR_PLATE_PROPS, PlatePropertyPanel.EmptyValue, (DObject)new object[] {
                    PlatePropertyPanel.ParamNames.Thickness, 0.0,
                    PlatePropertyPanel.ParamNames.NoPrefix, "",
                    PlatePropertyPanel.ParamNames.NoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.AssNoPrefix, "",
                    PlatePropertyPanel.ParamNames.AssNoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.Material, "Q235B",
                    PlatePropertyPanel.ParamNames.Name, "板",
                    PlatePropertyPanel.ParamNames.Width, 80.0,
                    PlatePropertyPanel.ParamNames.Heigth, 100.0
                });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.EAR_PLATE_BOLT_HORI_COUNT, int.MaxValue, 1);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.EAR_PLATE_BOLT_VERT_COUNT, int.MaxValue, 2);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.EAR_PLATE_BOLT_HORI_STRIDE, new double[] { }, new double[] { 36.0 });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.EAR_PLATE_BOLT_VERT_STRIDE, new double[] { }, new double[] { 36.0 });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.EAR_PLATE_BOLT_H_MARGIN, double.MaxValue, 30);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.EAR_PLATE_BOLT_V_MARGIN, double.MaxValue, 30);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.EAR_PLATE_BOLT_SIZE, double.MaxValue, 12.0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.EAR_PLATE_PLACE, 0, 1);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.MIN_GAP, double.MaxValue, 0);

            // 螺栓
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.BOLT_BASIC_PROPS, BoltBasicPropertyPanel.EmptyValue, (DObject)new object[] {
                    BoltBasicPropertyPanel.ParamNames.BoltStandard, "TS10.9",
                    BoltBasicPropertyPanel.ParamNames.BoltSize, 20,
                    BoltBasicPropertyPanel.ParamNames.ThreadInMtrl, 1, // false
                    BoltBasicPropertyPanel.ParamNames.MadeType0, 0, // Workshop
                });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.BOLT_HOLE_PROPS, BoltHolePanel.EmptyValue, (DObject)new object[] {
                BoltHolePanel.ParamNames.HoleX, 0.0,
                BoltHolePanel.ParamNames.HoleY, 0.0,
                BoltHolePanel.ParamNames.HoleType, 2,
                BoltHolePanel.ParamNames.RotSlot, 3,
                BoltHolePanel.ParamNames.SlotIn, 4
            });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.BOLT_CONTENT_PROPS, null, (DObject)new object[]
            {
                BoltContentPanel.ParamNames.PartWasherUp, false,
                BoltContentPanel.ParamNames.PartWasherDown0, false,
                BoltContentPanel.ParamNames.PartWasherDown1, true,
                BoltContentPanel.ParamNames.PartNut0, true,
                BoltContentPanel.ParamNames.PartNut1, false,
            });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.BOLT_EXTEND_PROPS, BoltExtendPanel.EmptyValue, (DObject)new object[]
            {
                BoltExtendPanel.ParamNames.ExtLength, 0.0,
            });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.BOLT_SHAPE, 0, 1); // Array
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.BOLT_ORIENTATION, 0, 3);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.BOLT_HORI_COUNT, int.MaxValue, 2);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.BOLT_HORI_STRIDE, new double[] { }, new double[] { });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.BOLT_VERT_COUNT, int.MaxValue, 2);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.BOLT_VERT_STRIDE, new double[] { }, new double[] { });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.BOLT_HORI_OFFSET, double.MaxValue, 0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.BOLT_VERT_OFFSET, double.MaxValue, 0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.BOLT_VERT_OFFSET_MODE, 0, 2);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.BOLT_TOP_MARGIN, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.BOLT_BOTTOM_MARGIN, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.BOLT_TOP_MARGIN, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.BOLT_RIGHT_MARGIN, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.BOLT_LEFT_MARGIN, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.BOLT_DELETE_INDICES, new int[] { } , new int[] { }); //要删除的螺栓序号

            // 端口1洞配置 
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.END1_HOLE_TW_MARGIN, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.END1_HOLE_TH_MARGIN, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.END1_HOLE_BW_MARGIN, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.END1_HOLE_BH_MARGIN, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.MAIN_END_PLATE_BOLT_SIZE_TOP, double.MaxValue, 16);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.MAIN_END_PLATE_BOLT_SIZE_BOTTOM, double.MaxValue, 16);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.MAIN_END_PLATE_BOLT_STANDARD, "", "TS10.9");
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.MAIN_END_PLATE_BOLT_TYPE, 0, 1);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.END1_PLATE_HOLE_MODE, 0, 1);


            // 端口2洞配置 
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.END2_HOLE_TW_MARGIN, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.END2_HOLE_TH_MARGIN, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.END2_HOLE_BW_MARGIN, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.END2_HOLE_BH_MARGIN, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.SUB_END_PLATE_BOLT_SIZE_TOP, double.MaxValue, 16);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.SUB_END_PLATE_BOLT_SIZE_BOTTOM, double.MaxValue, 16);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.SUB_END_PLATE_BOLT_STANDARD, "", "TS10.9");
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.SUB_END_PLATE_BOLT_TYPE, 0, 1);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.END2_PLATE_HOLE_MODE, 0, 1);

            // 焊缝
            for (int i = 0; i < ParamNames.WELD_PROPS_LIST.Length; ++i)
            {
                AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.WELD_PROPS_LIST[i], WeldPropertyPanel.EmptyValue, new DObject {
                    { WeldPropertyPanel.ParamNames.SizeUp, 6.0 },
                    { WeldPropertyPanel.ParamNames.WeldTypeUp, 11 }, // Fillet
                    { WeldPropertyPanel.ParamNames.GrooveAngleUp, 0.0 },
                    { WeldPropertyPanel.ParamNames.WeldContourUp,  1}, // None
                    { WeldPropertyPanel.ParamNames.WeldFinishUp, 1 }, // None
                    { WeldPropertyPanel.ParamNames.LengthUp, 0.0 },
                    { WeldPropertyPanel.ParamNames.PitchUp, 0.0 },
                    { WeldPropertyPanel.ParamNames.RootFaceUp, 0.0 },
                    { WeldPropertyPanel.ParamNames.EffectiveThroatUp, 0.0 },
                    { WeldPropertyPanel.ParamNames.RootGapUp, 0.0 },

                    { WeldPropertyPanel.ParamNames.SizeDown, 6.0 },
                    { WeldPropertyPanel.ParamNames.WeldTypeDown, 11 }, // Fillet
                    { WeldPropertyPanel.ParamNames.GrooveAngleDown, 0.0 },
                    { WeldPropertyPanel.ParamNames.WeldContourDown,  1}, // None
                    { WeldPropertyPanel.ParamNames.WeldFinishDown, 1 }, // None
                    { WeldPropertyPanel.ParamNames.LengthDown, 0.0 },
                    { WeldPropertyPanel.ParamNames.PitchDown, 0.0 },
                    { WeldPropertyPanel.ParamNames.RootFaceDown, 0.0 },
                    { WeldPropertyPanel.ParamNames.EffectiveThroatDown, 0.0 },
                    { WeldPropertyPanel.ParamNames.RootGapDown, 0.0 },

                    { WeldPropertyPanel.ParamNames.EdgeAround, 1 }, // Edge
                    { WeldPropertyPanel.ParamNames.MadeType, 2 }, // Workshop
                    { WeldPropertyPanel.ParamNames.StitchWeld, 1 }, // false
                    { WeldPropertyPanel.ParamNames.RefText, "" }
                });
            }

        }



        /// <summary>
        /// 组件公用属性空值表
        /// </summary>
        /// <remarks><b>此方法可直接复制到其他组件代码中使用</b></remarks>
        public static DObject EmptyValues
        {
            get
            {
                if (g_emptyValues == null)
                {
                    IntializeEmptyDefaults();
                }
                return g_emptyValues;
            }
        }

        /// <summary>
        /// 组件公用内置默认值接口
        /// </summary>
        /// <remarks><b>此方法可直接复制到其他组件代码中使用</b></remarks>
        public static DObject BuiltinDefautls
        {
            get
            {
                if (g_builtinDefaults == null)
                {
                    IntializeEmptyDefaults();
                }
                return g_builtinDefaults;
            }
        }

        /// <summary>
        /// 初始化默认值
        /// </summary>
        /// <param name="defaultConfig">从默认值配置加载的默认值</param>
        /// <remarks><b>此方法可直接复制到其他组件代码中使用</b></remarks>
        public override LoongCAD.Util.DObject InitializeDefaultValues(DObject defaultConfig)
        {
            m_defaultValues = new DObject();
            m_defaultValues.CopyFrom(defaultConfig);

            var emptyValues = ParamsHandler.EmptyValues;
            var builtinDefaults = ParamsHandler.BuiltinDefautls;
            if (emptyValues == null || builtinDefaults == null)
            {
                Console.WriteLine("ParamsHandler.InitializeDefaultValues: [Warning] EmptyValue/BuiltinDefaults is null!");
                return m_defaultValues;
            }

            this.TryCompleteDObjectValues(m_defaultValues, builtinDefaults, emptyValues);
            return m_defaultValues;
        }

    }
}
