﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using LoongCAD.Util;
using LoongCAD.STC.Plugins;
using IFWrapper;
using LoongCAD.Localization;

namespace ConnectingPlates14
{
    public partial class Form_PluginMain : LoongCAD.UI.Component.Form_ConnectionComponentProps
    {
        private DObject m_rootUIProps = new DObject();
        private ComponentPlugin m_refPlugin = null;
        private Form_WeldParameter m_weldForm = null;

        public Form_PluginMain(ComponentPlugin refPlugin)
        {
            InitializeComponent();
            m_refPlugin = refPlugin;
            this.OnPostIntialize();
        }

        public override ComponentPlugin ReferencePlugin => m_refPlugin;

        private void OnPostIntialize()
        {
            // 设置窗口标题
            this.Text = "端板拼接（203）";

            foreach (TabPage curPage in this.tab_main.TabPages)
            {
                curPage.AutoScroll = true;
            }

            this.tb_shim_slot_mode.ClearItems();
            this.tb_shim_slot_mode.AddIntegerItems(0, 0, 4);
            this.tb_shim_slot_mode.UpdateItems();

            this.tb_ear_plate_place.ClearItems();
            this.tb_ear_plate_place.AddIntegerItems(0, 0, 4);
            this.tb_ear_plate_place.UpdateItems();

            this.tb_end1_plate_hole_mode.ClearItems();
            this.tb_end1_plate_hole_mode.AddIntegerItems(0, 0, 5);
            this.tb_end1_plate_hole_mode.UpdateItems();

            this.tb_end2_plate_hole_mode.ClearItems();
            this.tb_end2_plate_hole_mode.AddIntegerItems(0, 0, 5);
            this.tb_end2_plate_hole_mode.UpdateItems();

            /*            this.tb_bolt_hori_offset_mode.ClearItems();
                        this.tb_bolt_hori_offset_mode.AddItem(0, "中间");
                        this.tb_bolt_hori_offset_mode.AddItem(1, "左");
                        this.tb_bolt_hori_offset_mode.AddItem(2, "右");
                        this.tb_bolt_hori_offset_mode.UpdateItems();
                        this.tb_bolt_hori_offset_mode.SelectedKey = 0;

                        this.tb_bolt_vert_offset_mode.ClearItems();
                        this.tb_bolt_vert_offset_mode.AddItem(0, "中间");
                        this.tb_bolt_vert_offset_mode.AddItem(1, "左");
                        this.tb_bolt_vert_offset_mode.AddItem(2, "右");
                        this.tb_bolt_vert_offset_mode.UpdateItems();
                        this.tb_bolt_vert_offset_mode.SelectedKey = 0;*/
            this.tb_under_board_weld.ClearItems();
            this.tb_under_board_weld.AddItem(0, "没有");
            this.tb_under_board_weld.AddItem(1, "主零件");
            this.tb_under_board_weld.AddItem(2, "次零件");
            this.tb_under_board_weld.UpdateItems();
            this.tb_under_board_weld.SelectedKey = 0;
            SetMainBoltHoleBasic();
            SetSubBoltHoleBasic();

            //翼缘加劲板折角参数
            this.tb_sub_haunch_shape.ClearItems();
            this.tb_sub_haunch_shape.AddIntegerItems(0, 0, 3);
            this.tb_sub_haunch_shape.UpdateItems();
            this.tb_sub_haunch_shape.SelectedKey = 0;

            this.tb_main_haunch_shape.ClearItems();
            this.tb_main_haunch_shape.AddIntegerItems(0, 0, 3);
            this.tb_main_haunch_shape.UpdateItems();
            this.tb_main_haunch_shape.SelectedKey = 0;

            //腹板加劲板折角参数
            this.tb_sub_web_haunch_shape.ClearItems();
            this.tb_sub_web_haunch_shape.AddIntegerItems(0, 0, 3);
            this.tb_sub_web_haunch_shape.UpdateItems();
            this.tb_sub_web_haunch_shape.SelectedKey = 0;

            this.tb_main_web_haunch_shape.ClearItems();
            this.tb_main_web_haunch_shape.AddIntegerItems(0, 0, 3);
            this.tb_main_web_haunch_shape.UpdateItems();
            this.tb_main_web_haunch_shape.SelectedKey = 0;

            //
            this.bolt_basic_standard_props.BoltStandardChanged += this.bolt_content_props.AdaptBoltContents;
        }

        private void SetMainBoltHoleBasic()
        {
            // 初始化螺栓标准
            do
            {
                this.tb_main_end_plate_bolt_standard.RefreshBoltStandards();
                object objStandard = Native.options("bolt_def_standard");
                if (objStandard != null)
                {
                    this.tb_main_end_plate_bolt_standard.DefaultBoltStandard = objStandard.ToString();
                }
            } while (false);

            // 初始化螺栓尺寸
            do
            {
                this.tb_main_end_plate_bolt_size_top.BoltStandard = this.tb_main_end_plate_bolt_standard.SelectedBoltStandard;
                object objSize = Native.options("bolt_def_size");
                if (objSize != null)
                {
                    double defBoltSize = double.Parse(objSize.ToString());
                    this.tb_main_end_plate_bolt_size_top.DefaultBoltSize = defBoltSize;
                }
                this.tb_main_end_plate_bolt_size_top.RefreshBoltSizes();
            } while (false);
            do
            {
                this.tb_main_end_plate_bolt_size_bottom.BoltStandard = this.tb_main_end_plate_bolt_standard.SelectedBoltStandard;
                object objSize = Native.options("bolt_def_size");
                if (objSize != null)
                {
                    double defBoltSize = double.Parse(objSize.ToString());
                    this.tb_main_end_plate_bolt_size_bottom.DefaultBoltSize = defBoltSize;
                }
                this.tb_main_end_plate_bolt_size_bottom.RefreshBoltSizes();
            } while (false);

            //工厂、工地
            this.tb_main_end_plate_bolt_type.ClearItems();
            this.tb_main_end_plate_bolt_type.AddItem(0, Lang.Local("default"));
            this.tb_main_end_plate_bolt_type.AddItem(1, Lang.Local("PART_MADE_SITE", "enum"));
            this.tb_main_end_plate_bolt_type.AddItem(2, Lang.Local("PART_MADE_WORKSHOP", "enum"));
            this.tb_main_end_plate_bolt_type.UpdateItems();
            this.tb_main_end_plate_bolt_type.SelectedKey = 0;
        }

        private void SetSubBoltHoleBasic()
        {
            // 初始化螺栓标准
            do
            {
                this.tb_sub_end_plate_bolt_standard.RefreshBoltStandards();
                object objStandard = Native.options("bolt_def_standard");
                if (objStandard != null)
                {
                    this.tb_sub_end_plate_bolt_standard.DefaultBoltStandard = objStandard.ToString();
                }
            } while (false);

            // 初始化螺栓尺寸
            do
            {
                this.tb_sub_end_plate_bolt_size_top.BoltStandard = this.tb_sub_end_plate_bolt_standard.SelectedBoltStandard;
                object objSize = Native.options("bolt_def_size");
                if (objSize != null)
                {
                    double defBoltSize = double.Parse(objSize.ToString());
                    this.tb_sub_end_plate_bolt_size_top.DefaultBoltSize = defBoltSize;
                }
                this.tb_sub_end_plate_bolt_size_top.RefreshBoltSizes();
            } while (false);
            do
            {
                this.tb_sub_end_plate_bolt_size_bottom.BoltStandard = this.tb_sub_end_plate_bolt_standard.SelectedBoltStandard;
                object objSize = Native.options("bolt_def_size");
                if (objSize != null)
                {
                    double defBoltSize = double.Parse(objSize.ToString());
                    this.tb_sub_end_plate_bolt_size_bottom.DefaultBoltSize = defBoltSize;
                }
                this.tb_sub_end_plate_bolt_size_bottom.RefreshBoltSizes();
            } while (false);

            //工厂、工地
            this.tb_sub_end_plate_bolt_type.ClearItems();
            this.tb_sub_end_plate_bolt_type.AddItem(0, Lang.Local("default"));
            this.tb_sub_end_plate_bolt_type.AddItem(1, Lang.Local("PART_MADE_SITE", "enum"));
            this.tb_sub_end_plate_bolt_type.AddItem(2, Lang.Local("PART_MADE_WORKSHOP", "enum"));
            this.tb_sub_end_plate_bolt_type.UpdateItems();
            this.tb_sub_end_plate_bolt_type.SelectedKey = 0;
        }

        public override void ClearUI(Control root = null)
        {
            // 刷新螺栓基础面板
            this.bolt_basic_standard_props.RefreshControls();
            base.ClearUI(root);
        }

        protected override void UpdatePlaceholders(DObject compProps, DObject defaultValues)
        {
            this.ClearPlaceholders();
            defaultValues = ParamsHandlerBase.SelectDefaultsByEmpty(compProps, defaultValues, ParamsHandler.EmptyValues);
            this.SetPlaceholders(defaultValues);
        }
        private void btn_weld_props_Click(object sender, EventArgs e)
        {
            if (m_weldForm == null)
            {
                m_weldForm = new Form_WeldParameter();
                m_weldForm.Owner = this.Owner;
                m_weldForm.ApplyHandler += this.ApplyWeldProps;
                m_weldForm.ModifyHandler += this.ModifyWeldProps;
                m_weldForm.GetHandler += this.GetWeldProps;
            }

            m_weldForm.Show(m_rootUIProps, null);
        }

        /// <summary>
        /// 应用焊缝属性的回调函数
        /// </summary>
        /// <returns></returns>
        /// <remarks><b>包含焊缝子窗口的组件需要复制此方法</b></remarks>
        protected void ApplyWeldProps(DObject srcProps)
        {
            m_rootUIProps.CopyFrom(srcProps);
        }

        /// <summary>
        /// 修改焊缝属性的回调函数
        /// </summary>
        /// <returns></returns>
        /// <remarks><b>包含焊缝子窗口的组件需要复制此方法</b></remarks>
        protected void ModifyWeldProps(DObject srcProps)
        {
            this.ModifyFocusedProps(srcProps);
        }

        /// <summary>
        /// 获取焊缝属性的回调函数
        /// </summary>
        /// <returns></returns>
        /// <remarks><b>包含焊缝子窗口的组件需要复制此方法</b></remarks>
        protected DObject GetWeldProps()
        {
            var refPlugin = this.ReferencePlugin;
            if (refPlugin == null)
                return m_rootUIProps;
            var curScene = LoongCAD.STC.STC.Document.FocusedScene;
            if (curScene == null)
                return m_rootUIProps;
            System.Guid pluginGuid = refPlugin.Guid;
            LoongCAD.STC.Object3D.ObjectBase[] curObjs = curScene.GetSelectedObjects(
                obj => obj is LoongCAD.STC.Object3D.ComponentBase &&
                ((LoongCAD.STC.Object3D.ComponentBase)obj).CompGuid == pluginGuid);
            if (curObjs == null || curObjs.Length == 0)
                return m_rootUIProps;
            LoongCAD.STC.Object3D.ComponentBase comp = curObjs[0] as LoongCAD.STC.Object3D.ComponentBase;
            if (comp == null)
                return m_rootUIProps;

            return comp.UIProps;
        }
        /// <summary>
        /// 设置当前窗口的属性值
        /// </summary>
        /// <param name="paras"></param>
        /// <param name="root"></param>
        /// <remarks>其他组件若同样包含类似焊缝属性窗的子窗口，则需要复制此方法</remarks>
        public override void SetParameters(DObject paras, Control root = null)
        {
            base.SetParameters(paras, root);
            if (root == null)
            {
                m_rootUIProps.Clear();
                m_rootUIProps.CopyFrom(paras);
            }
        }

        /// <summary>
        /// 获取当前窗口的属性值
        /// </summary>
        /// <param name="root"></param>
        /// <param name="exclude"></param>
        /// <param name="bConsiderCheck"></param>
        /// <remarks>其他组件若同样包含类似焊缝属性窗的子窗口，则需要复制此方法</remarks>
        /// <returns></returns>
        public override DObject GetParameters(Control root = null, List<Control> exclude = null, bool bConsiderCheck = true)
        {
            DObject retProps = new DObject();
            if (!bConsiderCheck || this.act_weld_props.Checked)
            {
                retProps.CopyFrom(m_rootUIProps);
            }
            DObject baseProps = base.GetParameters(root, exclude, true);
            retProps.CopyFrom(baseProps);
            return retProps;
        }

        private void tb_main_haunch_shape_SelectedIndexChanged(object sender, EventArgs e)
        {
            int select = tb_main_haunch_shape.SelectedIntKey;
            if (select == 1 || select == 0)
            {
                this.tb_main_haunch_outside_chamfer_cutx.Enabled = true;
                this.act_main_haunch_outside_chamfer_cutx.Enabled = true;
                this.act_main_haunch_outside_chamfer_cuty.Enabled = true;
                this.tb_main_haunch_outside_chamfer_cuty.Enabled = true;
            }
            else
            {
                this.tb_main_haunch_outside_chamfer_cutx.Enabled = false;
                this.act_main_haunch_outside_chamfer_cutx.Enabled = false;
                this.act_main_haunch_outside_chamfer_cuty.Enabled = false;
                this.tb_main_haunch_outside_chamfer_cuty.Enabled = false;
            }
        }

        private void tb_sub_haunch_shape_SelectedIndexChanged(object sender, EventArgs e)
        {
            int select = tb_sub_haunch_shape.SelectedIntKey;
            if (select == 1 || select == 0)
            {
                this.tb_sub_haunch_outside_chamfer_cutx.Enabled = true;
                this.act_sub_haunch_outside_chamfer_cutx.Enabled = true;
                this.act_sub_haunch_outside_chamfer_cuty.Enabled = true;
                this.tb_sub_haunch_outside_chamfer_cuty.Enabled = true;
            }
            else
            {
                this.tb_sub_haunch_outside_chamfer_cutx.Enabled = false;
                this.act_sub_haunch_outside_chamfer_cutx.Enabled = false;
                this.act_sub_haunch_outside_chamfer_cuty.Enabled = false;
                this.tb_sub_haunch_outside_chamfer_cuty.Enabled = false;
            }
        }

        private void tb_sub_web_haunch_shape_SelectedIndexChanged(object sender, EventArgs e)
        {
            int select = tb_sub_web_haunch_shape.SelectedIntKey;
            if (select == 1 || select == 0)
            {
                this.tb_sub_web_haunch_outside_chamfer_cutx.Enabled = true;
                this.act_sub_web_haunch_outside_chamfer_cutx.Enabled = true;
                this.act_sub_web_haunch_outside_chamfer_cuty.Enabled = true;
                this.tb_sub_web_haunch_outside_chamfer_cuty.Enabled = true;
            }
            else
            {
                this.tb_sub_web_haunch_outside_chamfer_cutx.Enabled = false;
                this.act_sub_web_haunch_outside_chamfer_cutx.Enabled = false;
                this.act_sub_web_haunch_outside_chamfer_cuty.Enabled = false;
                this.tb_sub_web_haunch_outside_chamfer_cuty.Enabled = false;
            }
        }

        private void tb_main_web_haunch_shape_SelectedIndexChanged(object sender, EventArgs e)
        {
            int select = tb_main_web_haunch_shape.SelectedIntKey;
            if (select == 1 || select == 0)
            {
                this.tb_main_web_haunch_outside_chamfer_cutx.Enabled = true;
                this.act_main_web_haunch_outside_chamfer_cutx.Enabled = true;
                this.act_main_web_haunch_outside_chamfer_cuty.Enabled = true;
                this.tb_main_web_haunch_outside_chamfer_cuty.Enabled = true;
            }
            else
            {
                this.tb_main_web_haunch_outside_chamfer_cutx.Enabled = false;
                this.act_main_web_haunch_outside_chamfer_cutx.Enabled = false;
                this.act_main_web_haunch_outside_chamfer_cuty.Enabled = false;
                this.tb_main_web_haunch_outside_chamfer_cuty.Enabled = false;
            }
        }

        private void pictureBox11_Click(object sender, EventArgs e)
        {

        }
    }
}
