﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using LoongCAD.STC;
using LoongCAD.Geometry;

namespace CornerBoltedGusset57.Common
{
    public class BoltParameter
    {
        public enum SoltInMode
        {
            NONE = 0,
            BEAM = 1,
            PLATE = 2,
            BOTH = 3,
        }

        public enum VertOffsetMode
        {
            AUTO = 0,
            TOP = 1,
            MIDDLE = 2,
            BOTTOM = 3
        }

        //螺栓基本属性
        public double BoltSize = 0.0;
        public string BoltStandard;
        public double HoleTol = 0.0;
        public bool ThreadInMaterial = false;
        public Define.PartMadeType MadeType = Define.PartMadeType.PART_MADE_SITE;

        //槽孔属性
        public double HoleX = 0.0;
        public double HoleY = 0.0;
        //孔类型
        public Define.BoltHoleType HoleType = Define.BoltHoleType.BOLT_HOLE_OVERSIZED;
        //槽
        public Define.BoltRotateSlot RotSlot = 0;
        //长洞
        public SoltInMode SlotIn = SoltInMode.NONE;

        //垫圈
        public bool PartWasherUp = false;
        public bool PartWasherDown0 = false;
        public bool PartWasherDown1 = false;
        //螺母
        public bool PartNut0 = false;
        public bool PartNut1 = false;

        //螺栓长度延申
        public double ExtLength = 0.0;

        public double BoltSizeX = 0.0;
        public double BoltSizeY = 0.0;
        public double BoltLeftMargin = 0.0;
        public double BoltRightMargin = 0.0;

        public int HoriCount = 0;
        public int VertCount = 0;
        public List<double> StrideX = new List<double>();
        public List<double> StrideY = new List<double>();
        //螺栓组形状
        public Define.BoltGroupShape BoltShape = Define.BoltGroupShape.BOLT_GROUPSHAPE_NONE;
        public double BoltHoriBraceMargin = 0.0;
        public double BoltHoriGussetMargin = 0.0;
        public VertOffsetMode bolt_vert_offset_mode = VertOffsetMode.BOTTOM;
        public double BoltVertOffset = 0.0;

        public BoltParameter()
        {

        }
    }
}
