﻿namespace CornerBoltedGusset57.Common
{
    public class ParamNames
    {
        /**
         * 图形参数页名称 
         */

        ///<summary>
        ///节点板边缘和主零件（构成角部的第一个零件）之间的间隙距离
        ///</summary>
        public static readonly string PIC_GUSSET_PLATE_EDGE_GAP_MAIN_PART = "pic_gusset_plate_edge_gap_main_part";
        /// <summary>
        /// 次零件与最后一个支撑之间的边距
        /// </summary>
        public static readonly string PIC_SECONDARY_PART_DISTANCE_LAST_BRACE = "pic_secondary_part_distance_last_brace";
        /// <summary>
        /// 支撑之间的距离
        /// </summary>
        public static readonly string PIC_BRACE_DISTANCE = "pic_brace_distance";
        /// <summary>
        /// 第一个支撑与主零件之间的边距
        /// </summary>
        public static readonly string PIC_MAIN_PART_DISTANCE_FIRST_BRACE = "pic_main_part_distance_first_brace";
        /// <summary>
        /// 节点板边缘和次零件（构成角部的第二个零件）之间的间隙距离
        /// </summary>
        public static readonly string PIC_GUSSET_PLATE_EDGE_GAP_SECONDARY_PART = "pic_gusset_plate_edge_gap_secondary_part";
        /// <summary>
        /// 第一个支撑附件节点板拐角角度(以度为单位) 自适应
        /// </summary>
        public static readonly string PIC_GUSSET_PLATE_CORNER_ANGLE_FIRST_BRACE = "pic_gusset_plate_corner_angle_first_brace";
        /// <summary>
        /// 最后一个支撑附件节点板拐角角度(以度为单位)
        /// </summary>
        public static readonly string PIC_GUSSET_PLATE_CORNER_ANGLE_LAST_BRACE = "pic_gusset_plate_corner_angle_last_brace";
        /// <summary>
        /// 第一个支撑附近节点板边缘长度
        /// </summary>
        public static readonly string PIC_GUSSET_PLATE_EDGE_LENGTH_FIRST_BRACE = "pic_gusset_plate_edge_length_first_brace";
        /// <summary>
        /// 两个支撑之间节点板边缘长度
        /// </summary>
        public static readonly string PIC_GUSSET_PLATE_EDGE_LENGTH_BETWEEN_BRACE = "pic_gusset_plate_edge_length_between_brace";
        /// <summary>
        /// 最后一个支撑附近节点板边缘长度
        /// </summary>
        public static readonly string PIC_GUSSET_PLATE_EDGE_LENGTH_LAST_BRACE = "pic_gusset_plate_edge_length_last_brace";

        /**
         * 节点板参数页名称
         */

        ///<summary>
        ///节点板属性
        ///</summary>
        public static readonly string GUSSET_PLATE_PROPS = "gusset_plate_props";
        /// <summary>
        /// 节点板在支撑上的位置类型
        /// </summary>
        public static readonly string GUSSET_PLATE_POSITION_BRACE = "gusset_plate_position_brace";
        /// <summary>
        /// 节点板在 z 方向上移动的距离
        /// </summary>
        public static readonly string GUSSET_PLATE_MOVE_DISTANCE_Z = "gusset_plate_move_distance_z";
        /// <summary>
        /// 节点板形状类型
        /// </summary>
        public static readonly string GUSSET_PLATE_SHAPE = "gusset_plate_shape";
        /// <summary>
        /// 支撑槽口类型
        /// </summary>
        public static readonly string GUSSET_BRACE_NOTCH = "gusset_brace_notch";
        /// <summary>
        /// 半开槽垂直槽口尺寸
        /// </summary>
        public static readonly string GUSSET_VERTICAL_NOTCH_DIMENSION_HALF_NOTCH = "gusset_vertical_notch_dimension_half_notch";
        /// <summary>
        /// 全开槽垂直槽口尺寸
        /// </summary>
        public static readonly string GUSSET_VERTICAL_NOTCH_DIMENSION_FULL_NOTCH = "gusset_vertical_notch_dimension_full_notch";
        /// <summary>
        /// 水平槽口尺寸
        /// </summary>
        public static readonly string GUSSET_HORIZONTAL_NOTCH_DIMENSION = "gusset_horizontal_notch_dimension";
        /// <summary>
        /// 槽口角度
        /// </summary>
        public static readonly string GUSSET_NOTCH_ANGLE = "gusset_notch_angle";
        /// <summary>
        /// 次零件与最后一个支撑之间的节点板边缘形状类型
        /// </summary>
        public static readonly string GUSSET_PLATE_EDGE_SHAPE_SECONDARY_PART_LAST_BRACE = "gusset_plate_edge_shape_secondary_part_last_brace";
        /// <summary>
        /// 主零件与第一个支撑之间的节点板边缘形状类型
        /// </summary>
        public static readonly string GUSSET_PLATE_EDGE_SHAPE_MAIN_PART_FIRST_BRACE = "gusset_plate_edge_shape_main_part_first_brace";
        /// <summary>
        /// 节点板接合类型 
        /// </summary>
        public static readonly string GUSSET_PLATE_FITTING = "gusset_plate_fitting";
        /// <summary>
        /// 节点板焊接类型
        /// </summary>
        public static readonly string GUSSET_WELDING = "gusset_welding";

        public static readonly string GUSSET_PLATE_MAIN_CHAMFER_TYPE = "gusset_plate_main_chamfer_type";
        public static readonly string GUSSET_PLATE_MAIN_CHAMFERX = "gusset_plate_main_chamferX";
        public static readonly string GUSSET_PLATE_MAIN_CHAMFERY = "gusset_plate_main_chamferY";
        public static readonly string GUSSET_PLATE_SUB_CHAMFER_TYPE = "gusset_plate_sub_chamfer_type";
        public static readonly string GUSSET_PLATE_SUB_CHAMFERX = "gusset_plate_sub_chamferX";
        public static readonly string GUSSET_PLATE_SUB_CHAMFERY = "gusset_plate_sub_chamferY";

        /**
         * 加劲肋参数页
         */

        //加劲肋1
        public static readonly string STIFFENER_PROPS1 = "stiffener_props1";
        /// <summary>
        /// 加劲肋的长度
        /// </summary>
        public static readonly string STIFFENER_LENGTH1 = "stiffener_length1";
        /// <summary>
        /// 加劲肋边缘和节点板边缘之间的距离
        /// </summary>
        public static readonly string STIFFENER_EDGE_GUSSET_PLATE_EDGE_DISTANCE1 = "stiffener_edge_gusset_plate_edge_distance1";
        /// <summary>
        /// 加劲肋的宽度
        /// </summary>
        public static readonly string STIFFENER_WIDTH1 = "stiffener_width1";
        /// <summary>
        /// 加劲肋底板的长度
        /// </summary>
        public static readonly string STIFFENER_BASE_LENGTH1 = "stiffener_base_length1";
        /// <summary>
        /// 加劲肋倾斜部分的长度
        /// </summary>
        public static readonly string STIFFENER_SKEW_PART_LENGTH1 = "stiffener_skew_part_length1";
        /// <summary>
        /// 距加劲肋中心线的距离
        /// </summary>
        public static readonly string STIFFENER_CENTER_LINE_DISTANCE1 = "stiffener_center_line_distance1";
        /// <summary>
        /// 加劲肋底板和倾斜部分之间的垂直距离
        /// </summary>
        public static readonly string STIFFENER_BASE_DISTANCE_SKEW_PART1 = "stiffener_base_distance_skew_part1";

        //加劲肋2
        public static readonly string STIFFENER_PROPS2 = "stiffener_props2";
        /// <summary>
        /// 加劲肋的长度
        /// </summary>
        public static readonly string STIFFENER_LENGTH2 = "stiffener_length2";
        /// <summary>
        /// 加劲肋边缘和节点板边缘之间的距离
        /// </summary>
        public static readonly string STIFFENER_EDGE_GUSSET_PLATE_EDGE_DISTANCE2 = "stiffener_edge_gusset_plate_edge_distance2";
        /// <summary>
        /// 加劲肋的宽度
        /// </summary>
        public static readonly string STIFFENER_WIDTH2 = "stiffener_width2";
        /// <summary>
        /// 加劲肋底板的长度
        /// </summary>
        public static readonly string STIFFENER_BASE_LENGTH2 = "stiffener_base_length2";
        /// <summary>
        /// 加劲肋倾斜部分的长度
        /// </summary>
        public static readonly string STIFFENER_SKEW_PART_LENGTH2 = "stiffener_skew_part_length2";
        /// <summary>
        /// 距加劲肋中心线的距离
        /// </summary>
        public static readonly string STIFFENER_CENTER_LINE_DISTANCE2 = "stiffener_center_line_distance2";
        /// <summary>
        /// 加劲肋底板和倾斜部分之间的垂直距离
        /// </summary>
        public static readonly string STIFFENER_BASE_DISTANCE_SKEW_PART2 = "stiffener_base_distance_skew_part2";

        /**
         * 螺栓参数页
         *  螺栓组基本属性
         *  槽孔属性
         *  构件属性
         *  螺栓延申长度属性
         *  螺栓组排列形状
         *  螺栓距离
         *  螺栓组在水平方向到支撑对齐面的边距
         *  螺栓组水平方向到节点板的边距
         *  垂直螺栓组位置尺寸的测量方式
         *  垂直螺栓组位置的尺寸
         *  水平方向螺栓数量
         *  垂直方向螺栓数量
         *  水平方向螺栓间距
         *  垂直方向螺栓间距
         */

        //支柱螺栓1
        public static readonly string BOLT1_BASIC_PROPS = "bolt1_basic_props";
        public static readonly string BOLT1_HOLE_PROPS = "bolt1_hole_props";
        public static readonly string BOLT1_CONTENT_PROPS = "bolt1_content_props";
        public static readonly string BOLT1_EXTEND_PROPS = "bolt1_extend_props";
        public static readonly string BOLT1_SHAPE = "bolt1_shape";
        /// <summary>
        /// 螺栓组在水平方向到支撑对齐面的边距
        /// </summary>
        public static readonly string BOLT1_HORI_BRACE_MARGIN = "bolt1_hori_brace_margin";
        /// <summary>
        /// 螺栓组水平方向到节点板的边距
        /// </summary>
        public static readonly string BOLT1_HORI_GUSSET_MARGIN = "bolt1_hori_gusset_margin";
        public static readonly string BOLT1_VERT_OFFSET_MODE = "bolt1_vert_offset_mode";
        public static readonly string BOLT1_VERT_OFFSET = "bolt1_vert_offset";
        public static readonly string BOLT1_HORI_COUNT = "bolt1_hori_count";
        public static readonly string BOLT1_VERT_COUNT = "bolt1_vert_count";
        public static readonly string BOLT1_HORI_STRIDE = "bolt1_hori_stride";
        public static readonly string BOLT1_VERT_STRIDE = "bolt1_vert_stride";

        //支柱螺栓2
        public static readonly string BOLT2_BASIC_PROPS = "bolt2_basic_props";
        public static readonly string BOLT2_HOLE_PROPS = "bolt2_hole_props";
        public static readonly string BOLT2_CONTENT_PROPS = "bolt2_content_props";
        public static readonly string BOLT2_EXTEND_PROPS = "bolt2_extend_props";
        public static readonly string BOLT2_SHAPE = "bolt2_shape";
        /// <summary>
        /// 螺栓组在水平方向到支撑对齐面的边距
        /// </summary>
        public static readonly string BOLT2_HORI_BRACE_MARGIN = "bolt2_hori_brace_margin";
        /// <summary>
        /// 螺栓组水平方向到节点板的边距
        /// </summary>
        public static readonly string BOLT2_HORI_GUSSET_MARGIN = "bolt2_hori_gusset_margin";
        public static readonly string BOLT2_VERT_OFFSET_MODE = "bolt2_vert_offset_mode";
        public static readonly string BOLT2_VERT_OFFSET = "bolt2_vert_offset";
        public static readonly string BOLT2_HORI_COUNT = "bolt2_hori_count";
        public static readonly string BOLT2_VERT_COUNT = "bolt2_vert_count";
        public static readonly string BOLT2_HORI_STRIDE = "bolt2_hori_stride";
        public static readonly string BOLT2_VERT_STRIDE = "bolt2_vert_stride";

        //支柱螺栓3
        public static readonly string BOLT3_BASIC_PROPS = "bolt3_basic_props";
        public static readonly string BOLT3_HOLE_PROPS = "bolt3_hole_props";
        public static readonly string BOLT3_CONTENT_PROPS = "bolt3_content_props";
        public static readonly string BOLT3_EXTEND_PROPS = "bolt3_extend_props";
        public static readonly string BOLT3_SHAPE = "bolt3_shape";
        /// <summary>
        /// 螺栓组在水平方向到支撑对齐面的边距
        /// </summary>
        public static readonly string BOLT3_HORI_BRACE_MARGIN = "bolt3_hori_brace_margin";
        /// <summary>
        /// 螺栓组水平方向到节点板的边距
        /// </summary>
        public static readonly string BOLT3_HORI_GUSSET_MARGIN = "bolt3_hori_gusset_margin";
        public static readonly string BOLT3_VERT_OFFSET_MODE = "bolt3_vert_offset_mode";
        public static readonly string BOLT3_VERT_OFFSET = "bolt3_vert_offset";
        public static readonly string BOLT3_HORI_COUNT = "bolt3_hori_count";
        public static readonly string BOLT3_VERT_COUNT = "bolt3_vert_count";
        public static readonly string BOLT3_HORI_STRIDE = "bolt3_hori_stride";
        public static readonly string BOLT3_VERT_STRIDE = "bolt3_vert_stride";

        /**
         * 焊缝属性名称
         */
        public static readonly string[] WELD_PROPS_LIST = new string[]
        {
            "weld_props0",
            "weld_props1",
            "weld_props2",
            "weld_props3"
        };
    }
}
