﻿using LoongCAD.Geometry;
using LoongCAD.STC.Object3D;
using LoongCAD.STC.Plugins;

namespace DiagonalJoint53
{
    public class SubData
    {
        public Beam Beam;
        public BeamPlanes BeamPlanes;
        /// <summary>
        /// 调整后支撑的构建方向
        /// </summary>
        public Vec3 BraceLine;
        /// <summary>
        /// 支撑离主零件较远的控制点
        /// </summary>
        public Vec3 FarPoint;
        /// <summary>
        /// 支撑从主零件构建方向出发，较近的面
        /// </summary>
        public Plane TopPlane;
        /// <summary>
        /// 支撑从主零件构建方向出发，较远的面
        /// </summary>
        public Plane BottomPlane;
        /// <summary>
        /// 沿着Z轴正方向的面
        /// </summary>
        public Plane FrontPlane;
        /// <summary>
        /// 沿着Z轴负方向的面
        /// </summary>
        public Plane BackPlane;
        /// <summary>
        /// 对齐面
        /// </summary>
        public Plane AlignPlane;
        /// <summary>
        /// 连接板边界面
        /// </summary>
        public Plane BorderPlane;
    }
}
