﻿using System;
using LoongCAD.STC.Object3D;
using LoongCAD.STC;

namespace ExtendedTrapezoidalPlate103
{
    public class PlateTools
    {
        /// <summary>
        /// 设置板折角
        /// </summary>
        public static void SetChamfer(ChamferCtrlPoint point, int type, double lenX, double lenY, PartBase retPlate)
        {
            if (retPlate == null)
                return;
            Define.CornerCutType chamferType;
            switch (type)
            {
                case 1:
                    chamferType = Define.CornerCutType.CORNER_CUT_NONE;
                    break;
                case 3:
                    chamferType = Define.CornerCutType.CORNER_CUT_ROUND;
                    break;
                case 4:
                    chamferType = Define.CornerCutType.CORNER_CUT_INV_ROUND;
                    break;
                case 0:
                default:
                    chamferType = Define.CornerCutType.CORNER_CUT_LINE;
                    break;
            }
            if (point != null)
            {
                point.CutX = lenX;
                point.CutY = lenY;
                point.CutType = chamferType;
                point.Flush();
                retPlate.Flush();
            }
        }
        /// <summary>
        /// 计算给定数组的元素绝对值之和
        /// </summary>
        public static double SumArray(double[] arr)
        {
            if (arr == null || arr.Length == 0)
                return 0.0;
            double sum = 0.0;
            foreach (var item in arr)
                sum += Math.Abs(item);
            return sum;
        }
    }
}
