﻿using LoongCAD.STC.Plugins;
using LoongCAD.Util;
using LoongCAD.UI.Component;
using LoongCAD.STC.Object3D;
using LoongCAD.Geometry;

namespace InnerDiaphragm1059
{
    public class WeldHandler
    {
        private ComponentInstanceContext m_context;
        private ParamsHandler m_paramsHandler = null;
        private WeldProperties m_weldProps = new WeldProperties();
        public WeldHandler(ComponentInstanceContext context, ParamsHandler paramsHandler)
        {
            m_context = context;
            m_paramsHandler = paramsHandler;
        }
        public void Execute()
        {
            if (!this.ParseProps())
                return;

            if (m_weldProps.TypeUp == LoongCAD.STC.Define.WeldType.WELD_TYPE_NONE)
                return;
            var retPlate = m_context.RetPlate;
            var weldPoints = m_context.WeldPoints;
            if (retPlate == null || weldPoints == null)
                return;
            for (int i = 0; i < weldPoints.Length; i++)
            {
                Weld curWeld = m_context.TargetComp.CreatePolyWeld(m_context.MainPart, retPlate,
                    new Vec3[] { weldPoints[i] }, true);
                m_weldProps.ApplyToWeld(curWeld);
            }
        }
        private bool ParseProps()
        {
            DObject weldProps = m_paramsHandler.GetDObjectValue(ParamNames.WELD_PROPS_LIST[0]);
            weldProps = WeldPropertyPanel.ParseNativeProps(weldProps);
            m_weldProps.SetProps(weldProps);
            return true;
        }
    }
}
