﻿using LoongCAD.UI.Component;
using LoongCAD.Util;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ShortColumn133
{
    public class ParamsHandler : LoongCAD.STC.Plugins.ParamsHandlerBase
    {

        /// <summary>
        /// 属性空值全局总表
        /// </summary>
        /// <remarks><b>此静态变量可直接复制到其他组件代码中使用</b></remarks>
        protected static DObject g_emptyValues = null;

        /// <summary>
        /// 属性内置默认值全局总表
        /// </summary>
        /// <remarks><b>此静态变量可直接复制到其他组件代码中使用</b></remarks>
        protected static DObject g_builtinDefaults = null;

        /// <summary>
        /// 默认构造函数
        /// </summary>
        /// <remarks><b>此方法需要复制到其他组件代码中使用</b></remarks>
        public ParamsHandler()
            : base(ParamsHandler.EmptyValues, ParamsHandler.BuiltinDefautls)
        {

        }

        /// <summary>
        /// 初始化组件所有实例公用的属性空值、属性内置默认值
        /// </summary>
        /// <remarks><b>每个组件需要分别实现此方法</b></remarks>
        public static void IntializeEmptyDefaults()
        {
            g_emptyValues = new DObject();
            g_builtinDefaults = new DObject();

            //图形页
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.COLUMN_BEAM_DISTANCE, double.MaxValue, 500d);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.FLANGE_PLATE_MARGIN_TOP, double.MaxValue, 0d);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.FLANGE_PLATE_MARGIN_OUTSIDE, double.MaxValue, 0d);

            //零件页
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.TOP_FLANGE_PLATE_PROPS, PlatePropertyPanel.EmptyValue, (DObject)new object[] {
                    PlatePropertyPanel.ParamNames.Thickness, 8.0,
                    PlatePropertyPanel.ParamNames.NoPrefix, "",
                    PlatePropertyPanel.ParamNames.NoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.AssNoPrefix, "",
                    PlatePropertyPanel.ParamNames.AssNoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.Material, "Q235B",
                    PlatePropertyPanel.ParamNames.Name, "上翼板"
                });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.BOTTOM_FLANGE_PLATE_PROPS, PlatePropertyPanel.EmptyValue, (DObject)new object[] {
                    PlatePropertyPanel.ParamNames.Thickness, 8.0,
                    PlatePropertyPanel.ParamNames.NoPrefix, "",
                    PlatePropertyPanel.ParamNames.NoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.AssNoPrefix, "",
                    PlatePropertyPanel.ParamNames.AssNoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.Material, "Q235B",
                    PlatePropertyPanel.ParamNames.Name, "下翼板"
                });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.WEB_PLATE_PROPS, PlatePropertyPanel.EmptyValue, (DObject)new object[] {
                    PlatePropertyPanel.ParamNames.Thickness, 8.0,
                    PlatePropertyPanel.ParamNames.NoPrefix, "",
                    PlatePropertyPanel.ParamNames.NoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.AssNoPrefix, "",
                    PlatePropertyPanel.ParamNames.AssNoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.Material, "Q235B",
                    PlatePropertyPanel.ParamNames.Name, "腹板"
                });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.WEB_CONN_PLATE_PROPS, PlatePropertyPanel.EmptyValue, (DObject)new object[] {
                        PlatePropertyPanel.ParamNames.Thickness, 10.0,
                        PlatePropertyPanel.ParamNames.Width, double.MaxValue,
                        PlatePropertyPanel.ParamNames.Heigth, double.MaxValue,
                        PlatePropertyPanel.ParamNames.NoPrefix, "",
                        PlatePropertyPanel.ParamNames.NoStartPostfix, "1",
                        PlatePropertyPanel.ParamNames.AssNoPrefix, "",
                        PlatePropertyPanel.ParamNames.AssNoStartPostfix, "1",
                        PlatePropertyPanel.ParamNames.Material, "Q235B",
                        PlatePropertyPanel.ParamNames.Name, "腹板连接板",
                        });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.OUTSIDE_FLANGE_CONN_PLATE_PROPS, PlatePropertyPanel.EmptyValue, (DObject)new object[] {
                        PlatePropertyPanel.ParamNames.Thickness, 10.0,
                        PlatePropertyPanel.ParamNames.Width, double.MaxValue,
                        PlatePropertyPanel.ParamNames.Heigth, double.MaxValue,
                        PlatePropertyPanel.ParamNames.NoPrefix, "",
                        PlatePropertyPanel.ParamNames.NoStartPostfix, "1",
                        PlatePropertyPanel.ParamNames.AssNoPrefix, "",
                        PlatePropertyPanel.ParamNames.AssNoStartPostfix, "1",
                        PlatePropertyPanel.ParamNames.Material, "Q235B",
                        PlatePropertyPanel.ParamNames.Name, "翼缘连接板",
                        });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.TOP_INSIDE_FLANGE_CONN_PLATE_PROPS, PlatePropertyPanel.EmptyValue, (DObject)new object[] {
                        PlatePropertyPanel.ParamNames.Thickness, double.MaxValue,
                        PlatePropertyPanel.ParamNames.Width, double.MaxValue,
                        PlatePropertyPanel.ParamNames.Heigth, double.MaxValue,
                        PlatePropertyPanel.ParamNames.NoPrefix, "",
                        PlatePropertyPanel.ParamNames.NoStartPostfix, "1",
                        PlatePropertyPanel.ParamNames.AssNoPrefix, "",
                        PlatePropertyPanel.ParamNames.AssNoStartPostfix, "1",
                        PlatePropertyPanel.ParamNames.Material, "Q235B",
                        PlatePropertyPanel.ParamNames.Name, "顶端内翼缘板",
                        });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.BOTTOM_INSIDE_FLANGE_CONN_PLATE_PROPS, PlatePropertyPanel.EmptyValue, (DObject)new object[] {
                        PlatePropertyPanel.ParamNames.Thickness, double.MaxValue,
                        PlatePropertyPanel.ParamNames.Width, double.MaxValue,
                        PlatePropertyPanel.ParamNames.Heigth, double.MaxValue,
                        PlatePropertyPanel.ParamNames.NoPrefix, "",
                        PlatePropertyPanel.ParamNames.NoStartPostfix, "1",
                        PlatePropertyPanel.ParamNames.AssNoPrefix, "",
                        PlatePropertyPanel.ParamNames.AssNoStartPostfix, "1",
                        PlatePropertyPanel.ParamNames.Material, "Q235B",
                        PlatePropertyPanel.ParamNames.Name, "底端内翼缘板",
                        });

            //短柱剪切
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.BACKING_BAR_PROPS, PlatePropertyPanel.EmptyValue, (DObject)new object[] {
                    PlatePropertyPanel.ParamNames.Thickness, 6.0,
                    PlatePropertyPanel.ParamNames.Width, 10,
                    PlatePropertyPanel.ParamNames.NoPrefix, "",
                    PlatePropertyPanel.ParamNames.NoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.AssNoPrefix, "",
                    PlatePropertyPanel.ParamNames.AssNoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.Material, "Q235B",
                    PlatePropertyPanel.ParamNames.Name, "垫板" });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.BACKING_BAR_MARGIN, double.MaxValue, 0d);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.BACKING_BAR_RADIUS, double.MaxValue, 0d);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.BACKING_BAR_TOP_PLACE_MODE, 0, 1);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.BACKING_BAR_BOTTOM_PLACE_MODE, 0, 1);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.BACKING_BAR_LENGTH, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.BACKING_BAR_LENGTH_MODE, 0, 1);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.RAT_HOLE_SHAPE_MODE, 0, 1);

            //接合页
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.FLANGE_PLATE_INSIDE_CHAMFER_MODE, 0, 2);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.FLANGE_PLATE_INSIDE_CHAMFER_CUTX, double.MaxValue, 15.0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.FLANGE_PLATE_INSIDE_CHAMFER_CUTY, double.MaxValue, 15.0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.FLANGE_PLATE_OUTSIDE_CHAMFER_MODE, 0, 1);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.FLANGE_PLATE_OUTSIDE_CHAMFER_CUTX, double.MaxValue, 15.0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.FLANGE_PLATE_OUTSIDE_CHAMFER_CUTY, double.MaxValue, 15.0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.FLANGE_PLATE_SHAPE_MODE, 0, 1);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.WEB_PLATE_BEAM_GAP, double.MaxValue, 0d);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.WEB_CONN_PLATE_MARGIN_LEFT, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.WEB_CONN_PLATE_MARGIN_RIGHT, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.SHIM_THICKNESS, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.LIFTING_HOLE_HORI_OFFSET, double.MaxValue, 140.0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.LIFTING_HOLE_VERT_OFFSET, double.MaxValue, 0d);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.LIFTING_HOLE_RADIUS, double.MaxValue, 60.0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.WEB_CONN_PLATE_OPEN_MODE, 0, 1);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.LIFTING_HOLE_OPEN_MODE, 0, 1);


            //腹板螺栓
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.WEB_BOLT_BASIC_PROPS, BoltBasicPropertyPanel.EmptyValue, (DObject)new object[] {
                            BoltBasicPropertyPanel.ParamNames.BoltStandard, "TS10.9",
                            BoltBasicPropertyPanel.ParamNames.BoltSize, 16,
                            BoltBasicPropertyPanel.ParamNames.ThreadInMtrl, 1, // false
                            BoltBasicPropertyPanel.ParamNames.MadeType0, 1, // Site
                        });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.WEB_BOLT_HOLE_PROPS, BoltHolePanel.EmptyValue, (DObject)new object[] {
                            BoltHolePanel.ParamNames.HoleX, 0.0,
                            BoltHolePanel.ParamNames.HoleY, 0.0,
                            BoltHolePanel.ParamNames.HoleType, 2,
                            BoltHolePanel.ParamNames.RotSlot, 3,
                            BoltHolePanel.ParamNames.SlotIn, 4
                        });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.WEB_BOLT_CONTENT_PROPS, null, (DObject)new object[]
                        {
                            BoltContentPanel.ParamNames.PartWasherUp, false,
                            BoltContentPanel.ParamNames.PartWasherDown0, false,
                            BoltContentPanel.ParamNames.PartWasherDown1, true,
                            BoltContentPanel.ParamNames.PartNut0, true,
                            BoltContentPanel.ParamNames.PartNut1,false,
                        });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.WEB_BOLT_EXTEND_PROPS, BoltExtendPanel.EmptyValue, (DObject)new object[] {
                            BoltExtendPanel.ParamNames.ExtLength, 0.0,
                        });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.WEB_BOLT_SHAPE, 0, 1);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.WEB_BOLT_VERT_COUNT, int.MaxValue, 2);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.WEB_BOLT_VERT_STRIDE, new double[] { }, new double[] { });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.WEB_BOLT_VERT_MARGIN_TOP, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.WEB_BOLT_VERT_MARGIN_BOTTOM, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.WEB_BOLT_LEFT_COUNT, int.MaxValue, 3);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.WEB_BOLT_LEFT_STRIDE, new double[] { }, new double[] { });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.WEB_BOLT_LEFT_MARGIN_SIDE, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.WEB_BOLT_LEFT_MARGIN_CENTER, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.WEB_BOLT_LEFT_MADE_MODE, 0, 1);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.WEB_BOLT_RIGHT_COUNT, int.MaxValue, 3);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.WEB_BOLT_RIGHT_STRIDE, new double[] { }, new double[] { });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.WEB_BOLT_RIGHT_MARGIN_SIDE, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.WEB_BOLT_RIGHT_MARGIN_CENTER, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.WEB_BOLT_RIGHT_MADE_MODE, 0, 1);


            //翼缘螺栓
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.FLANGE_BOLT_BASIC_PROPS, BoltBasicPropertyPanel.EmptyValue, (DObject)new object[] {
                            BoltBasicPropertyPanel.ParamNames.BoltStandard, "TS10.9",
                            BoltBasicPropertyPanel.ParamNames.BoltSize, 16,
                            BoltBasicPropertyPanel.ParamNames.ThreadInMtrl, 1, // false
                            BoltBasicPropertyPanel.ParamNames.MadeType0, 1, // Site
                        });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.FLANGE_BOLT_HOLE_PROPS, BoltHolePanel.EmptyValue, (DObject)new object[] {
                            BoltHolePanel.ParamNames.HoleX, 0.0,
                            BoltHolePanel.ParamNames.HoleY, 0.0,
                            BoltHolePanel.ParamNames.HoleType, 2,
                            BoltHolePanel.ParamNames.RotSlot, 3,
                            BoltHolePanel.ParamNames.SlotIn, 4
                        });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.FLANGE_BOLT_CONTENT_PROPS, null, (DObject)new object[]
                        {
                            BoltContentPanel.ParamNames.PartWasherUp, false,
                            BoltContentPanel.ParamNames.PartWasherDown0, false,
                            BoltContentPanel.ParamNames.PartWasherDown1, true,
                            BoltContentPanel.ParamNames.PartNut0, true,
                            BoltContentPanel.ParamNames.PartNut1, false,
                        });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.FLANGE_BOLT_EXTEND_PROPS, BoltExtendPanel.EmptyValue, (DObject)new object[] {
                            BoltExtendPanel.ParamNames.ExtLength, 0.0,
                        });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.FLANGE_BOLT_SHAPE, 0, 1);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.FLANGE_BOLT_HORI_COUNT, int.MaxValue, 3);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.FLANGE_BOLT_HORI_STRIDE, new double[] { }, new double[] { });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.FLANGE_BOLT_HORI_MARGIN_TOP, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.FLANGE_BOLT_HORI_MARGIN_BOTTOM, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.FLANGE_BOLT_VERT_COUNT, int.MaxValue, 2);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.FLANGE_BOLT_VERT_STRIDE, new double[] { }, new double[] { });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.FLANGE_BOLT_VERT_MARGIN_TOP, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.FLANGE_BOLT_VERT_MARGIN_BOTTOM, double.MaxValue, double.MaxValue);
            /*            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.FLANGES_BOLT_VERT_COUNT, int.MaxValue, 3);
                        AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.FLANGES_BOLT_VERT_STRIDE, new double[] { }, new double[] { });
                        AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.FLANGES_BOLT_TOP_MARGIN, double.MaxValue, double.MaxValue);
                        AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.FLANGES_BOLT_BOTTOM_MARGIN, double.MaxValue, double.MaxValue);*/

            // 焊缝
            for (int i = 0; i < ParamNames.WELD_PROPS_LIST.Length; ++i)
            {
                double defaultSize = 6.0;
                int WeldType = 11;
                if (i < 3)
                {
                    defaultSize = double.MaxValue;
                    WeldType = 1;
                }
                AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.WELD_PROPS_LIST[i], WeldPropertyPanel.EmptyValue, new DObject {
                    { WeldPropertyPanel.ParamNames.SizeUp, defaultSize },
                    { WeldPropertyPanel.ParamNames.WeldTypeUp, WeldType }, // Fillet
                    { WeldPropertyPanel.ParamNames.GrooveAngleUp, 0.0 },
                    { WeldPropertyPanel.ParamNames.WeldContourUp,  1}, // None
                    { WeldPropertyPanel.ParamNames.WeldFinishUp, 1 }, // None
                    { WeldPropertyPanel.ParamNames.LengthUp, 0.0 },
                    { WeldPropertyPanel.ParamNames.PitchUp, 0.0 },
                    { WeldPropertyPanel.ParamNames.RootFaceUp, 0.0 },
                    { WeldPropertyPanel.ParamNames.EffectiveThroatUp, 0.0 },
                    { WeldPropertyPanel.ParamNames.RootGapUp, 0.0 },

                    { WeldPropertyPanel.ParamNames.SizeDown, defaultSize },
                    { WeldPropertyPanel.ParamNames.WeldTypeDown, WeldType }, // Fillet
                    { WeldPropertyPanel.ParamNames.GrooveAngleDown, 0.0 },
                    { WeldPropertyPanel.ParamNames.WeldContourDown,  1}, // None
                    { WeldPropertyPanel.ParamNames.WeldFinishDown, 1 }, // None
                    { WeldPropertyPanel.ParamNames.LengthDown, 0.0 },
                    { WeldPropertyPanel.ParamNames.PitchDown, 0.0 },
                    { WeldPropertyPanel.ParamNames.RootFaceDown, 0.0 },
                    { WeldPropertyPanel.ParamNames.EffectiveThroatDown, 0.0 },
                    { WeldPropertyPanel.ParamNames.RootGapDown, 0.0 },

                    { WeldPropertyPanel.ParamNames.EdgeAround, 1 }, // Edge
                    { WeldPropertyPanel.ParamNames.MadeType, 2 }, // Workshop
                    { WeldPropertyPanel.ParamNames.StitchWeld, 1 }, // false
                    { WeldPropertyPanel.ParamNames.RefText, "" }
                });
            }

        }



        /// <summary>
        /// 组件公用属性空值表
        /// </summary>
        /// <remarks><b>此方法可直接复制到其他组件代码中使用</b></remarks>
        public static DObject EmptyValues
        {
            get
            {
                if (g_emptyValues == null)
                {
                    IntializeEmptyDefaults();
                }
                return g_emptyValues;
            }
        }

        /// <summary>
        /// 组件公用内置默认值接口
        /// </summary>
        /// <remarks><b>此方法可直接复制到其他组件代码中使用</b></remarks>
        public static DObject BuiltinDefautls
        {
            get
            {
                if (g_builtinDefaults == null)
                {
                    IntializeEmptyDefaults();
                }
                return g_builtinDefaults;
            }
        }

        /// <summary>
        /// 初始化默认值
        /// </summary>
        /// <param name="defaultConfig">从默认值配置加载的默认值</param>
        /// <remarks><b>此方法可直接复制到其他组件代码中使用</b></remarks>
        public override LoongCAD.Util.DObject InitializeDefaultValues(DObject defaultConfig)
        {
            m_defaultValues = new DObject();
            m_defaultValues.CopyFrom(defaultConfig);

            var emptyValues = ParamsHandler.EmptyValues;
            var builtinDefaults = ParamsHandler.BuiltinDefautls;
            if (emptyValues == null || builtinDefaults == null)
            {
                Console.WriteLine("ParamsHandler.InitializeDefaultValues: [Warning] EmptyValue/BuiltinDefaults is null!");
                return m_defaultValues;
            }

            this.TryCompleteDObjectValues(m_defaultValues, builtinDefaults, emptyValues);
            return m_defaultValues;
        }

    }
}
