﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using LoongCAD.Geometry;
using LoongCAD.STC;
using LoongCAD.STC.Plugins;

namespace ShortColumn133
{
    public class ColumnSplice42Handler
    {
        private ComponentInstanceContext m_context = null;
        private ParamsHandler m_paramsHandler = null;
        private ColumnSplice42.SpliceContext spliceContext = null;

        public ColumnSplice42Handler(ComponentInstanceContext context, ParamsHandler paramsHandler)
        {
            m_context = context;
            m_paramsHandler = paramsHandler;
            //
            spliceContext = new ColumnSplice42.SpliceContext();
            spliceContext.SubPart = m_context.SubPart;
            spliceContext.Comp = m_context.Comp;
            spliceContext.MainWebCenter = Util.CenterPlane(m_context.SubFrontWeb, m_context.SubBackWeb);
            spliceContext.MainHCenter = Util.CenterPlane(m_context.SubTopBound, m_context.SubBottomBound);
            spliceContext.SubHCenter = spliceContext.MainHCenter.Clone();
            //spliceContext.SubWebCenter = spliceContext.MainWebCenter.Clone();
            spliceContext.MainTopFlange = m_context.SubTopBound.Clone();
            spliceContext.MainBottomFlange = m_context.SubBottomBound.Clone();
            spliceContext.SubTopFlange = m_context.SubTopBound.Clone();
            spliceContext.SubBottomFlange = m_context.SubBottomBound.Clone();
            spliceContext.SubFrontWeb = m_context.SubFrontWeb.Clone();
            spliceContext.SubBackWeb = m_context.SubBackWeb.Clone();
            spliceContext.MainFront = m_context.SubFrontBound.Clone();
            spliceContext.MainBack = m_context.SubBackBound.Clone();
            spliceContext.SubFront = spliceContext.MainFront.Clone();
            spliceContext.SubBack = spliceContext.MainBack.Clone();
            spliceContext.SubTopFlangeInside = m_context.SubTopFlangeInside;
            spliceContext.SubBottomFlangeInside = m_context.SubBottomFlangeInside;
            //
            m_context.spliceContext = spliceContext;
        }

        public void Execute()
        {
            spliceContext.Initialize();

            ColumnSplice42.PlateHandler plateHandler = new ColumnSplice42.PlateHandler(spliceContext, m_paramsHandler);
            plateHandler.Execute();

            ColumnSplice42.BoltsHandler boltHandler = new ColumnSplice42.BoltsHandler(spliceContext, m_paramsHandler);
            boltHandler.Execute();

            ColumnSplice42.LiftingHoleHandler holeHandler = new ColumnSplice42.LiftingHoleHandler(spliceContext, m_paramsHandler);
            holeHandler.Execute();
        }
    }
}
