﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SpliceConnection77
{
    public static class ParamNames
    {
        //图形页参数
        public static readonly string BEAM_GAP = "beam_gap";
        public static readonly string BEAM_GAP_TYPE = "beam_gap_type";

        //零件页参数
        public static readonly string TOP_FLANGE_OUTSIDE_PLATE_PROPS = "top_flange_outside_plate_props";
        public static readonly string TOP_FLANGE_INSIDE_PLATE_PROPS = "top_flange_inside_plate_props";
        public static readonly string BOTTOM_FLANGE_OUTSIDE_PLATE_PROPS = "bottom_flange_outside_plate_props";
        public static readonly string BOTTOM_FLANGE_INSIDE_PLATE_PROPS = "bottom_flange_inside_plate_props";
        public static readonly string WEB_PLATE_PROPS = "web_plate_props";

        //衬板参数页
        public static readonly string TOP_FLANGE_OUTSIDE_PLATE_GAP = "top_flange_outside_plate_gap";
        public static readonly string TOP_FLANGE_INSIDE_PLATE_GAP = "top_flange_inside_plate_gap";
        public static readonly string BOTTOM_FLANGE_OUTSIDE_PLATE_GAP = "bottom_flange_outside_plate_gap";
        public static readonly string BOTTOM_FLANGE_INSIDE_PLATE_GAP = "bottom_flange_inside_plate_gap";
        public static readonly string WEB_PLATE_GAP = "web_plate_gap";

        /*
         * 翼缘螺栓
         */
        //属性设置
        public static readonly string BOLT_FLANGE_BASIC_PROPS = "bolt_flange_basic_standard_props";
        public static readonly string BOLT_FLANGE_HOLE_PROPS = "bolt_flange_hole_props";
        public static readonly string BOLT_FLANGE_CONTENT_PROPS = "bolt_flange_content_props";
        public static readonly string BOLT_FLANGE_EXTEND_PROPS = "bolt_flange_extend_props";
        public static readonly string BOLT_FLANGE_SHAPE = "bolt_flange_shape";
        public static readonly string BOLT_FLANGE_ORIENTATION = "bolt_flange_orientation";
        //位置信息
        public static readonly string BOLT_FLANGE_HORI_CENTER_MARGIN = "bolt_flange_hori_center_margin";//距靠中心截面间距
        public static readonly string BOLT_FLANGE_HORI_COUNT = "bolt_flange_hori_count";
        public static readonly string BOLT_FLANGE_HORI_STRIDE = "bolt_flange_hori_stride";
        public static readonly string BOLT_FLANGE_HORI_EDGE_MARGIN = "bolt_flange_hori_edge_margin";//边距
        public static readonly string BOLT_FLANGE_VERT_CENTER_GAP = "bolt_flange_vert_center_gap";//中心两螺栓间距
        public static readonly string BOLT_FLANGE_VERT_COUNT = "bolt_flange_vert_count";
        public static readonly string BOLT_FLANGE_VERT_STRIDE = "bolt_flange_vert_stride";
        public static readonly string BOLT_FLANGE_VERT_EDGE_MARGIN = "bolt_flange_vert_edge_margin";//边距
        //翼缘内侧连接板的定位，板中心与边缘螺栓的间距
        public static readonly string BOLT_FLANGE_VERT_INSIDE_MARGIN = "bolt_flange_vert_inside_margin";


        /*
         * 腹板螺栓
         */
        //属性设置
        public static readonly string BOLT_WEB_BASIC_PROPS = "bolt_web_basic_standard_props";
        public static readonly string BOLT_WEB_HOLE_PROPS = "bolt_web_hole_props";
        public static readonly string BOLT_WEB_CONTENT_PROPS = "bolt_web_content_props";
        public static readonly string BOLT_WEB_EXTEND_PROPS = "bolt_web_extend_props";
        public static readonly string BOLT_WEB_SHAPE = "bolt_web_shape";
        public static readonly string BOLT_WEB_ORIENTATION = "bolt_web_orientation";
        //位置信息
        public static readonly string BOLT_WEB_HORI_CENTER_MARGIN = "bolt_web_hori_center_margin";//
        public static readonly string BOLT_WEB_HORI_COUNT = "bolt_web_hori_count";
        public static readonly string BOLT_WEB_HORI_STRIDE = "bolt_web_hori_stride";
        public static readonly string BOLT_WEB_HORI_EDGE_MARGIN = "bolt_web_hori_edge_margin";
        public static readonly string BOLT_WEB_VERT_FLANGE_MARGIN = "bolt_web_vert_flange_margin"; //与上翼缘间距
        public static readonly string BOLT_WEB_VERT_COUNT = "bolt_web_vert_count";
        public static readonly string BOLT_WEB_VERT_STRIDE = "bolt_web_vert_stride";
        public static readonly string BOLT_WEB_VERT_EDGE_MARGIN = "bolt_web_vert_edge_margin";



        /*
         * 焊接准备
         */
        //衬垫板
        public static readonly string WELD_BACKING_PROPS = "weld_backing_props";
        public static readonly string WELD_BACKING_H = "weld_backing_h";
        public static readonly string WELD_BACKING_H_MODE = "weld_backing_h_mode";
        public static readonly string WELD_BACKING_CENTER_OFFSET = "weld_backing_center_offset";
        public static readonly string WELD_BACKING_PLACE_TOP = "weld_backing_place_top";
        public static readonly string WELD_BACKING_PLACE_BOTTOM = "weld_backing_place_bottom";
        //出入孔
        public static readonly string WELD_ACCESS_HOLE_RADIUS_MAIN = "weld_access_hole_radius_main";
        public static readonly string WELD_ACCESS_HOLE_RADIUS_SUB = "weld_access_hole_radius_sub";
        //
        public static readonly string WELD_READY_TOP_FLANGE = "weld_ready_top_flange";
        public static readonly string WELD_READY_BOTTOM_FLANGE = "weld_ready_bottom_flange";
        public static readonly string WELD_READY_WEB = "weld_ready_web";
        public static readonly string WELD_READY_BACKING = "weld_ready_backing";




        /*
         * 楼层板
         */
        //基础属性
        public static readonly string FLOOR_PLATE_PROPS = "floor_plate_props";
        //位置
        public static readonly string FLOOR_PLATE_PLACE = "floor_plate_place";
        //梁方向长度
        public static readonly string FLOOR_PLATE_MAIN_CENTER_MARGIN = "floor_plate_main_center_margin";
        public static readonly string FLOOR_PLATE_MAIN_SIDE_OFFSET = "floor_plate_main_side_offset";
        public static readonly string FLOOR_PLATE_SUB_CENTER_MARGIN = "floor_plate_sub_center_margin";
        public static readonly string FLOOR_PLATE_SUB_SIDE_OFFSET = "floor_plate_sub_side_offset";


        /*
         * 吊装孔
         */
        public static readonly string LIFTING_HOLE_PLACE = "lifting_hole_place";
        public static readonly string LIFTING_HOLE_RADIUS = "lifting_hole_radius";
        public static readonly string LIFTING_HOLE_VERT_MARGIN = "lifting_hole_vert_margin";
        public static readonly string LIFTING_HOLE_HORI_MARGIN = "lifting_hole_hori_margin";


        /*
         * 构件设置
         */
        public static readonly string WEB_PLATE_PLACE = "web_plate_place";
        public static readonly string BOLT_WELD_SELECT_MAIN_TOP = "bolt_weld_select_main_top";
        public static readonly string BOLT_WELD_SELECT_MAIN_BOTTOM = "bolt_weld_select_main_bottom";
        public static readonly string BOLT_WELD_SELECT_SUB_TOP = "bolt_weld_select_sub_top";
        public static readonly string BOLT_WELD_SELECT_SUB_BOTTOM = "bolt_weld_select_sub_bottom";
        public static readonly string BOLT_WELD_SELECT_WEB_MAIN = "bolt_weld_select_web_main";
        public static readonly string BOLT_WELD_SELECT_WEB_SUB = "bolt_weld_select_web_sub";
        public static readonly string FACTORY_BOLT = "factory_bolt"; //车间螺栓
        public static readonly string UNDER_BOARD_WELD = "under_board_weld"; //松弛部件装配
        public static readonly string CONNECT_PLATE_COMPONENT = "connect_plate_component"; //连接板构件


        /*
         * 焊缝属性名称
         */
        public static readonly string[] WELD_PROPS_LIST = new string[]
        {
            "weld_props0",
            "weld_props1",
            "weld_props2",
            "weld_props3",
            "weld_props4"
        };

    }
}
