﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using LoongCAD.UI.Component;
using LoongCAD.Util;

namespace SpliceConnection77
{
    public class ParamsHandler : LoongCAD.STC.Plugins.ParamsHandlerBase
    {
        /// <summary>
        /// 属性空值全局总表
        /// </summary>
        /// <remarks><b>此静态变量可直接复制到其他组件代码中使用</b></remarks>
        protected static DObject g_emptyValues = null;

        /// <summary>
        /// 属性内置默认值全局总表
        /// </summary>
        /// <remarks><b>此静态变量可直接复制到其他组件代码中使用</b></remarks>
        protected static DObject g_builtinDefaults = null;

        /// <summary>
        /// 默认构造函数
        /// </summary>
        /// <remarks><b>此方法需要复制到其他组件代码中使用</b></remarks>
        public ParamsHandler()
            : base(ParamsHandler.EmptyValues, ParamsHandler.BuiltinDefautls)
        {

        }

        public static void IntializeEmptyDefaults()
        {
            g_emptyValues = new DObject();
            g_builtinDefaults = new DObject();

            //图形页
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.BEAM_GAP, double.MaxValue, 0.0); // 默认间距0
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.BEAM_GAP_TYPE, 0, 1); //默认居中

            //零件页
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.TOP_FLANGE_OUTSIDE_PLATE_PROPS, PlatePropertyPanel.EmptyValue, (DObject)new object[] {
                    PlatePropertyPanel.ParamNames.Thickness, double.MaxValue,
                    PlatePropertyPanel.ParamNames.Width, double.MaxValue,
                    PlatePropertyPanel.ParamNames.Heigth, double.MaxValue,
                    PlatePropertyPanel.ParamNames.NoPrefix, "",
                    PlatePropertyPanel.ParamNames.NoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.AssNoPrefix, "",
                    PlatePropertyPanel.ParamNames.AssNoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.Material, "Q235B",
                    PlatePropertyPanel.ParamNames.Name, "板",
                });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.TOP_FLANGE_INSIDE_PLATE_PROPS, PlatePropertyPanel.EmptyValue, (DObject)new object[] {
                    PlatePropertyPanel.ParamNames.Thickness, double.MaxValue,
                    PlatePropertyPanel.ParamNames.Width, double.MaxValue,
                    PlatePropertyPanel.ParamNames.Heigth, double.MaxValue,
                    PlatePropertyPanel.ParamNames.NoPrefix, "",
                    PlatePropertyPanel.ParamNames.NoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.AssNoPrefix, "",
                    PlatePropertyPanel.ParamNames.AssNoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.Material, "Q235B",
                    PlatePropertyPanel.ParamNames.Name, "板",
                });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.BOTTOM_FLANGE_OUTSIDE_PLATE_PROPS, PlatePropertyPanel.EmptyValue, (DObject)new object[] {
                    PlatePropertyPanel.ParamNames.Thickness, double.MaxValue,
                    PlatePropertyPanel.ParamNames.Width, double.MaxValue,
                    PlatePropertyPanel.ParamNames.Heigth, double.MaxValue,
                    PlatePropertyPanel.ParamNames.NoPrefix, "",
                    PlatePropertyPanel.ParamNames.NoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.AssNoPrefix, "",
                    PlatePropertyPanel.ParamNames.AssNoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.Material, "Q235B",
                    PlatePropertyPanel.ParamNames.Name, "板",
                });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.BOTTOM_FLANGE_INSIDE_PLATE_PROPS, PlatePropertyPanel.EmptyValue, (DObject)new object[] {
                    PlatePropertyPanel.ParamNames.Thickness, double.MaxValue,
                    PlatePropertyPanel.ParamNames.Width, double.MaxValue,
                    PlatePropertyPanel.ParamNames.Heigth, double.MaxValue,
                    PlatePropertyPanel.ParamNames.NoPrefix, "",
                    PlatePropertyPanel.ParamNames.NoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.AssNoPrefix, "",
                    PlatePropertyPanel.ParamNames.AssNoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.Material, "Q235B",
                    PlatePropertyPanel.ParamNames.Name, "板",
                });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.WEB_PLATE_PROPS, PlatePropertyPanel.EmptyValue, (DObject)new object[] {
                    PlatePropertyPanel.ParamNames.Thickness, double.MaxValue,
                    PlatePropertyPanel.ParamNames.Width, double.MaxValue,
                    PlatePropertyPanel.ParamNames.Heigth, double.MaxValue,
                    PlatePropertyPanel.ParamNames.NoPrefix, "",
                    PlatePropertyPanel.ParamNames.NoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.AssNoPrefix, "",
                    PlatePropertyPanel.ParamNames.AssNoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.Material, "Q235B",
                    PlatePropertyPanel.ParamNames.Name, "板",
                });

            //衬板页
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.TOP_FLANGE_OUTSIDE_PLATE_GAP, PlatePropertyPanel.EmptyValue, (DObject)new object[] {
                    PlatePropertyPanel.ParamNames.Thickness, double.MaxValue,
                    PlatePropertyPanel.ParamNames.NoPrefix, "",
                    PlatePropertyPanel.ParamNames.NoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.AssNoPrefix, "",
                    PlatePropertyPanel.ParamNames.AssNoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.Material, "Q235B",
                    PlatePropertyPanel.ParamNames.Name, "板",
                });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.TOP_FLANGE_INSIDE_PLATE_GAP, PlatePropertyPanel.EmptyValue, (DObject)new object[] {
                    PlatePropertyPanel.ParamNames.Thickness, double.MaxValue,
                    PlatePropertyPanel.ParamNames.NoPrefix, "",
                    PlatePropertyPanel.ParamNames.NoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.AssNoPrefix, "",
                    PlatePropertyPanel.ParamNames.AssNoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.Material, "Q235B",
                    PlatePropertyPanel.ParamNames.Name, "板",
                });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.BOTTOM_FLANGE_OUTSIDE_PLATE_GAP, PlatePropertyPanel.EmptyValue, (DObject)new object[] {
                    PlatePropertyPanel.ParamNames.Thickness, double.MaxValue,
                    PlatePropertyPanel.ParamNames.NoPrefix, "",
                    PlatePropertyPanel.ParamNames.NoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.AssNoPrefix, "",
                    PlatePropertyPanel.ParamNames.AssNoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.Material, "Q235B",
                    PlatePropertyPanel.ParamNames.Name, "板",
                });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.BOTTOM_FLANGE_INSIDE_PLATE_GAP, PlatePropertyPanel.EmptyValue, (DObject)new object[] {
                    PlatePropertyPanel.ParamNames.Thickness, double.MaxValue,
                    PlatePropertyPanel.ParamNames.NoPrefix, "",
                    PlatePropertyPanel.ParamNames.NoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.AssNoPrefix, "",
                    PlatePropertyPanel.ParamNames.AssNoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.Material, "Q235B",
                    PlatePropertyPanel.ParamNames.Name, "板",
                });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.WEB_PLATE_GAP, PlatePropertyPanel.EmptyValue, (DObject)new object[] {
                    PlatePropertyPanel.ParamNames.Thickness, double.MaxValue,
                    PlatePropertyPanel.ParamNames.NoPrefix, "",
                    PlatePropertyPanel.ParamNames.NoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.AssNoPrefix, "",
                    PlatePropertyPanel.ParamNames.AssNoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.Material, "Q235B",
                    PlatePropertyPanel.ParamNames.Name, "板",
                });
            
            //翼缘螺栓
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.BOLT_FLANGE_BASIC_PROPS, BoltBasicPropertyPanel.EmptyValue, (DObject)new object[] {
                    BoltBasicPropertyPanel.ParamNames.BoltStandard, "TS10.9",
                    BoltBasicPropertyPanel.ParamNames.BoltSize, 20D,
                    BoltBasicPropertyPanel.ParamNames.ThreadInMtrl, 1, // false
                    BoltBasicPropertyPanel.ParamNames.MadeType0, 1, // Site
                });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.BOLT_FLANGE_HOLE_PROPS, BoltHolePanel.EmptyValue, (DObject)new object[] {
                BoltHolePanel.ParamNames.HoleX, 0.0,
                BoltHolePanel.ParamNames.HoleY, 0.0,
                BoltHolePanel.ParamNames.HoleType, 2,
                BoltHolePanel.ParamNames.RotSlot, 3,
                BoltHolePanel.ParamNames.SlotIn, 4
            });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.BOLT_FLANGE_CONTENT_PROPS, null, (DObject)new object[]
            {
                BoltContentPanel.ParamNames.PartWasherUp, false,
                BoltContentPanel.ParamNames.PartWasherDown0, false,
                BoltContentPanel.ParamNames.PartWasherDown1, true,
                BoltContentPanel.ParamNames.PartNut0, true,
                BoltContentPanel.ParamNames.PartNut1, false,
            });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.BOLT_FLANGE_EXTEND_PROPS, BoltExtendPanel.EmptyValue, (DObject)new object[]
            {
                BoltExtendPanel.ParamNames.ExtLength, 0.0,
            });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.BOLT_FLANGE_SHAPE, 0, 1); // Array
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.BOLT_FLANGE_ORIENTATION, 0, 3);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.BOLT_FLANGE_HORI_CENTER_MARGIN, double.MaxValue, double.MaxValue);//
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.BOLT_FLANGE_HORI_COUNT, int.MaxValue, int.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.BOLT_FLANGE_HORI_STRIDE, new double[] { }, new double[] { });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.BOLT_FLANGE_HORI_EDGE_MARGIN, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.BOLT_FLANGE_VERT_CENTER_GAP, double.MaxValue, double.MaxValue);//中心两螺栓间距
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.BOLT_FLANGE_VERT_COUNT, int.MaxValue, int.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.BOLT_FLANGE_VERT_STRIDE, new double[] { }, new double[] { });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.BOLT_FLANGE_VERT_EDGE_MARGIN, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.BOLT_FLANGE_VERT_INSIDE_MARGIN, double.MaxValue, double.MaxValue);

            //腹板螺栓
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.BOLT_WEB_BASIC_PROPS, BoltBasicPropertyPanel.EmptyValue, (DObject)new object[] {
                    BoltBasicPropertyPanel.ParamNames.BoltStandard, "TS10.9",
                    BoltBasicPropertyPanel.ParamNames.BoltSize, 20,
                    BoltBasicPropertyPanel.ParamNames.ThreadInMtrl, 1, // false
                    BoltBasicPropertyPanel.ParamNames.MadeType0, 1, // Site
                });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.BOLT_WEB_HOLE_PROPS, BoltHolePanel.EmptyValue, (DObject)new object[] {
                BoltHolePanel.ParamNames.HoleX, 0.0,
                BoltHolePanel.ParamNames.HoleY, 0.0,
                BoltHolePanel.ParamNames.HoleType, 2,
                BoltHolePanel.ParamNames.RotSlot, 3,
                BoltHolePanel.ParamNames.SlotIn, 4
            });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.BOLT_WEB_CONTENT_PROPS, null, (DObject)new object[]
            {
                BoltContentPanel.ParamNames.PartWasherUp, false,
                BoltContentPanel.ParamNames.PartWasherDown0, false,
                BoltContentPanel.ParamNames.PartWasherDown1, true,
                BoltContentPanel.ParamNames.PartNut0, true,
                BoltContentPanel.ParamNames.PartNut1, false,
            });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.BOLT_WEB_EXTEND_PROPS, BoltExtendPanel.EmptyValue, (DObject)new object[]
            {
                BoltExtendPanel.ParamNames.ExtLength, 0.0,
            });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.BOLT_WEB_SHAPE, 0, 1); // Array
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.BOLT_WEB_ORIENTATION, 0, 3); 
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.BOLT_WEB_HORI_CENTER_MARGIN, double.MaxValue, double.MaxValue);//
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.BOLT_WEB_HORI_COUNT, int.MaxValue, int.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.BOLT_WEB_HORI_STRIDE, new double[] { }, new double[] { });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.BOLT_WEB_HORI_EDGE_MARGIN, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.BOLT_WEB_VERT_FLANGE_MARGIN, double.MaxValue, double.MaxValue);//这个距离是自适应的，在主梁中间
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.BOLT_WEB_VERT_COUNT, int.MaxValue, int.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.BOLT_WEB_VERT_STRIDE, new double[] { }, new double[] { });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.BOLT_WEB_VERT_EDGE_MARGIN, double.MaxValue, double.MaxValue);

            //焊接准备——衬垫板
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.WELD_BACKING_PROPS, PlatePropertyPanel.EmptyValue, (DObject)new object[] {
                    PlatePropertyPanel.ParamNames.Thickness, 6.0,
                    PlatePropertyPanel.ParamNames.Width, 32.0,
                    PlatePropertyPanel.ParamNames.Heigth, 32.0, //这个值是自适应的
                    PlatePropertyPanel.ParamNames.NoPrefix, "",
                    PlatePropertyPanel.ParamNames.NoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.AssNoPrefix, "",
                    PlatePropertyPanel.ParamNames.AssNoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.Material, "Q235B",
                    PlatePropertyPanel.ParamNames.Name, "板",
                });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.WELD_BACKING_H, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.WELD_BACKING_H_MODE, double.MaxValue, 0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.WELD_BACKING_CENTER_OFFSET, double.MaxValue, 0.0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.WELD_BACKING_PLACE_TOP, 0, 0); 
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults, ParamNames.WELD_BACKING_PLACE_BOTTOM, 0, 0); //默认为 内
            //焊接准备——出入孔
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.WELD_ACCESS_HOLE_RADIUS_MAIN, double.MaxValue, 0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.WELD_ACCESS_HOLE_RADIUS_SUB, double.MaxValue, 0);
            //焊接准备
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.WELD_READY_TOP_FLANGE, 0, 0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.WELD_READY_BOTTOM_FLANGE, 0, 0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.WELD_READY_WEB, 0, 0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.WELD_READY_BACKING, 0, 0);


            //楼层板
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.FLOOR_PLATE_PROPS, PlatePropertyPanel.EmptyValue, (DObject)new object[] {
                    PlatePropertyPanel.ParamNames.Thickness, 6.0,
                    PlatePropertyPanel.ParamNames.Width, 50.0,
                    PlatePropertyPanel.ParamNames.Heigth, 230.0, 
                    PlatePropertyPanel.ParamNames.NoPrefix, "",
                    PlatePropertyPanel.ParamNames.NoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.AssNoPrefix, "",
                    PlatePropertyPanel.ParamNames.AssNoStartPostfix, "1",
                    PlatePropertyPanel.ParamNames.Material, "Q235B",
                    PlatePropertyPanel.ParamNames.Name, "板",
                });
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.FLOOR_PLATE_PLACE, 0, 0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.FLOOR_PLATE_MAIN_CENTER_MARGIN, double.MaxValue, 50.0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.FLOOR_PLATE_MAIN_SIDE_OFFSET, double.MaxValue, 50.0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.FLOOR_PLATE_SUB_CENTER_MARGIN, double.MaxValue, 50.0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.FLOOR_PLATE_SUB_SIDE_OFFSET, double.MaxValue, 50.0);

            //吊装孔
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.LIFTING_HOLE_PLACE, 0, 0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.LIFTING_HOLE_RADIUS, double.MaxValue, 20.0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.LIFTING_HOLE_VERT_MARGIN, double.MaxValue, 0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.LIFTING_HOLE_HORI_MARGIN, double.MaxValue, 50.0);

            //构件设置
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.WEB_PLATE_PLACE, 0, 0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.BOLT_WELD_SELECT_MAIN_TOP, 0, 0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.BOLT_WELD_SELECT_MAIN_BOTTOM, 0, 0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.BOLT_WELD_SELECT_SUB_TOP, 0, 0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.BOLT_WELD_SELECT_SUB_BOTTOM, 0, 0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.BOLT_WELD_SELECT_WEB_MAIN, 0, 0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.BOLT_WELD_SELECT_WEB_SUB, 0, 0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.FACTORY_BOLT, 0, 0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.UNDER_BOARD_WELD, 0, 0);
            AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.CONNECT_PLATE_COMPONENT, 0, 0);

            // 焊缝
            for (int i = 0; i < ParamNames.WELD_PROPS_LIST.Length; ++i)
            {
                AddEmptyDefaultValue(g_emptyValues, g_builtinDefaults,  ParamNames.WELD_PROPS_LIST[i], WeldPropertyPanel.EmptyValue, new DObject {
                    { WeldPropertyPanel.ParamNames.SizeUp, double.MaxValue },
                    { WeldPropertyPanel.ParamNames.WeldTypeUp, 1 }, // None
                    { WeldPropertyPanel.ParamNames.GrooveAngleUp, 0.0 },
                    { WeldPropertyPanel.ParamNames.WeldContourUp,  1}, // None
                    { WeldPropertyPanel.ParamNames.WeldFinishUp, 1 }, // None
                    { WeldPropertyPanel.ParamNames.LengthUp, 0.0 },
                    { WeldPropertyPanel.ParamNames.PitchUp, 0.0 },
                    { WeldPropertyPanel.ParamNames.RootFaceUp, 0.0 },
                    { WeldPropertyPanel.ParamNames.EffectiveThroatUp, 0.0 },
                    { WeldPropertyPanel.ParamNames.RootGapUp, 0.0 },

                    { WeldPropertyPanel.ParamNames.SizeDown, double.MaxValue },
                    { WeldPropertyPanel.ParamNames.WeldTypeDown, 1 }, // None
                    { WeldPropertyPanel.ParamNames.GrooveAngleDown, 0.0 },
                    { WeldPropertyPanel.ParamNames.WeldContourDown,  1}, // None
                    { WeldPropertyPanel.ParamNames.WeldFinishDown, 1 }, // None
                    { WeldPropertyPanel.ParamNames.LengthDown, 0.0 },
                    { WeldPropertyPanel.ParamNames.PitchDown, 0.0 },
                    { WeldPropertyPanel.ParamNames.RootFaceDown, 0.0 },
                    { WeldPropertyPanel.ParamNames.EffectiveThroatDown, 0.0 },
                    { WeldPropertyPanel.ParamNames.RootGapDown, 0.0 },

                    { WeldPropertyPanel.ParamNames.EdgeAround, 1 }, // Edge
                    { WeldPropertyPanel.ParamNames.MadeType, 1 }, // 默认工地
                    { WeldPropertyPanel.ParamNames.StitchWeld, 1 }, // false
                    { WeldPropertyPanel.ParamNames.RefText, "" }
                });
            }
        }

        /// <summary>
        /// 组件公用属性空值表
        /// </summary>
        /// <remarks><b>此方法可直接复制到其他组件代码中使用</b></remarks>
        public static DObject EmptyValues
        {
            get
            {
                if (g_emptyValues == null)
                {
                    IntializeEmptyDefaults();
                }
                return g_emptyValues;
            }
        }

        /// <summary>
        /// 组件公用内置默认值接口
        /// </summary>
        /// <remarks><b>此方法可直接复制到其他组件代码中使用</b></remarks>
        public static DObject BuiltinDefautls
        {
            get
            {
                if (g_builtinDefaults == null)
                {
                    IntializeEmptyDefaults();
                }
                return g_builtinDefaults;
            }
        }

        /// <summary>
        /// 初始化默认值
        /// </summary>
        /// <param name="defaultConfig">从默认值配置加载的默认值</param>
        /// <remarks><b>此方法可直接复制到其他组件代码中使用</b></remarks>
        public override LoongCAD.Util.DObject InitializeDefaultValues(DObject defaultConfig)
        {
            m_defaultValues = new DObject();
            m_defaultValues.CopyFrom(defaultConfig);

            var emptyValues = ParamsHandler.EmptyValues;
            var builtinDefaults = ParamsHandler.BuiltinDefautls;
            if (emptyValues == null || builtinDefaults == null)
            {
                Console.WriteLine("ParamsHandler.InitializeDefaultValues: [Warning] EmptyValue/BuiltinDefaults is null!");
                return m_defaultValues;
            }

            this.TryCompleteDObjectValues(m_defaultValues, builtinDefaults, emptyValues);
            return m_defaultValues;
        }



    }
}
