﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using LoongCAD.Geometry;
using LoongCAD.STC;
using LoongCAD.STC.Object3D;
using LoongCAD.STC.Plugins;
using LoongCAD.UI;
using LoongCAD.UI.Component;
using LoongCAD.Util;

namespace SpliceConnection77
{
    class Util
    {
        public static void CreateSteelBySymmetry(ConnectionComponent cmp, Plane zplane, double thickness, Plane[] sidePlanes, bool bRuntime, Plane plane)
        {
            Plane symmetryCenterPlane = plane.Clone();
            Plane zCtrlPlane = zplane.Clone();
            cmp.CreateSteelPlate(zCtrlPlane, thickness, sidePlanes, bRuntime);
            if (symmetryCenterPlane != null)
            {
                double dist = zCtrlPlane.SignedDist(symmetryCenterPlane.Origin);
                zCtrlPlane.Move(2 * dist - thickness); //移动板平面到对应位置
                cmp.CreateSteelPlate(zCtrlPlane, thickness, sidePlanes, bRuntime);
            }
            cmp.Flush();
        }

        public static Plane CreatePlaneBySymmetry(Plane zplane, Plane plane)
        {
            Plane symmetryCenterPlane = plane.Clone();
            Plane zCtrlPlane = zplane.Clone();
            double dist = zCtrlPlane.SignedDist(symmetryCenterPlane.Origin);
            return zCtrlPlane.Move(2 * dist).Invert(); //移动板平面到对应位置
        }
    }
}
