﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using LoongCAD.STC.Object3D;
using LoongCAD.STC.Plugins;
using LoongCAD.UI;
using LoongCAD.Util;

namespace SpliceConnection77
{
    public partial class Form_PluginMain : LoongCAD.UI.Component.Form_ConnectionComponentProps
    {

        private DObject m_rootUIProps = new DObject();
        private ComponentPlugin m_refPlugin = null;
        private Form_WeldParameter m_weldForm = null;

        public Form_PluginMain(ComponentPlugin refPlugin)
        {
            InitializeComponent();
            m_refPlugin = refPlugin;
            this.OnPostIntialize();
        }

        public override ComponentPlugin ReferencePlugin => m_refPlugin;

        private void OnPostIntialize()
        {
            // 设置窗口标题
            this.Text = "拼接节点（204）";

            foreach (TabPage curPage in this.tab_main.TabPages)
            {
                curPage.AutoScroll = true;
            }

            this.tb_beam_gap_type.ClearItems();
            this.tb_beam_gap_type.AddIntegerItems(0, 0, 4);
            this.tb_beam_gap_type.UpdateItems();


            this.tb_bolt_web_orientation.ClearItems();
            this.tb_bolt_web_orientation.AddIntegerItems(0, 0, 3);
            this.tb_bolt_web_orientation.UpdateItems();

            this.tb_bolt_flange_orientation.ClearItems();
            this.tb_bolt_flange_orientation.AddIntegerItems(0, 0, 3);
            this.tb_bolt_flange_orientation.UpdateItems();

            this.tb_weld_backing_h_mode.ClearItems();
            this.tb_weld_backing_h_mode.AddIntegerItems(0, 0, 3);
            this.tb_weld_backing_h_mode.UpdateItems();

            this.tb_floor_plate_place.ClearItems();
            this.tb_floor_plate_place.AddIntegerItems(0, 0, 5);
            this.tb_floor_plate_place.UpdateItems();


            this.tb_lifting_hole_place.ClearItems();
            this.tb_lifting_hole_place.AddIntegerItems(0, 0, 4);
            this.tb_lifting_hole_place.UpdateItems();

            this.tb_web_plate_place.ClearItems();
            this.tb_web_plate_place.AddIntegerItems(0, 0, 4);
            this.tb_web_plate_place.UpdateItems();

            this.tb_bolt_weld_select_main_top.ClearItems(); //选择螺栓还是焊接？
            this.tb_bolt_weld_select_main_top.AddIntegerItems(0, 0, 3);//
            this.tb_bolt_weld_select_main_top.UpdateItems();

            this.tb_bolt_weld_select_main_bottom.ClearItems();
            this.tb_bolt_weld_select_main_bottom.AddIntegerItems(0, 0, 3);//
            this.tb_bolt_weld_select_main_bottom.UpdateItems();

            this.tb_bolt_weld_select_sub_top.ClearItems();
            this.tb_bolt_weld_select_sub_top.AddIntegerItems(0, 0, 3);//
            this.tb_bolt_weld_select_sub_top.UpdateItems();

            this.tb_bolt_weld_select_sub_bottom.ClearItems();
            this.tb_bolt_weld_select_sub_bottom.AddIntegerItems(0, 0, 3);//
            this.tb_bolt_weld_select_sub_bottom.UpdateItems();

            this.tb_bolt_weld_select_web_main.ClearItems();
            this.tb_bolt_weld_select_web_main.AddIntegerItems(0, 0, 3);//
            this.tb_bolt_weld_select_web_main.UpdateItems();

            this.tb_bolt_weld_select_web_sub.ClearItems();
            this.tb_bolt_weld_select_web_sub.AddIntegerItems(0, 0, 3);//
            this.tb_bolt_weld_select_web_sub.UpdateItems();

            this.tb_weld_backing_place_top.ClearItems();
            this.tb_weld_backing_place_top.AddIntegerItems(0, 0, 4);//上翼缘衬垫板位置
            this.tb_weld_backing_place_top.UpdateItems();

            this.tb_weld_backing_place_bottom.ClearItems();
            this.tb_weld_backing_place_bottom.AddIntegerItems(0, 0, 4);//
            this.tb_weld_backing_place_bottom.UpdateItems();


            this.tb_weld_ready_top_flange.ClearItems();
            this.tb_weld_ready_top_flange.AddItem(0, "无");
            this.tb_weld_ready_top_flange.AddItem(1, "两者");
            this.tb_weld_ready_top_flange.AddItem(2, "主零件");
            this.tb_weld_ready_top_flange.AddItem(3, "次零件");
            this.tb_weld_ready_top_flange.UpdateItems();
            this.tb_weld_ready_top_flange.SelectedKey = 0;

            this.tb_weld_ready_bottom_flange.ClearItems();
            this.tb_weld_ready_bottom_flange.AddItem(0, "无");
            this.tb_weld_ready_bottom_flange.AddItem(1, "两者");
            this.tb_weld_ready_bottom_flange.AddItem(2, "主零件");
            this.tb_weld_ready_bottom_flange.AddItem(3, "次零件");
            this.tb_weld_ready_bottom_flange.UpdateItems();
            this.tb_weld_ready_bottom_flange.SelectedKey = 0;

            this.tb_weld_ready_web.ClearItems();
            this.tb_weld_ready_web.AddItem(0, "无");
            this.tb_weld_ready_web.AddItem(1, "两者");
            this.tb_weld_ready_web.AddItem(2, "主零件");
            this.tb_weld_ready_web.AddItem(3, "次零件");
            this.tb_weld_ready_web.UpdateItems();
            this.tb_weld_ready_web.SelectedKey = 0;

            this.tb_weld_ready_backing.ClearItems(); //背板焊接准备
            this.tb_weld_ready_backing.AddItem(0, "无");
            this.tb_weld_ready_backing.AddItem(1, "主零件");
            this.tb_weld_ready_backing.AddItem(2, "次零件");
            this.tb_weld_ready_backing.UpdateItems();
            this.tb_weld_ready_backing.SelectedKey = 0;

            this.tb_factory_bolt.ClearItems();
            this.tb_factory_bolt.AddItem(0, "没有");
            this.tb_factory_bolt.AddItem(1, "主零件");
            this.tb_factory_bolt.AddItem(2, "次零件");
            this.tb_factory_bolt.UpdateItems();
            this.tb_factory_bolt.SelectedKey = 0;

            this.tb_under_board_weld.ClearItems();
            this.tb_under_board_weld.AddItem(0, "没有");
            this.tb_under_board_weld.AddItem(1, "主零件");
            this.tb_under_board_weld.AddItem(2, "次零件");
            this.tb_under_board_weld.AddItem(3, "两者");
            this.tb_under_board_weld.UpdateItems();
            this.tb_under_board_weld.SelectedKey = 0;

            this.tb_connect_plate_component.ClearItems();
            this.tb_connect_plate_component.AddItem(0, "没有");
            this.tb_connect_plate_component.AddItem(1, "主零件");
            this.tb_connect_plate_component.AddItem(2, "次零件");
            this.tb_connect_plate_component.AddItem(3, "两者");
            this.tb_connect_plate_component.UpdateItems();
            this.tb_connect_plate_component.SelectedKey = 0;

            //
            this.panel_web_bolt_basic_property.BoltStandardChanged += this.bolt_web_content_props.AdaptBoltContents;
            this.panel_flange_bolt_basic_property.BoltStandardChanged += this.bolt_flange_content_props.AdaptBoltContents;
        }

        public override void ClearUI(Control root = null)
        {
            // 刷新螺栓基础面板
            this.panel_web_bolt_basic_property.RefreshControls();
            this.panel_flange_bolt_basic_property.RefreshControls();
            base.ClearUI(root);
        }
        protected override void UpdatePlaceholders(DObject compProps, DObject defaultValues)
        {
            // 螺栓垫片设置
            defaultValues = ParamsHandlerBase.SelectDefaultsByEmpty(compProps, defaultValues, ParamsHandler.EmptyValues);
            this.SetPlaceholders(defaultValues);
        }

        private void tb_floor_plate_place_SelectedIndexChanged(object sender, EventArgs e)
        {
            int select = tb_floor_plate_place.SelectedIntKey;
            if (select == 0 || select == 1)
            {
                //设置控件不能输入，使用 Enable、ReadOnly、onfocus、onkeydown
                this.tb_floor_plate_main_center_margin.Enabled = false;
                this.act_floor_plate_main_center_margin.Enabled = false;
                this.tb_floor_plate_main_side_offset.Enabled = false;
                this.act_floor_plate_main_side_offset.Enabled = false;
                this.tb_floor_plate_sub_center_margin.Enabled = false;
                this.act_floor_plate_sub_center_margin.Enabled = false;
                this.tb_floor_plate_sub_side_offset.Enabled = false;
                this.act_floor_plate_sub_side_offset.Enabled = false;
            }
            else
            {
                this.tb_floor_plate_main_center_margin.Enabled = true;
                this.act_floor_plate_main_center_margin.Enabled = true;
                this.tb_floor_plate_main_side_offset.Enabled = true;
                this.act_floor_plate_main_side_offset.Enabled = true;
                this.tb_floor_plate_sub_center_margin.Enabled = true;
                this.act_floor_plate_sub_center_margin.Enabled = true;
                this.tb_floor_plate_sub_side_offset.Enabled = true;
                this.act_floor_plate_sub_side_offset.Enabled = true;
            }

        }

        private void tb_lifting_hole_place_place_SelectedIndexChanged(object sender, EventArgs e)
        {
            int select = tb_lifting_hole_place.SelectedIntKey;
            if (select == 0 || select == 1)
            {
                this.act_lifting_hole_radius.Enabled = false;
                this.tb_lifting_hole_radius.Enabled = false;
                this.act_lifting_hole_vert_margin.Enabled = false;
                this.tb_lifting_hole_vert_margin.Enabled = false;
                this.act_lifting_hole_hori_margin.Enabled = false;
                this.tb_lifting_hole_hori_margin.Enabled = false;
            }
            else
            {
                this.act_lifting_hole_radius.Enabled = true;
                this.tb_lifting_hole_radius.Enabled = true;
                this.act_lifting_hole_vert_margin.Enabled = true;
                this.tb_lifting_hole_vert_margin.Enabled = true;
                this.act_lifting_hole_hori_margin.Enabled = true;
                this.tb_lifting_hole_hori_margin.Enabled = true;
            }

        }

        private void btn_weld_props_Click(object sender, EventArgs e)
        {
            if (m_weldForm == null)
            {
                m_weldForm = new Form_WeldParameter();
                m_weldForm.Owner = this.Owner;
                m_weldForm.ApplyHandler += this.ApplyWeldProps;
                m_weldForm.ModifyHandler += this.ModifyWeldProps;
                m_weldForm.GetHandler += this.GetWeldProps;
            }

            m_weldForm.Show(m_rootUIProps, null);
        }

        /// <summary>
        /// 应用焊缝属性的回调函数
        /// </summary>
        /// <returns></returns>
        /// <remarks><b>包含焊缝子窗口的组件需要复制此方法</b></remarks>
        protected void ApplyWeldProps(DObject srcProps)
        {
            m_rootUIProps.CopyFrom(srcProps);
        }

        /// <summary>
        /// 修改焊缝属性的回调函数
        /// </summary>
        /// <returns></returns>
        /// <remarks><b>包含焊缝子窗口的组件需要复制此方法</b></remarks>
        protected void ModifyWeldProps(DObject srcProps)
        {
            this.ModifyFocusedProps(srcProps);
        }

        /// <summary>
        /// 获取焊缝属性的回调函数
        /// </summary>
        /// <returns></returns>
        /// <remarks><b>包含焊缝子窗口的组件需要复制此方法</b></remarks>
        protected DObject GetWeldProps()
        {
            var refPlugin = this.ReferencePlugin;
            if (refPlugin == null)
                return m_rootUIProps;
            var curScene = LoongCAD.STC.STC.Document.FocusedScene;
            if (curScene == null)
                return m_rootUIProps;
            System.Guid pluginGuid = refPlugin.Guid;
            LoongCAD.STC.Object3D.ObjectBase[] curObjs = curScene.GetSelectedObjects(
                obj => obj is LoongCAD.STC.Object3D.ComponentBase &&
                ((LoongCAD.STC.Object3D.ComponentBase)obj).CompGuid == pluginGuid);
            if (curObjs == null || curObjs.Length == 0)
                return m_rootUIProps;
            LoongCAD.STC.Object3D.ComponentBase comp = curObjs[0] as LoongCAD.STC.Object3D.ComponentBase;
            if (comp == null)
                return m_rootUIProps;

            return comp.UIProps;
        }
        
        /// <summary>
        /// 设置当前窗口的属性值
        /// </summary>
        /// <param name="paras"></param>
        /// <param name="root"></param>
        /// <remarks>其他组件若同样包含类似焊缝属性窗的子窗口，则需要复制此方法</remarks>
        public override void SetParameters(DObject paras, Control root = null)
        {
            base.SetParameters(paras, root);
            if (root == null)
            {
                m_rootUIProps.Clear();
                m_rootUIProps.CopyFrom(paras);
            }
        }

        /// <summary>
        /// 获取当前窗口的属性值
        /// </summary>
        /// <param name="root"></param>
        /// <param name="exclude"></param>
        /// <param name="bConsiderCheck"></param>
        /// <remarks>其他组件若同样包含类似焊缝属性窗的子窗口，则需要复制此方法</remarks>
        /// <returns></returns>
        public override DObject GetParameters(Control root = null, List<Control> exclude = null, bool bConsiderCheck = true)
        {
            DObject retProps = new DObject();
            if (!bConsiderCheck || this.act_weld_props.Checked)
            {
                retProps.CopyFrom(m_rootUIProps);
            }
            DObject baseProps = base.GetParameters(root, exclude, true);
            retProps.CopyFrom(baseProps);
            return retProps;
        }


    }
}