﻿using System;
using System.Collections.Generic;
using System.Linq;
using LoongCAD.Geometry;
using LoongCAD.STC.Object3D;
using LoongCAD.STC;

namespace StiffenedShearPlate17
{
    public class PlateTools
    {
        /// <summary>
        /// 得到平行面的间距
        /// </summary>
        public static double GetPlaneDist(Plane plane1, Plane plane2)
        {
            if (plane1 == null || plane2 == null)
                return 0.0;
            return plane1.Dist(plane2.Origin);
        }
        //设置板折角
        public static void SetChamfer(int type, double lenX, double lenY, PartBase retPlate,params ChamferCtrlPoint[] points)
        {
            if (retPlate == null)
                return;
            Define.CornerCutType chamferType;
            switch (type)
            {
                case 1:
                    chamferType = Define.CornerCutType.CORNER_CUT_NONE;
                    break;
                case 3:
                    chamferType = Define.CornerCutType.CORNER_CUT_ROUND;
                    break;
                case 4:
                    chamferType = Define.CornerCutType.CORNER_CUT_INV_ROUND;
                    break;
                case 0:
                default:
                    chamferType = Define.CornerCutType.CORNER_CUT_LINE;
                    break;
            }
            for (int i = 0; i < points.Length; i++)
            {
                if (points[i] != null)
                {
                    points[i].CutX = lenX;
                    points[i].CutY = lenY;
                    points[i].CutType = chamferType;
                    points[i].Flush();
                    retPlate.Flush();
                }
            }
        }
        /// <summary>
        /// 设置板折角
        /// </summary>
        public static void SetChamfer(ChamferCtrlPoint point, int type, double lenX, double lenY, PartBase retPlate)
        {
            if (retPlate == null)
                return;
            Define.CornerCutType chamferType;
            switch (type)
            {
                case 1:
                    chamferType = Define.CornerCutType.CORNER_CUT_NONE;
                    break;
                case 3:
                    chamferType = Define.CornerCutType.CORNER_CUT_ROUND;
                    break;
                case 4:
                    chamferType = Define.CornerCutType.CORNER_CUT_INV_ROUND;
                    break;
                case 0:
                default:
                    chamferType = Define.CornerCutType.CORNER_CUT_LINE;
                    break;
            }
            if (point != null)
            {
                point.CutX = lenX;
                point.CutY = lenY;
                point.CutType = chamferType;
                point.Flush();
                retPlate.Flush();
            }
        }
        public static double SumArray(double[] arr)
        {
            if (arr == null || arr.Length == 0)
                return 0.0;
            double sum = 0.0;
            foreach (var item in arr)
                sum += item;
            return sum;
        }
    }
}
