﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace StubConnection119
{

    public class ParamNames
    {

        //图形页
        public static readonly string COLUMN_ENDPLATE_DISTANCE = "column_endplate_distance";
        public static readonly string ENDPLATE_DISTANCE = "endplate_distance";
        public static readonly string RIGHT_STIFFENER_MARGIN_FRONT = "right_stiffener_margin_front";  //柱靠近梁的那一侧的加劲肋上边距（距离内翼缘）
        public static readonly string RIGHT_STIFFENER_MARGIN_BACK = "right_stiffener_margin_back";
        public static readonly string RIGHT_STIFFENER_MARGIN_TOP = "right_stiffener_margin_top";
        public static readonly string RIGHT_STIFFENER_MARGIN_BOTTOM = "right_stiffener_margin_bottom";
        public static readonly string RIGHT_STIFFENER_GAP = "right_stiffener_gap";
        public static readonly string ENDPLATE_MARGIN_TOP = "endplate_margin_top";
        public static readonly string ENDPLATE_MARGIN_BOTTOM = "endplate_margin_bottom";
        public static readonly string SUB_HAUNCH_SHAPE = "sub_haunch_shape";//次加劲板(腋板)
        public static readonly string SUB_HAUNCH_INSIDE_CHAMFER_CUTX = "sub_haunch_inside_chamfer_cutx";
        public static readonly string SUB_HAUNCH_INSIDE_CHAMFER_CUTY = "sub_haunch_inside_chamfer_cuty";
        public static readonly string SUB_HAUNCH_OUTSIDE_CHAMFER_CUTX = "sub_haunch_outside_chamfer_cutx";
        public static readonly string SUB_HAUNCH_OUTSIDE_CHAMFER_CUTY = "sub_haunch_outside_chamfer_cuty";
        public static readonly string MAIN_HAUNCH_SHAPE = "main_haunch_shape";//主加劲板(腋板)
        public static readonly string MAIN_HAUNCH_INSIDE_CHAMFER_CUTX = "main_haunch_inside_chamfer_cutx";
        public static readonly string MAIN_HAUNCH_INSIDE_CHAMFER_CUTY = "main_haunch_inside_chamfer_cuty";
        public static readonly string MAIN_HAUNCH_OUTSIDE_CHAMFER_CUTX = "main_haunch_outside_chamfer_cutx";
        public static readonly string MAIN_HAUNCH_OUTSIDE_CHAMFER_CUTY = "main_haunch_outside_chamfer_cuty";
        public static readonly string WEB_STIFF_MARGIN_TOP = "web_stiff_margin_top";//腹板加劲板（次）
        public static readonly string WEB_STIFF_COUNT = "web_stiff_count";
        public static readonly string WEB_STIFF_STRIDE = "web_stiff_stride";
        public static readonly string MAIN_WEB_STIFF_MARGIN_TOP = "main_web_stiff_margin_top";//腹板加劲板（主）
        public static readonly string MAIN_WEB_STIFF_COUNT = "main_web_stiff_count";
        public static readonly string MAIN_WEB_STIFF_STRIDE = "main_web_stiff_stride";



        //零件
        public static readonly string END_PLATE1_PROPS = "end_plate1_props";
        public static readonly string END_PLATE2_PROPS = "end_plate2_props";
        public static readonly string TOP_HAUNCH_PLATES_PROPS = "top_haunch_plates_props"; //上腋板属性
        public static readonly string BOTTOM_HAUNCH_PLATES_PROPS = "bottom_haunch_plates_props"; //下腋板属性
        public static readonly string RIGHT_TOP_STIFFENER_PROPS = "right_top_stiffener_props"; //右侧加劲肋（已改名为上、下翼板和腹板）
        public static readonly string RIGHT_MIDDLE_STIFFENER_PROPS = "right_middle_stiffener_props";
        public static readonly string RIGHT_BOTTOM_STIFFENER_PROPS = "right_bottom_stiffener_props";
        public static readonly string LEFT_TOP_STIFFENER_PROPS = "left_top_stiffener_props"; //左侧加劲肋（已改名为柱加劲板）
        public static readonly string LEFT_MIDDLE_STIFFENER_PROPS = "left_middle_stiffener_props";
        public static readonly string LEFT_BOTTOM_STIFFENER_PROPS = "left_bottom_stiffener_props";
        public static readonly string WEB_STIFF_PROPS = "web_stiff_props";//腹板加劲板


        //参数页
        //public static readonly string LEFT_STIFFENER_MARGIN_FRONT = "left_stiffener_margin_front";  
        //public static readonly string LEFT_STIFFENER_MARGIN_BACK = "left_stiffener_margin_back";
        public static readonly string LEFT_STIFFENER_VERT_MARGIN_SIDE = "left_stiffener_vert_margin_side";
        public static readonly string LEFT_STIFFENER_HORI_MARGIN_CENTER = "left_stiffener_hori_margin_center";
        public static readonly string LEFT_STIFFENER_HORI_MARGIN_SIDE = "left_stiffener_hori_margin_side";
        public static readonly string MIDDLE_STIFFENER_CHAMFER_MODE = "middle_stiffener_chamfer_mode"; //中间板（与翼缘平行的加劲肋）折角类型
        public static readonly string MIDDLE_STIFFENER_CHAMFER_CUTX = "middle_stiffener_chamfer_cutx";
        public static readonly string MIDDLE_STIFFENER_CHAMFER_CUTY = "middle_stiffener_chamfer_cuty";
        public static readonly string SIDE_STIFFENER_CHAMFER_MODE = "side_stiffener_chamfer_mode"; //顶底板（与翼缘垂直的两个加劲肋）
        public static readonly string SIDE_STIFFENER_CHAMFER_CUTX = "side_stiffener_chamfer_cutx";
        public static readonly string SIDE_STIFFENER_CHAMFER_CUTY = "side_stiffener_chamfer_cuty";
        public static readonly string SIDE_STIFFENER_MARGIN_TOP = "side_stiffener_margin_top"; 
        public static readonly string SIDE_STIFFENER_MARGIN_BOTTOM = "side_stiffener_margin_bottom";
        public static readonly string LEFT_STIFFENER_OPEN_MODE = "left_stiffener_open_mode";

        //腹板折角页
        public static readonly string MAIN_TOP_CHAMFER_MODE = "main_top_chamfer_mode";//
        public static readonly string MAIN_TOP_CHAMFER_CUTX = "main_top_chamfer_cutx";
        public static readonly string MAIN_TOP_CHAMFER_CUTY = "main_top_chamfer_cuty";
        public static readonly string SUB_TOP_CHAMFER_MODE = "sub_top_chamfer_mode";//
        public static readonly string SUB_TOP_CHAMFER_CUTX = "sub_top_chamfer_cutx";
        public static readonly string SUB_TOP_CHAMFER_CUTY = "sub_top_chamfer_cuty";
        public static readonly string MAIN_BOTTOM_CHAMFER_MODE = "main_bottom_chamfer_mode";//
        public static readonly string MAIN_BOTTOM_CHAMFER_CUTX = "main_bottom_chamfer_cutx";
        public static readonly string MAIN_BOTTOM_CHAMFER_CUTY = "main_bottom_chamfer_cuty";
        public static readonly string SUB_BOTTOM_CHAMFER_MODE = "sub_bottom_chamfer_mode";//
        public static readonly string SUB_BOTTOM_CHAMFER_CUTX = "sub_bottom_chamfer_cutx";
        public static readonly string SUB_BOTTOM_CHAMFER_CUTY = "sub_bottom_chamfer_cuty";


        //螺栓页
        public static readonly string BOLT_BASIC_PROPS = "bolt_basic_standard_props";
        public static readonly string BOLT_HOLE_PROPS = "bolt_hole_props";
        public static readonly string BOLT_CONTENT_PROPS = "bolt_content_props";
        public static readonly string BOLT_EXTEND_PROPS = "bolt_extend_props";
        public static readonly string BOLT_SHAPE = "bolt_shape";
        public static readonly string BOLT_HORI_OFFSET = "bolt_hori_offset"; //水平偏移
        public static readonly string BOLT_HORI_COUNT = "bolt_hori_count"; //水平方向螺栓参数
        public static readonly string BOLT_HORI_STRIDE = "bolt_hori_stride";
        public static readonly string BOLT_LEFT_MARGIN = "bolt_left_margin";
        public static readonly string BOLT_RIGHT_MARGIN = "bolt_right_margin"; 
        public static readonly string BOLT_VERT_OFFSET = "bolt_vert_offset"; //垂直偏移
        public static readonly string BOLT_VERT_COUNT = "bolt_vert_count"; //垂直方向螺栓参数
        public static readonly string BOLT_VERT_STRIDE = "bolt_vert_stride";
        public static readonly string BOLT_TOP_MARGIN = "bolt_top_margin";
        public static readonly string BOLT_BOTTOM_MARGIN = "bolt_bottom_margin";
        public static readonly string IGNORE_BOLT_INDEX = "ignore_bolt_index"; //要删除的螺栓索引


        //焊缝属性名称
        public static readonly string[] WELD_PROPS_LIST = new string[]
        {
            "weld_props1",
            "weld_props2",
            "weld_props3",
            "weld_props4",
            "weld_props5",
            "weld_props6",
            "weld_props7",
            "weld_props8",
            "weld_props9",
            "weld_props10"
        };
    }
}
