﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using LoongCAD.Geometry;
using LoongCAD.STC;
using LoongCAD.STC.Plugins;

namespace StubConnection119
{
    public class CutHandler
    {
        private ComponentInstanceContext m_context = null;
        private ParamsHandler m_paramsHandler = null;

        public CutHandler(ComponentInstanceContext context, ParamsHandler paramsHandler)
        {
            m_context = context;
            m_paramsHandler = paramsHandler;
        }

        public void Execute()
        {
            double dist = m_paramsHandler.GetDoubleValue(ParamNames.COLUMN_ENDPLATE_DISTANCE);
            //dist += (double)m_paramsHandler.GetDObjectValue(ParamNames.END_PLATE1_PROPS).Get("thickness");
            dist += (double)m_paramsHandler.GetDObjectValue(ParamNames.END_PLATE2_PROPS).Get("thickness");
            dist += m_paramsHandler.GetDoubleValue(ParamNames.ENDPLATE_DISTANCE);
            Vec3 topPoint = m_context.MainTopBound.Intersect(m_context.MainWebCenterPlane, m_context.SubHoriCenterPlane); //主零件上边缘上一点
            Vec3 bottomPoint = m_context.MainBottomBound.Intersect(m_context.MainWebCenterPlane, m_context.SubHoriCenterPlane); //主零件下边缘上一点
            Plane alignPlane;
            if(m_context.SubNearCenterPlane.Normal.IsVerticalTo(m_context.MainTopBound.Normal)) 
            {
                alignPlane = m_context.MainWebCenterPlane.Clone(); //柱、梁在同一个平面上
            }
            else
            {
                if (m_context.SubNearCenterPlane.Dist(topPoint) <= m_context.SubNearCenterPlane.Dist(bottomPoint))
                    alignPlane = new Plane(topPoint, -m_context.SubNearCenterPlane.Normal); //上侧边缘点更近
                else
                    alignPlane = new Plane(bottomPoint, -m_context.SubNearCenterPlane.Normal);
            }
            alignPlane.MoveThis(dist);
            m_context.Comp.CreateAlignPlane(m_context.SubPart, alignPlane, true);
            m_context.SubNearCenterPlane = alignPlane.Invert();
            m_context.SubEndPlateCtrlPlane = alignPlane.Invert();
        }
    }
}
