﻿namespace TubeGusset_20_.Main
{
    public static class ParamNames
    {
        //标签页相关
        
        #region 图形标签页
        /// <summary>
        /// 节点板到主零件的间隙距离
        /// </summary>
        public static readonly string PIC_GAP_BETWEEN_GUSSET_PLATE_AND_MAIN_PART = "pic_gap_between_gusset_plate_and_main_part";
        /// <summary>
        /// 主零件到支撑的距离
        /// </summary>
        public static readonly string PIC_DISTANCE_BETWEEN_MAIN_PART_AND_BRACE = "pic_distance_between_main_part_and_brace";
        /// <summary>
        /// 支撑之间的最小距离
        /// </summary>
        public static readonly string PIC_MIN_DISTANCE_BETWEEN_THE_BRACES = "pic_min_distance_between_the_braces";
        /// <summary>
        /// 节点板拐角角度，顶部拐角(UI中为上方输入框)
        /// </summary>
        public static readonly string PIC_THE_GUSSET_PLATE_CORNER_ANGLE_TOP = "pic_the_gusset_plate_corner_angle_top";
        /// <summary>
        /// 节点板拐角角度，顶部拐角(UI中为下方输入框)
        /// </summary>
        public static readonly string PIC_THE_GUSSET_PLATE_CORNER_ANGLE_BOTTOM= "pic_the_gusset_plate_corner_angle_bottom";
        /// <summary>
        /// 节点板拐角边缘长度，顶部支撑外侧
        /// </summary>
        public static readonly string PIC_LENGTH_EDGE_OF_THE_GUSSET_PLATE_TOP_OUTSIDE = "pic_length_edge_of_the_gusset_plate_top_outside";
        /// <summary>
        /// 节点板拐角边缘长度，顶部支撑内侧
        /// </summary>
        public static readonly string PIC_LENGTH_EDGE_OF_THE_GUSSET_PLATE_TOP_INSIDE = "pic_length_edge_of_the_gusset_plate_top_inside";
        /// <summary>
        /// 节点板拐角边缘长度，底部支撑外侧
        /// </summary>
        public static readonly string PIC_LENGTH_EDGE_OF_THE_GUSSET_PLATE_BOTTOM_OUTSIDE = "pic_length_edge_of_the_gusset_plate_bottom_outside";
        /// <summary>
        /// 节点板拐角边缘长度，底部支撑内侧
        /// </summary>
        public static readonly string PIC_LENGTH_EDGE_OF_THE_GUSSET_PLATE_BOTTOM_INSIDE = "pic_length_edge_of_the_gusset_plate_bottom_inside";
        /// <summary>
        /// 连接部分到节点板顶部的距离
        /// </summary>
        public static readonly string PIC_TOP_DISTANCE_BETWEEN_CONNECTION_PART_AND_GUSSET_PLATE_EDGE = "pic_top_distance_between_connection_part_and_gusset_plate_edge";
        /// <summary>
        /// 支撑在连接部分上的长度(TK中可输入负值，暂不考虑)
        /// </summary>
        public static readonly string PIC_BRACE_LENGTH_ON_THE_CONNECTION_PART= "pic_brace_length_on_the_connection_part";
        /// <summary>
        /// 支撑部分与节点板边缘的距离（有封板时，封板算作支撑部分）
        /// </summary>
        public static readonly string PIC_DISTANCE_BETWEEN_THE_GUSSET_PLATE_AND_BRACE_PART = "pic_distance_between_the_gusset_plate_and_brace_part";
        /// <summary>
        /// 定义节点板是否穿过主零件，指定间距值的含义
        /// </summary>
        public static readonly string PIC_SELECT_GUSSET_PLATE_DIMENSIONS= "pic_select_gusset_plate_dimensions";
        /// <summary>
        /// 节点板的切割长度
        /// </summary>
        public static readonly string PIC_GUSSET_PLATE_CUT_DIMENSIONS = "pic_gusset_plate_cut_dimensions";
        #endregion
        #region 支柱标签页
        /// <summary>
        /// 支柱端连接板的板属性
        /// </summary>
        public static readonly string BRACE_CONN_CONNECTION_PLATE = "brace_conn_connection_plate";
        /// <summary>
        /// 端板的板属性
        /// </summary>
        public static readonly string BRACE_CONN_END_PLATE = "brace_conn_end_plate";
        /// <summary>
        /// 中间端板，在两个连接板的情况下生成
        /// </summary>
        public static readonly string BRACE_CONN_MIDDLE_END_PLATE = "brace_conn_middle_end_plate";
        /// <summary>
        /// 舌柱，在支撑节点类型4下创建
        /// </summary>
        public static readonly string BRACE_CONN_TONGUE_PLATE = "brace_conn_tongue_plate";
        /// <summary>
        /// 盖板，在支撑节点类型4下创建
        /// </summary>
        public static readonly string BRACE_CONN_COVER_PLATE = "brace_conn_cover_plate";
        /// <summary>
        /// 支撑连接部分的类型
        /// </summary>
        public static readonly string BRACE_CONN_SELECT_CONNECTION_PART_TYPES = "brace_conn_select_connection_part_types";
        /// <summary>
        /// 定义支撑中切割的宽度，其中t表示连接板的厚度
        /// 会受到连接板数目的影响,和类型影响
        /// </summary>
        public static readonly string BRACE_CONN_CUT_IN_BRACING_WIDTH = "brace_conn_cut_in_bracing_width";
        /// <summary>
        /// 定义支撑中从连接板边缘切割的长度
        /// </summary>
        public static readonly string BRACE_CONN_CUT_IN_BRACING_LENGTH = "brace_conn_cut_in_bracing_length";
        /// <summary>
        /// 定义节点板和连接板（在类型4下为盖板）之间的距离。
        /// 连接部分到节点板的间隙距离
        /// </summary>
        public static readonly string BRACE_CONN_GUSSET_AND_CONNECTION_PLATE_DISTANCE = "brace_conn_gusset_and_connection_plate_distance";
        /// <summary>
        /// 定义连接板连接到支撑时，支撑是否被切割，连接板是否被开槽。
        /// 其中连接板在类型4下为舌柱
        /// </summary>
        public static readonly string BRACE_CONN_SELECT_BRACE_IS_NOTCHED_CUT = "brace_conn_select_brace_is_notched_cut";
        /// <summary>
        /// 如果对连接板开槽，不切割支撑，定义连接板开槽部分与支撑的间隙尺寸
        /// 两端相同
        /// </summary>
        public static readonly string BRACE_CONN_SIZE_GAP_BETWEEN_BRACE_AND_CONNECTION_PLATE = "brace_conn_size_gap_between_brace_and_connection_plate";
        /// <summary>
        /// 选择连接板的数目(在类型4下为盖板cover_plate的数目)
        /// </summary>
        public static readonly string BRACE_CONN_SELECT_NUMBER_OF_CONNECTION_PLATE = "brace_conn_select_number_of_connection_plate";
        /// <summary>
        /// 中间端板的宽度值
        /// </summary>
        public static readonly string BRACE_CONN_WIDTH_OF_MIDDLE_END_PLATE= "brace_conn_width_of_middle_end_plate";
        /// <summary>
        /// 定义是否创建斜切连接板，是否给连接板创建折角
        /// </summary>
        public static readonly string BRACE_CONN_SELECT_CONNECTION_PLATE_CHAMFER = "brace_conn_select_connection_plate_chamfer";
        /// <summary>
        /// 折角的垂直尺寸
        /// </summary>
        public static readonly string BRACE_CONN_CHAMFER_VERTICAL_DIMENSION = "brace_conn_chamfer_vertical_dimension";
        /// <summary>
        /// 折角的水平尺寸
        /// </summary>
        public static readonly string BRACE_CONN_CHAMFER_HORIZONTAL_DIMENSION = "brace_conn_chamfer_horizontal_dimension";
        /// <summary>
        /// 选择端板的形状
        /// </summary>
        public static readonly string BRACE_CONN_SELECT_END_PLATE_TYPE = "brace_conn_select_end_plate_type";
        /// <summary>
        /// 圆型端板的边缘到支撑外边缘的距离
        /// </summary>
        public static readonly string BRACE_CONN_CIRCULAR_END_PLATE_EDGE_DISTANCE_FROM_BRACE_OUTER_EDGE = 
            "brace_conn_circular_end_plate_edge_distance_from_brace_outer_edge";
        /// <summary>
        /// 方形端板的左侧边缘到支撑外边缘的距离
        /// </summary>
        public static readonly string BRACE_CONN_SQUARE_END_PLATE_LEFT_EDGE_DISTANCE_FROM_BRACE_OUTER_EDGE = 
            "brace_conn_square_end_plate_left_edge_distance_from_brace_outer_edge";
        /// <summary>
        /// 方形端板的右侧边缘到支撑外边缘的距离
        /// </summary>
        public static readonly string BRACE_CONN_SQUARE_END_PLATE_RIGHT_EDGE_DISTANCE_FROM_BRACE_OUTER_EDGE = 
            "brace_conn_square_end_plate_right_edge_distance_from_brace_outer_edge";
        /// <summary>
        /// 方形端板的顶侧边缘到支撑外边缘的距离
        /// </summary>
        public static readonly string BRACE_CONN_SQUARE_END_PLATE_TOP_EDGE_DISTANCE_FROM_BRACE_OUTER_EDGE = 
            "brace_conn_square_end_plate_top_edge_distance_from_brace_outer_edge";
        /// <summary>
        /// 端板的折角类型，仅对方形端板生效
        /// </summary>
        public static readonly string BRACE_CONN_SELECT_END_PLATE_CHAMFER_TYPE = "brace_conn_select_end_plate_chamfer_type";
        /// <summary>
        /// 端板折角的水平距离
        /// </summary>
        public static readonly string BRACE_CONN_END_PLATE_CHAMFER_HORIZONTAL_DIST = "brace_conn_end_plate_chamfer_horizontal_dist";
        /// <summary>
        /// 端板折角的垂直距离
        /// </summary>
        public static readonly string BRACE_CONN_END_PLATE_CHAMFER_VERTICAL_DIST = "brace_conn_end_plate_chamfer_vertical_dist";
        
        #endregion
        #region 节点板标签页
        /// <summary>
        /// 节点板的配置信息
        /// </summary>
        public static readonly string GUSSET_GUSSET_PLATE = "gusset_gusset_plate";
        /// <summary>
        /// 连接板的配置信息
        /// </summary>
        public static readonly string GUSSET_CONNECTION_PLATE= "gusset_connection_plate";
        /// <summary>
        /// L型截面的配置信息
        /// </summary>
        public static readonly string GUSSET_L_PROFILE_PLATE = "gusset_l_profile_plate";
        /// <summary>
        /// 节点板在组件Y轴方向的偏移
        /// </summary>
        public static readonly string GUSSET_GUSSET_PLATE_Y_DIRECTION_OFFSET = "gusset_gusset_plate_y_direction_offset";
        /// <summary>
        /// 节点板在组件Z轴方向的偏移
        /// </summary>
        public static readonly string GUSSET_GUSSET_PLATE_Z_DIRECTION_OFFSET = "gusset_gusset_plate_z_direction_offset";
        /// <summary>
        /// 节点板的形状选项
        /// </summary>
        public static readonly string GUSSET_GUSSET_PLATE_SHAPE_SELECT = "gusset_gusset_plate_shape_select";
        /// <summary>
        /// 节点板在支撑上的位置
        /// </summary>
        public static readonly string GUSSET_GUSSET_PLATE_POSITION_ON_BRACE_SELECT = "gusset_gusset_plate_position_on_brace_select";
        /// <summary>
        /// 选择创建连接板还是L截面板
        /// </summary>
        public static readonly string GUSSET_SELECT_CONNECTION_OR_CLIP_ANGLES = "gusset_select_connection_or_clip_angles";
        /// <summary>
        /// 选择L截面的对齐方向
        /// </summary>
        public static readonly string GUSSET_SELECT_CLIP_ANGLE_ORIENTATION = "gusset_select_clip_angle_orientation";
        /// <summary>
        /// 节点板的顶部边缘化延长距离
        /// </summary>
        public static readonly string GUSSET_MAIN_PART_EDGE_EXTENSION_DISTANCE = "gusset_main_part_edge_extension_distance";
        /// <summary>
        /// 节点板的底部边缘延长距离
        /// </summary>
        public static readonly string GUSSET_TOP_BOTTOM_EDGE_EXTENSION_DISTANCE = "gusset_top_bottom_edge_extension_distance";
        /// <summary>
        /// 横向切割尺寸
        /// </summary>
        public static readonly string GUSSET_HORIZONTAL_SIZE_OF_CUT= "gusset_horizontal_size_of_cut";
        /// <summary>
        /// 纵向切割尺寸
        /// </summary>
        public static readonly string GUSSET_VERTICAL_SIZE_OF_CUT= "gusset_vertical_size_of_cut";
        
        #endregion
        #region 节点板螺栓标签页
        /// <summary>
        /// 节点板螺栓的基本属性
        /// </summary>
        public static readonly string GUSSET_BOLTS_BOLT_BASIC_PROPERTIES = "gusset_bolts_bolt_basic_properties";
        /// <summary>
        /// 节点板螺栓的槽孔属性
        /// </summary>
        public static readonly string GUSSET_BOLTS_SLOTTED_HOLES = "gusset_bolts_slotted_holes";
        /// <summary>
        /// 节点板螺栓的螺栓装配
        /// </summary>
        public static readonly string GUSSET_BOLTS_BOLT_ASSEMBLY = "gusset_bolts_bolt_assembly";
        /// <summary>
        /// 节点板螺栓的长度增加
        /// </summary>
        public static readonly string GUSSET_BOLTS_BOLT_LENGTH_INCREASE = "gusset_bolts_bolt_length_increase";
        /// <summary>
        /// 节点板螺栓的交错
        /// </summary>
        public static readonly string GUSSET_BOLTS_STAGGERING_OF_BOLTS = "gusset_bolts_staggering_of_bolts";
        #region 水平方向相关 组件方向的x方向
        public static readonly string GUSSET_BOLTS_HORIZONTAL_BOLTS_NUMBER = "gusset_bolts_horizontal_bolts_number";
        public static readonly string GUSSET_BOLTS_HORIZONTAL_BOLTS_SPACING = "gusset_bolts_horizontal_bolts_spacing";
        public static readonly string GUSSET_BOLTS_HORIZONTAL_BOLTS_TOP_EDGE_DIST= "gusset_bolts_horizontal_bolts_top_edge_dist";
        public static readonly string GUSSET_BOLTS_HORIZONTAL_BOLTS_BOTTOM_EDGE_DIST= "gusset_bolts_horizontal_bolts_bottom_edge_dist";
        #endregion
        #region 垂直方向相关 组件方向的y方向
        public static readonly string GUSSET_BOLTS_VERTICAL_BOLTS_NUMBER = "gusset_bolts_vertical_bolts_number";
        public static readonly string GUSSET_BOLTS_VERTICAL_BOLTS_SPACING = "gusset_bolts_vertical_bolts_spacing";
        public static readonly string GUSSET_BOLTS_VERTICAL_BOLTS_NEAR_EDGE_DIST= "gusset_bolts_vertical_bolts_near_edge_dist";
        #endregion
        #region 特殊延长板的螺栓配置
        public static readonly string GUSSET_BOLTS_EXTENDED_VERTICAL_BOLTS_TOP_EDGE_DIST = "gusset_bolts_extended_vertical_bolts_top_edge_dist";
        public static readonly string GUSSET_BOLTS_EXTENDED_VERTICAL_BOLTS_NUMBER = "gusset_bolts_extended_vertical_bolts_number";
        public static readonly string GUSSET_BOLTS_EXTENDED_VERTICAL_BOLTS_SPACING= "gusset_bolts_extended_vertical_bolts_spacing";
        public static readonly string GUSSET_BOLTS_EXTENDED_HORIZONTAL_BOLTS_FAR_EDGE_DIST = "gusset_bolts_extended_horizontal_bolts_far_edge_dist";
        public static readonly string GUSSET_BOLTS_EXTENDED_HORIZONTAL_BOLTS_NUMBER = "gusset_bolts_extended_horizontal_bolts_number";
        public static readonly string GUSSET_BOLTS_EXTENDED_HORIZONTAL_BOLTS_SPACING= "gusset_bolts_extended_horizontal_bolts_spacing";
        #endregion
        #region 螺栓的其余配置
        /// <summary>
        /// 节点板和连接零件的螺栓制作配置
        /// </summary>
        public static readonly string GUSSET_BOLTS_SELECT_LINKED_PART_BOLTS_MADE_TYPE = "gusset_bolts_select_linked_part_bolts_made_type";
        /// <summary>
        /// 主零件和连接零件的螺栓制作配置。
        /// </summary>
        public static readonly string GUSSET_BOLTS_SELECT_MAIN_PART_BOLTS_MADE_TYPE = "gusset_bolts_select_main_part_bolts_made_type";
        /// <summary>
        /// 主零件和连接零件的螺栓对中心的偏移距离 
        /// </summary>
        public static readonly string GUSSET_BOLTS_MAIN_PART_BOLTS_CENTER_EDGE_DIST = "gusset_bolts_main_part_bolts_center_edge_dist";
        public static readonly string GUSSET_BOLTS_MAIN_PART_BOLTS_NUMBER = "gusset_bolts_main_part_bolts_number";
        public static readonly string GUSSET_BOLTS_MAIN_PART_BOLTS_SPACING= "gusset_bolts_main_part_bolts_spacing";
        #endregion
        /// <summary>
        /// 选择不适用L截面时，是否使用螺栓将节点板连接到主零件
        /// </summary>
        public static readonly string GUSSET_BOLTS_SELECT_BOLTS_ON_GUSSET_PLATE = "gusset_bolts_select_bolts_on_gusset_plate";
        /// <summary>
        /// 角钢连接类型，同时会影响不使用角钢时的螺栓和焊接选择
        /// </summary>
        public static readonly string GUSSET_BOLTS_SELECT_CLIP_ANGLE_ATTACHMENT_TYPE = "gusset_bolts_select_clip_angle_attachment_type";
        #endregion
        #region 支柱螺栓1 标签页
        /// <summary>
        /// 支柱螺栓1的基本属性
        /// </summary>
        public static readonly string BRACE_BOLTS_1_BOLT_BASIC_PROPERTIES = "brace_bolts_1_bolt_basic_properties";
        /// <summary>
        /// 支柱螺栓1的槽孔属性
        /// </summary>
        public static readonly string BRACE_BOLTS_1_SLOTTED_HOLES = "brace_bolts_1_slotted_holes";
        /// <summary>
        /// 支柱螺栓1的螺栓装配
        /// </summary>
        public static readonly string BRACE_BOLTS_1_BOLT_ASSEMBLY = "brace_bolts_1_bolt_assembly";
        /// <summary>
        /// 支柱螺栓1的长度增加
        /// </summary>
        public static readonly string BRACE_BOLTS_1_BOLT_LENGTH_INCREASE = "brace_bolts_1_bolt_length_increase";
        /// <summary>
        /// 支柱螺栓1的交错
        /// </summary>
        public static readonly string BRACE_BOLTS_1_STAGGERING_OF_BOLTS = "brace_bolts_1_staggering_of_bolts";
        /// <summary>
        /// 支柱螺栓1的水平螺栓数目
        /// </summary>
        public static readonly string BRACE_BOLTS_1_HORIZONTAL_BOLTS_NUMBER = "brace_bolts_1_horizontal_bolts_number";
        /// <summary>
        /// 支柱螺栓1的水平螺栓间距
        /// </summary>
        public static readonly string BRACE_BOLTS_1_HORIZONTAL_BOLTS_SPACING = "brace_bolts_1_horizontal_bolts_spacing";
        /// <summary>
        /// 支柱螺栓1的垂直螺栓数目
        /// </summary>
        public static readonly string BRACE_BOLTS_1_VERTICAL_BOLTS_NUMBER = "brace_bolts_1_vertical_bolts_number";
        /// <summary>
        /// 支柱螺栓1的垂直螺栓间距
        /// </summary>
        public static readonly string BRACE_BOLTS_1_VERTICAL_BOLTS_SPACING = "brace_bolts_1_vertical_bolts_spacing";
        /// <summary>
        /// 支柱螺栓1的垂直螺栓的近端边距,靠近支柱对齐面为近端
        /// </summary>
        public static readonly string BRACE_BOLTS_1_VERTICAL_BOLTS_NEAR_EDGE_DIST = "brace_bolts_1_vertical_bolts_near_edge_dist";
        /// <summary>
        /// 支柱螺栓1的垂直螺栓的远端边距,远离支柱对齐面为远端
        /// </summary>
        public static readonly string BRACE_BOLTS_1_VERTICAL_BOLTS_FAR_EDGE_DIST = "brace_bolts_1_vertical_bolts_far_edge_dist";
        /// <summary>
        /// 支柱螺栓1的垂直螺栓组的测量方式
        /// </summary>
        public static readonly string BRACE_BOLTS_1_VERTICAL_BOLTS_SELECT_MEASURE_METHOD = "brace_bolts_1_vertical_bolts_select_measure_method";
        /// <summary>
        /// 支柱螺栓1的垂直螺栓组的在测量方式下的偏移
        /// </summary>
        public static readonly string BRACE_BOLTS_1_VERTICAL_BOLTS_MEASURE_OFFSET = "brace_bolts_1_vertical_bolts_measure_offset";
        /// <summary>
        /// 支柱螺栓1的支撑边缘和连接板边缘之间的距离。
        /// </summary>
        public static readonly string BRACE_BOLTS_1_DISTANCE_BETWEEN_BRACE_AND_CONNECTION_PLATE_EDGE = "brace_bolts_1_distance_between_brace_and_connection_plate_edge";
        #endregion
        #region 支柱螺栓2 标签页
        /// <summary>
        /// 支柱螺栓2的基本属性
        /// </summary>
        public static readonly string BRACE_BOLTS_2_BOLT_BASIC_PROPERTIES = "brace_bolts_2_bolt_basic_properties";
        /// <summary>
        /// 支柱螺栓2的槽孔属性
        /// </summary>
        public static readonly string BRACE_BOLTS_2_SLOTTED_HOLES = "brace_bolts_2_slotted_holes";
        /// <summary>
        /// 支柱螺栓2的螺栓装配
        /// </summary>
        public static readonly string BRACE_BOLTS_2_BOLT_ASSEMBLY = "brace_bolts_2_bolt_assembly";
        /// <summary>
        /// 支柱螺栓2的长度增加
        /// </summary>
        public static readonly string BRACE_BOLTS_2_BOLT_LENGTH_INCREASE = "brace_bolts_2_bolt_length_increase";
        /// <summary>
        /// 支柱螺栓2的交错
        /// </summary>
        public static readonly string BRACE_BOLTS_2_STAGGERING_OF_BOLTS = "brace_bolts_2_staggering_of_bolts";
        /// <summary>
        /// 支柱螺栓2的水平螺栓数目
        /// </summary>
        public static readonly string BRACE_BOLTS_2_HORIZONTAL_BOLTS_NUMBER = "brace_bolts_2_horizontal_bolts_number";
        /// <summary>
        /// 支柱螺栓2的水平螺栓间距
        /// </summary>
        public static readonly string BRACE_BOLTS_2_HORIZONTAL_BOLTS_SPACING = "brace_bolts_2_horizontal_bolts_spacing";
        /// <summary>
        /// 支柱螺栓2的垂直螺栓数目
        /// </summary>
        public static readonly string BRACE_BOLTS_2_VERTICAL_BOLTS_NUMBER = "brace_bolts_2_vertical_bolts_number";
        /// <summary>
        /// 支柱螺栓2的垂直螺栓间距
        /// </summary>
        public static readonly string BRACE_BOLTS_2_VERTICAL_BOLTS_SPACING = "brace_bolts_2_vertical_bolts_spacing";
        /// <summary>
        /// 支柱螺栓2的垂直螺栓的近端边距,靠近支柱对齐面为近端
        /// </summary>
        public static readonly string BRACE_BOLTS_2_VERTICAL_BOLTS_NEAR_EDGE_DIST = "brace_bolts_2_vertical_bolts_near_edge_dist";
        /// <summary>
        /// 支柱螺栓2的垂直螺栓的远端边距,远离支柱对齐面为远端
        /// </summary>
        public static readonly string BRACE_BOLTS_2_VERTICAL_BOLTS_FAR_EDGE_DIST = "brace_bolts_2_vertical_bolts_far_edge_dist";
        /// <summary>
        /// 支柱螺栓2的垂直螺栓组的测量方式
        /// </summary>
        public static readonly string BRACE_BOLTS_2_VERTICAL_BOLTS_SELECT_MEASURE_METHOD = "brace_bolts_2_vertical_bolts_select_measure_method";
        /// <summary>
        /// 支柱螺栓2的垂直螺栓组的在测量方式下的偏移
        /// </summary>
        public static readonly string BRACE_BOLTS_2_VERTICAL_BOLTS_MEASURE_OFFSET = "brace_bolts_2_vertical_bolts_measure_offset";
        /// <summary>
        /// 支柱螺栓2的支撑边缘和连接板边缘之间的距离。
        /// </summary>
        public static readonly string BRACE_BOLTS_2_DISTANCE_BETWEEN_BRACE_AND_CONNECTION_PLATE_EDGE = "brace_bolts_2_distance_between_brace_and_connection_plate_edge";
        #endregion
        #region 支柱螺栓3 标签页
        /// <summary>
        /// 支柱螺栓3的基本属性
        /// </summary>
        public static readonly string BRACE_BOLTS_3_BOLT_BASIC_PROPERTIES = "brace_bolts_3_bolt_basic_properties";
        /// <summary>
        /// 支柱螺栓3的槽孔属性
        /// </summary>
        public static readonly string BRACE_BOLTS_3_SLOTTED_HOLES = "brace_bolts_3_slotted_holes";
        /// <summary>
        /// 支柱螺栓3的螺栓装配
        /// </summary>
        public static readonly string BRACE_BOLTS_3_BOLT_ASSEMBLY = "brace_bolts_3_bolt_assembly";
        /// <summary>
        /// 支柱螺栓3的长度增加
        /// </summary>
        public static readonly string BRACE_BOLTS_3_BOLT_LENGTH_INCREASE = "brace_bolts_3_bolt_length_increase";
        /// <summary>
        /// 支柱螺栓3的交错
        /// </summary>
        public static readonly string BRACE_BOLTS_3_STAGGERING_OF_BOLTS = "brace_bolts_3_staggering_of_bolts";
        /// <summary>
        /// 支柱螺栓3的水平螺栓数目
        /// </summary>
        public static readonly string BRACE_BOLTS_3_HORIZONTAL_BOLTS_NUMBER = "brace_bolts_3_horizontal_bolts_number";
        /// <summary>
        /// 支柱螺栓3的水平螺栓间距
        /// </summary>
        public static readonly string BRACE_BOLTS_3_HORIZONTAL_BOLTS_SPACING = "brace_bolts_3_horizontal_bolts_spacing";
        /// <summary>
        /// 支柱螺栓3的垂直螺栓数目
        /// </summary>
        public static readonly string BRACE_BOLTS_3_VERTICAL_BOLTS_NUMBER = "brace_bolts_3_vertical_bolts_number";
        /// <summary>
        /// 支柱螺栓3的垂直螺栓间距
        /// </summary>
        public static readonly string BRACE_BOLTS_3_VERTICAL_BOLTS_SPACING = "brace_bolts_3_vertical_bolts_spacing";
        /// <summary>
        /// 支柱螺栓3的垂直螺栓的近端边距,靠近支柱对齐面为近端
        /// </summary>
        public static readonly string BRACE_BOLTS_3_VERTICAL_BOLTS_NEAR_EDGE_DIST = "brace_bolts_3_vertical_bolts_near_edge_dist";
        /// <summary>
        /// 支柱螺栓3的垂直螺栓的远端边距,远离支柱对齐面为远端
        /// </summary>
        public static readonly string BRACE_BOLTS_3_VERTICAL_BOLTS_FAR_EDGE_DIST = "brace_bolts_3_vertical_bolts_far_edge_dist";
        /// <summary>
        /// 支柱螺栓3的垂直螺栓组的测量方式
        /// </summary>
        public static readonly string BRACE_BOLTS_3_VERTICAL_BOLTS_SELECT_MEASURE_METHOD = "brace_bolts_3_vertical_bolts_select_measure_method";
        /// <summary>
        /// 支柱螺栓3的垂直螺栓组的在测量方式下的偏移
        /// </summary>
        public static readonly string BRACE_BOLTS_3_VERTICAL_BOLTS_MEASURE_OFFSET = "brace_bolts_3_vertical_bolts_measure_offset";
        /// <summary>
        /// 支柱螺栓3的支撑边缘和连接板边缘之间的距离。
        /// </summary>
        public static readonly string BRACE_BOLTS_3_DISTANCE_BETWEEN_BRACE_AND_CONNECTION_PLATE_EDGE = "brace_bolts_3_distance_between_brace_and_connection_plate_edge";
        #endregion
        /// <summary>
        ///焊缝数组 
        /// </summary>
        public static readonly string[] WELD_PROPS_LIST = {
            "weld_props0",
            "weld_props1",
            "weld_props2",
            "weld_props3",
#if Example 
            "weld_props0",
            //"weld_props1",  | 以这种固定的名称形式添加
#endif
        };
    }
}