﻿using LoongCAD.STC.Plugins;
using LoongCAD.Util;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using LoongCAD.UI;
using TargetComponentType = LoongCAD.STC.Object3D.DetailComponent;

namespace U.S.Base_plate_1047_.Main
{
    public partial class Form_PluginMain : LoongCAD.UI.Component.Form_DetailComponentProps
    {
        public Form_PluginMain()
        {
            InitializeComponent();
        }
        private PluginMain m_plugin;
        public PluginMain Plugin { get => m_plugin; set => m_plugin = value; }
        private DObject m_weldPropsBatch = new DObject();

        //----------
        private DObject m_rootUIProps = new DObject();
        private ComponentPlugin m_refPlugin = null;
        private Form_WeldParameter m_weldForm = null;
        public override ComponentPlugin ReferencePlugin => m_refPlugin;

        public Form_PluginMain(ComponentPlugin refPlugin)
        {
            InitializeComponent();
            m_refPlugin = refPlugin;
            this.OnPostInitialize();
            DisposeOnClose = false;
        }
        #region 辅助类函数
        private void AddItems(KeyValueComboBox comboBox,List<string> msg)
        {
            comboBox.ClearItems();
            for(var i = 0; i < msg.Count; ++i)
            {
                comboBox.AddItem(i, msg[i]);
            }
            comboBox.UpdateItems();
        }
        private void AddItems(ImageComboBox imageComboBox,int num)
        {
            imageComboBox.ClearItems();
            for(var i = 0; i< num; ++i) {
                imageComboBox.AddItem(i,i);
            }
            imageComboBox.UpdateItems();
        }
        #endregion

        private void OnPostInitialize()
        {
            //螺栓的额外配置
            this.bolts_bolt_basic_properties.BoltStandardChanged += this.bolts_bolt_assembly.AdaptBoltContents;
            //配置参数选项卡
            AddItems(parts_shear_key_profile_welded,new List<string>(){"默认","底板","层板(水准板)"});
            //配置螺栓选项卡
            AddItems(bolts_select_how_to_measure_the_dimensions_for_horizontal_bolt_group_position,new List<string>(){"默认","左侧","中间","右侧"});
            AddItems(bolts_select_how_to_measure_the_dimensions_for_vertical_bolt_group_position,new List<string>(){"默认","顶端","中间","下面"});
            AddItems(bolts_select_can_ignore_centre_bolt,new List<string>(){"默认","否","是"});
            //配置图片选项卡
            AddItems(parameters_base_plate_with_holes_or_bolts,3);
            AddItems(anchor_rod_types,5);
            AddItems(bolts_bolting_direction,3);
            //配置弯钩图片选项卡
            AddItems(anchor_hook_direction,5);
            //配置锚钉杆选项卡
            AddItems(anchor_select_can_build,new List<string>(){"默认","不添加","添加"});
            //配置锚钉杆创建选项卡
            SetSelectUI(anchor_select_create_nut_1);
            SetSelectUI(anchor_select_create_washer_2);
            SetSelectUI(anchor_select_create_washer_plate_3);
            SetSelectUI(anchor_select_create_nut_4);
            SetSelectUI(anchor_select_create_washer_5);
            SetSelectUI(anchor_select_create_nut_6);
            SetSelectUI(anchor_select_create_nut_7);
            SetSelectUI(anchor_select_create_nut_8);
            SetSelectUI(anchor_select_create_washer_plate_9);
            SetSelectUI(anchor_select_create_nut_10);
            //配置锚钉杆焊缝选项卡
            SetSelectUIForWeld(anchor_select_weld_nut_1);
            SetSelectUIForWeld(anchor_select_weld_washer_2);
            SetSelectUIForWeld(anchor_select_weld_washer_plate_3);
            SetSelectUIForWeld(anchor_select_weld_nut_4);
            SetSelectUIForWeld(anchor_select_weld_washer_5);
            SetSelectUIForWeld(anchor_select_weld_nut_6);
            SetSelectUIForWeld(anchor_select_weld_nut_7);
            SetSelectUIForWeld(anchor_select_weld_nut_8);
            SetSelectUIForWeld(anchor_select_weld_washer_plate_9);
            SetSelectUIForWeld(anchor_select_weld_nut_10);
            //配置铸造板孔隙
            AddItems(anchor_select_create_hole_in_washer,new List<string>(){"默认","垫圈上没有孔","垫圈孔隙:"});
            //配置锚钉杆构件
            AddItems(anchor_rod_assembly_included_select,new List<string>(){"默认","否","仅锚栓"});
            //anchor_rod_assembly_included_select.AddItem(3,"包括LP");
            //配置附加板
            AddItems(extra_plates_plate_1_select_pos_type,4);
            AddItems(extra_plates_plate_1_select_rotation,new List<string>(){"默认","前面","顶端","后面","底端"});
            AddItems(extra_plates_plate_1_select_create_hole_in_washer,new List<string>(){"默认","垫圈上没有孔","垫圈孔隙:"});
            AddItems(extra_plates_plate_2_select_type,7);
            AddItems(extra_plates_plate_2_select_dir,3);
            AddItems(extra_plates_plate_2_select_rotation,new List<string>(){"默认","前面","顶端","后面","底端"});
            //配置临时板开孔
            var msg = new List<string>() { "默认", "否", "是" };
            AddItems(temporary_plate_opening_select_can_build,msg);
            AddItems(temporary_plate_opening_select_can_leveling_plate,msg);
            AddItems(temporary_plate_opening_select_can_fitting_plate_1,msg);
            AddItems(temporary_plate_opening_select_can_fitting_plate_2,msg);
            AddItems(temporary_plate_opening_select_can_fitting_plate_3,msg);
            AddItems(temporary_plate_opening_select_can_cast_plate,msg);
            AddItems(temporary_plate_opening_select_type,3);
            
            foreach(TabPage curPage in this.tab_main.TabPages)
            {
                curPage.AutoScroll = true;
            }
        }

        private void SetSelectUI(LoongCAD.UI.KeyValueComboBox ui)
        {
            ui.ClearItems();
            ui.AddItem(0,"默认");
            ui.AddItem(1,"否");
            ui.AddItem(2,"是");
            ui.UpdateItems();
        }
        private void SetSelectUIForWeld(LoongCAD.UI.KeyValueComboBox ui)
        {
            ui.ClearItems();
            ui.AddItem(0, "默认");
            ui.AddItem(1, "否");
            ui.AddItem(2, "是");
            ui.UpdateItems();
        }
        /// <summary>
        /// 当前组件需要重写此方法，并刷新螺栓基本面板
        /// </summary>
        /// <param name="root"></param>
        public override void ClearUI(Control root = null)
        {
            bolts_bolt_basic_properties.RefreshControls();
            base.ClearUI(root);
        }
        
        protected override void UpdatePlaceholders(DObject compProps, DObject defaultValues)
        {
            //this.ClearPlaceholders();
            defaultValues = ParamsHandlerBase.SelectDefaultsByEmpty(compProps, defaultValues, ParamsHandler.EmptyValues);
            this.SetPlaceholders(defaultValues);
        }

        private void btn_weld_props_Click(object sender, EventArgs e)
        {
            if (m_weldForm == null)
            {
                m_weldForm = new Form_WeldParameter();
                m_weldForm.Owner = this.Owner;
                m_weldForm.ApplyHandler += this.ApplyWeldProps;
                m_weldForm.ModifyHandler += this.ModifyWeldProps;
                m_weldForm.GetHandler += this.GetWeldProps;
            }

            m_weldForm.Show(m_rootUIProps, null);

        }

        public override void SetParameters(DObject paras, Control root = null)
        {
            base.SetParameters(paras, root);
            if (root == null)
            {
                m_rootUIProps.Clear();
                m_rootUIProps.CopyFrom(paras);
            }
        }

        /// <summary>
        /// 应用焊缝属性的回调函数
        /// </summary>
        /// <returns></returns>
        /// <remarks><b>包含焊缝子窗口的组件需要复制此方法</b></remarks>
        protected void ApplyWeldProps(DObject srcProps)
        {
            m_rootUIProps.CopyFrom(srcProps);
        }

        /// <summary>
        /// 修改焊缝属性的回调函数
        /// </summary>
        /// <returns></returns>
        /// <remarks><b>包含焊缝子窗口的组件需要复制此方法</b></remarks>
        protected void ModifyWeldProps(DObject srcProps)
        {
            this.ModifyFocusedProps(srcProps);
        }

        /// <summary>
        /// 获取焊缝属性的回调函数
        /// </summary>
        /// <returns></returns>
        /// <remarks><b>包含焊缝子窗口的组件需要复制此方法</b></remarks>
        protected DObject GetWeldProps()
        {
            var refPlugin = this.ReferencePlugin;
            if (refPlugin == null)
                return m_rootUIProps;
            var curScene = LoongCAD.STC.STC.Document.FocusedScene;
            if (curScene == null)
                return m_rootUIProps;
            System.Guid pluginGuid = refPlugin.Guid;
            LoongCAD.STC.Object3D.ObjectBase[] curObjs = curScene.GetSelectedObjects(
                obj => obj is LoongCAD.STC.Object3D.ComponentBase &&
                ((LoongCAD.STC.Object3D.ComponentBase)obj).CompGuid == pluginGuid);
            if (curObjs == null || curObjs.Length == 0)
                return m_rootUIProps;
            LoongCAD.STC.Object3D.ComponentBase comp = curObjs[0] as LoongCAD.STC.Object3D.ComponentBase;
            if (comp == null)
                return m_rootUIProps;

            return comp.UIProps;
        }
        
        /// <summary>
        /// 获取当前窗口的属性值
        /// </summary>
        /// <param name="root"></param>
        /// <param name="exclude"></param>
        /// <param name="bConsiderCheck"></param>
        /// <remarks>其他组件若同样包含类似焊缝属性窗的子窗口，则需要复制此方法</remarks>
        /// <returns></returns>
        public override DObject GetParameters(Control root = null, List<Control> exclude = null, bool bConsiderCheck = true)
        {
            DObject retProps = new DObject();
            if (!bConsiderCheck || this.act_weld_props.Checked) {
                retProps.CopyFrom(m_rootUIProps);
            }
            DObject baseProps = base.GetParameters(root, exclude, true);
            retProps.CopyFrom(baseProps);
            return retProps;
        }

        Dictionary<Control, Tuple<Color, Color>> originalColors = new Dictionary<Control, Tuple<Color,Color>>();
        private void HighlightControl(Control control, int duration)
        {
            // 保存原始颜色
            if (!originalColors.ContainsKey(control))
            {
                originalColors.Add(control, new Tuple<Color, Color>(control.BackColor,control.ForeColor));
            }

            // 改变颜色
            control.BackColor = Color.Black;
            control.ForeColor = Color.White;

            // 配置计时器
            Timer timer = new Timer();
            timer.Interval = duration; // 持续时间，单位毫秒
            timer.Tick += (sender, e) =>
            {
                // 恢复原始颜色
                if (originalColors.ContainsKey(control))
                {
                    control.BackColor = originalColors[control].Item1;
                    control.ForeColor = originalColors[control].Item2;
                    originalColors.Remove(control);
                }

                // 停止并销毁计时器
                timer.Stop();
                timer.Dispose();
            };

            // 启动计时器
            timer.Start();
        }


        private void label_leveling_plate_Click(object sender, EventArgs e)
        {
            tab_main.SelectedIndex = PartsTab.TabIndex;
            HighlightControl(parts_leveling_plate,2000);
        }

        private void label_temporary_plate_opening_select_can_fitting_plate_1_Click(object sender, EventArgs e)
        {
            tab_main.SelectedIndex = PartsTab.TabIndex;
            HighlightControl(parts_fitting_plate_1,2000);
            HighlightControl(label_part_fitting_plate_1,2000);
            HighlightControl(parts_fitting_plate_1_num,2000);
            HighlightControl(checkBoxparts_fitting_plate_1_num,2000);
        }

        private void label_temporary_plate_opening_select_can_fitting_plate_2_Click(object sender, EventArgs e)
        {
            tab_main.SelectedIndex = PartsTab.TabIndex;
            HighlightControl(parts_fitting_plate_2,2000);
            HighlightControl(label_part_fitting_plate_2,2000);
            HighlightControl(parts_fitting_plate_2_num,2000);
            HighlightControl(checkBoxparts_fitting_plate_2_num,2000);
        }

        private void label_temporary_plate_opening_select_can_fitting_plate_3_Click(object sender, EventArgs e)
        {
            tab_main.SelectedIndex = PartsTab.TabIndex;
            HighlightControl(parts_fitting_plate_3,2000);
            HighlightControl(label_part_fitting_plate_3,2000);
            HighlightControl(parts_fitting_plate_3_num,2000);
            HighlightControl(checkBoxparts_fitting_plate_3_num,2000);
        }

        private void label_temporary_plate_opening_select_can_cast_plate_Click(object sender, EventArgs e)
        {
            tab_main.SelectedIndex = AnchorRodsTab.TabIndex;
            HighlightControl(anchor_cast_plate,2000);
        }

        private void temporary_plate_opening_select_type_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (temporary_plate_opening_select_type.SelectedIndex == 2)
            {
                temporary_plate_opening_hor_length.Enabled = false;
                checkBoxtemporary_plate_opening_hor_length.Enabled = false;
                temporary_plate_opening_rotation.Enabled = false;
                checkBoxtemporary_plate_opening_rotation.Enabled = false;
            }
            else
            {
                temporary_plate_opening_hor_length.Enabled = true;
                checkBoxtemporary_plate_opening_hor_length.Enabled = true;
                temporary_plate_opening_rotation.Enabled = true;
                checkBoxtemporary_plate_opening_rotation.Enabled = true;
            }
        }

        /// <summary>
        /// 切换临时板开孔的选项
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void temporary_plate_opening_select_can_build_SelectedIndexChanged(object sender, EventArgs e)
        {
            var select = temporary_plate_opening_select_can_build.SelectedIndex;
            temporary_plate_opening_select_can_leveling_plate.SelectedIndex = select;
            temporary_plate_opening_select_can_fitting_plate_1.SelectedIndex = select;
            temporary_plate_opening_select_can_fitting_plate_2.SelectedIndex = select;
            temporary_plate_opening_select_can_fitting_plate_3.SelectedIndex = select;
            temporary_plate_opening_select_can_cast_plate.SelectedIndex = select;
        }

        /// <summary>
        /// 螺栓形状切换
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void bolts_staggering_of_bolts_SelectedIndexChanged(object sender, EventArgs e)
        {
            var select = bolts_staggering_of_bolts.SelectedIndex;
            if(select == 0 || select == 1)
            {
                bolts_select_can_ignore_centre_bolt.Enabled = true;
                checkBoxbolts_select_can_ignore_centre_bolt.Enabled = true;
            }
            else
            {
                bolts_select_can_ignore_centre_bolt.Enabled = false;
                checkBoxbolts_select_can_ignore_centre_bolt.Enabled = false;
            }

        }
    }
}
