﻿using LoongCAD.UI;
using LoongCAD.UI.Component;
using LoongCAD.Util;
using U.S.Base_plate_1047_.Tool;


namespace U.S.Base_plate_1047_.Main
{
    public static class ParamNames
    {
        #region  PIC 图形标签页
        /// <summary>
        ///加劲肋 1、2、4、5 的顶部折角垂直宽度。 
        /// </summary>
        public static readonly string PIC_TOP_VERTICAL_CHAMFER_FOR_STIFFENERS_1_2_4_5 = "pic_top_vertical_chamfer_for_stiffeners_1_2_4_5";
        /// <summary>
        /// 加劲肋 1、2、4、5 的顶部折角水平高度。
        /// </summary>
        public static readonly string PIC_TOP_HORIZONTAL_CHAMFER_FOR_STIFFENERS_1_2_4_5 = "pic_top_horizontal_chamfer_for_stiffeners_1_2_4_5";
        /// <summary>
        /// 加劲肋 1、2、4、5 的底部折角水平高度。
        /// </summary>
        public static readonly string PIC_BOTTOM_HORIZONTAL_CHAMFER_FOR_STIFFENERS_1_2_4_5 = "pic_bottom_horizontal_chamfer_for_stiffeners_1_2_4_5";
        /// <summary>
        /// 加劲肋 1、2、4、5 的底部折角垂直宽度。
        /// </summary>
        public static readonly string PIC_BOTTOM_VERTICAL_CHAMFER_FOR_STIFFENERS_1_2_4_5 = "pic_bottom_vertical_chamfer_for_stiffeners_1_2_4_5";
        /// <summary>
        /// 加劲肋 3、6 的顶部折角垂直宽度。
        /// </summary>
        public static readonly string PIC_TOP_VERTICAL_CHAMFER_FOR_STIFFENERS_3_6 = "pic_top_vertical_chamfer_for_stiffeners_3_6";
        /// <summary>
        /// 加劲肋 3、6 的顶部折角水平高度。
        /// </summary>
        public static readonly string PIC_TOP_HORIZONTAL_CHAMFER_FOR_STIFFENERS_3_6 = "pic_top_horizontal_chamfer_for_stiffeners_3_6";
        /// <summary>
        /// 加劲肋 3、6 的底部折角水平高度。
        /// </summary>
        public static readonly string PIC_BOTTOM_HORIZONTAL_CHAMFER_FOR_STIFFENERS_3_6 = "pic_bottom_horizontal_chamfer_for_stiffeners_3_6";
        /// <summary>
        /// 加劲肋 3、6 的底部折角垂直宽度。
        /// </summary>
        public static readonly string PIC_BOTTOM_VERTICAL_CHAMFER_FOR_STIFFENERS_3_6 = "pic_bottom_vertical_chamfer_for_stiffeners_3_6";
        
        public static readonly string PIC_TOP_VERTICAL_CHAMFER_FOR_STIFFENERS_7 = "pic_top_vertical_chamfer_for_stiffeners_7";
        public static readonly string PIC_TOP_HORIZONTAL_CHAMFER_FOR_STIFFENERS_7 = "pic_top_horizontal_chamfer_for_stiffeners_7";
        public static readonly string PIC_BOTTOM_HORIZONTAL_CHAMFER_FOR_STIFFENERS_7 = "pic_bottom_horizontal_chamfer_for_stiffeners_7";
        public static readonly string PIC_BOTTOM_VERTICAL_CHAMFER_FOR_STIFFENERS_7 = "pic_bottom_vertical_chamfer_for_stiffeners_7";
        
        public static readonly string PIC_TOP_VERTICAL_CHAMFER_FOR_STIFFENERS_8 = "pic_top_vertical_chamfer_for_stiffeners_8";
        public static readonly string PIC_TOP_HORIZONTAL_CHAMFER_FOR_STIFFENERS_8 = "pic_top_horizontal_chamfer_for_stiffeners_8";
        public static readonly string PIC_BOTTOM_HORIZONTAL_CHAMFER_FOR_STIFFENERS_8 = "pic_bottom_horizontal_chamfer_for_stiffeners_8";
        public static readonly string PIC_BOTTOM_VERTICAL_CHAMFER_FOR_STIFFENERS_8 = "pic_bottom_vertical_chamfer_for_stiffeners_8";
        /// <summary>
        /// 焊缝间隙，实际效果是柱子顶部裁剪的高度，并且不会影响加劲肋、基板的布局。
        /// </summary>
        public static readonly string PIC_WELD_GAP = "pic_weld_gap";
        /// <summary>
        /// 底板折角1的宽度
        /// </summary>
        public static readonly string PIC_WIDTH_OF_BASE_PLATE_CHAMFER_1 = "pic_width_of_base_plate_chamfer_1";
        /// <summary>
        /// 底板折角1的高度
        /// </summary>
        public static readonly string PIC_HEIGHT_OF_BASE_PLATE_CHAMFER_1 = "pic_height_of_base_plate_chamfer_1";
        /// <summary>
        /// 底板折角2的高度
        /// </summary>
        public static readonly string PIC_HEIGHT_OF_BASE_PLATE_CHAMFER_2 = "pic_height_of_base_plate_chamfer_2";
        /// <summary>
        /// 底板折角2的宽度
        /// </summary>
        public static readonly string PIC_WIDTH_OF_BASE_PLATE_CHAMFER_2 = "pic_width_of_base_plate_chamfer_2";
        /// <summary>
        /// 底板折角3的宽度
        /// </summary>
        public static readonly string PIC_WIDTH_OF_BASE_PLATE_CHAMFER_3 = "pic_width_of_base_plate_chamfer_3";
        /// <summary>
        /// 底板折角3的高度
        /// </summary>
        public static readonly string PIC_HEIGHT_OF_BASE_PLATE_CHAMFER_3 = "pic_height_of_base_plate_chamfer_3";
        /// <summary>
        /// 底板折角4的高度
        /// </summary>
        public static readonly string PIC_HEIGHT_OF_BASE_PLATE_CHAMFER_4 = "pic_height_of_base_plate_chamfer_4";
        /// <summary>
        /// 底板折角4的宽度
        /// </summary>
        public static readonly string PIC_WIDTH_OF_BASE_PLATE_CHAMFER_4 = "pic_width_of_base_plate_chamfer_4";
        /// <summary>
        /// 灌浆孔距柱中心的水平距离
        /// </summary>
        public static readonly string PIC_GROUT_HOLE_HORIZONTAL_DISTANCE_FROM_COLUMN_CENTER = "pic_grout_hole_horizontal_distance_from_column_center";
        /// <summary>
        /// 灌浆孔距柱中心的垂直距离
        /// </summary>
        public static readonly string PIC_GROUT_HOLE_VERTICAL_DISTANCE_FROM_COLUMN_CENTER = "pic_grout_hole_vertical_distance_from_column_center";
        /// <summary>
        /// 灌浆孔直径
        /// </summary>
        public static readonly string PIC_DIAMETER_OF_THE_GROUT_HOLE = "pic_diameter_of_the_grout_hole";
        #endregion
        #region PARTS 零件选项页
        //零件选项卡
        /// <summary>
        /// 基板（底板）的板属性
        /// </summary>
        public static readonly string PARTS_BASE_PLATE = "parts_base_plate";
        /// <summary>
        /// 加劲肋 1、2、4、5 的板属性。
        /// </summary>
        public static readonly string PARTS_STIFFENERS_1_2_4_5 = "parts_stiffeners_1_2_4_5";
        /// <summary>
        /// 加劲肋 3、6的板属性。
        /// </summary>
        public static readonly string PARTS_STIFFENERS_3_6 = "parts_stiffeners_3_6"; 
        /// <summary>
        /// 加劲肋 7 的板属性。
        /// </summary>
        public static readonly string PARTS_STIFFENERS_7 = "parts_stiffeners_7";
        /// <summary>
        /// 加劲肋 8 的板属性。
        /// </summary>
        public static readonly string PARTS_STIFFENERS_8 = "parts_stiffeners_8"; 
        /// <summary>
        /// 抗剪键的型号
        /// </summary>
        public static readonly string PARTS_KEY_PROFILE = "parts_key_profile";
        /// <summary>
        /// 水准板(层板)的厚度、宽度和高度
        /// </summary>
        public static readonly string PARTS_LEVELING_PLATE = "parts_leveling_plate";
        /// <summary>
        /// 垫板(装配板)的厚度、宽度和高度。最多可以定义三个不同的垫板。
        /// 1号衬板的厚度、宽度和高度。
        /// </summary>
        public static readonly string PARTS_FITTING_PLATE_1= "parts_fitting_plate_1"; 
        /// <summary>
        /// 1号衬板的数量
        /// </summary>
        public static readonly string PARTS_FITTING_PLATE_1_NUM= "parts_fitting_plate_1_num"; 
        /// <summary>
        /// 2号衬板的厚度、宽度和高度。
        /// </summary>
        public static readonly string PARTS_FITTING_PLATE_2 = "parts_fitting_plate_2";
        /// <summary>
        /// 2号衬板的数量
        /// </summary>
        public static readonly string PARTS_FITTING_PLATE_2_NUM= "parts_fitting_plate_2_num"; 
        /// <summary>
        /// 衬板的厚度、宽度和高度。
        /// </summary>
        public static readonly string PARTS_FITTING_PLATE_3 = "parts_fitting_plate_3";
        /// <summary>
        /// 3号衬板的数量
        /// </summary>
        public static readonly string PARTS_FITTING_PLATE_3_NUM= "parts_fitting_plate_3_num"; 
        /// <summary>
        /// 水准板(层板)孔的直径
        /// </summary>
        public static readonly string PARTS_LEVELING_PLATE_HOLE_DIAMETER = "parts_leveling_plate_hole_diameter"; 
        /// <summary>
        /// 定义将抗剪键焊接到哪个板。
        /// </summary>
        public static readonly string PARTS_SHEAR_KEY_PROFILE_WELDED = "parts_shear_key_profile_welded";
        #endregion
        #region PARAMETERS 参数选项页 
        //参数选项卡
        /// <summary>
        /// 方切割角点的选择编号
        /// </summary>
        public static readonly string PARAMETERS_SQUARE_CUT_CORNERS_1TO4 = "parameters_square_cut_corners_1to4"; 
        /// <summary>
        /// 选择基板创建孔洞还是螺栓
        /// </summary>
        public static readonly string PARAMETERS_BASE_PLATE_WITH_HOLES_OR_BOLTS = "parameters_base_plate_with_holes_or_bolts"; 
        /// <summary>
        /// 螺栓组的旋转角度
        /// </summary>
        public static readonly string PARAMETERS_BOLT_GROUP_ROTATION_ANGLE = "parameters_bolt_group_rotation_angle"; 
        /// <summary>
        /// 底板(基板)与柱中心的水平偏移
        /// </summary>
        public static readonly string PARAMETERS_BASE_PLATE_HORIZONTAL_OFFSET_FROM_THE_COLUMN_CENTER = "parameters_base_plate_horizontal_offset_from_the_column_center";
        /// <summary>
        /// 底板(基板)与柱中心的垂直偏移
        /// </summary>
        public static readonly string PARAMETERS_BASE_PLATE_VERTICAL_OFFSET_FROM_THE_COLUMN_CENTER = "parameters_base_plate_vertical_offset_from_the_column_center";
        /// <summary>
        /// 抗剪键垂直偏移。
        /// </summary>
        public static readonly string PARAMETERS_SHEAR_KEY_VERTICAL_OFFSET = "parameters_shear_key_vertical_offset";
        /// <summary>
        /// 抗剪键水平偏移。
        /// </summary>
        public static readonly string PARAMETERS_SHEAR_KEY_HORIZONTAL_OFFSET = "parameters_shear_key_horizontal_offset";
        /// <summary>
        /// 抗剪键旋转角度（用度表示）。
        /// </summary>
        public static readonly string PARAMETERS_SHEAR_KEY_ROTATION_ANGLE= "parameters_shear_key_rotation_angle";
        /// <summary>
        /// 抗剪键长度
        /// </summary>
        public static readonly string PARAMETERS_SHEAR_KEY_LENGTH = "parameters_shear_key_length";
        #endregion
        #region BOLTS 螺栓选项页 
        //"螺栓选项卡"
        /// <summary>
        /// 选择测量水平螺栓组位置的选项
        /// </summary>
        public static readonly string BOLTS_SELECT_HOW_TO_MEASURE_THE_DIMENSIONS_FOR_HORIZONTAL_BOLT_GROUP_POSITION =
            "bolts_select_how_to_measure_the_dimensions_for_horizontal_bolt_group_position";
        /// <summary>
        /// 测量水平螺栓组位置的尺寸,或者说是偏移值
        /// </summary>
        public static readonly string BOLTS_DIMENSION_FOR_HORIZONTAL_BOLT_GROUP_POSITION = "bolts_dimension_for_horizontal_bolt_group_position";
        /// <summary>
        /// 选择测量垂直螺栓组位置的选项
        /// </summary>
        public static readonly string BOLTS_SELECT_HOW_TO_MEASURE_THE_DIMENSIONS_FOR_VERTICAL_BOLT_GROUP_POSITION =
            "bolts_select_how_to_measure_the_dimensions_for_vertical_bolt_group_position";
        /// <summary>
        /// 测量垂直螺栓组位置的尺寸,或者说是偏移值
        /// </summary>
        public static readonly string BOLTS_DIMENSION_FOR_VERTICAL_BOLT_GROUP_POSITION = "bolts_dimension_for_vertical_bolt_group_position";
        /// <summary>
        /// 螺栓边距：螺栓中心到零件边缘的距离。
        /// 此处为顶部的垂直距离。
        /// </summary>
        public static readonly string BOLTS_BOLT_EDGE_TOP_VERTICAL_DISTANCE = "bolts_bolt_edge_top_vertical_distance";
        /// <summary>
        /// 螺栓边距：螺栓中心到零件边缘的距离。
        /// 此处为底部的垂直距离。
        /// </summary>
        public static readonly string BOLTS_BOLT_EDGE_BOTTOM_VERTICAL_DISTANCE = "bolts_bolt_edge_bottom_vertical_distance";
        /// <summary>
        /// 螺栓边距：螺栓中心到零件边缘的距离。
        /// 此处为左侧的水平距离。
        /// </summary>
        public static readonly string BOLTS_BOLT_EDGE_LEFT_DISTANCE = "bolts_bolt_edge_left_distance";
        /// <summary>
        /// 螺栓边距：螺栓中心到零件边缘的距离。
        /// 此处为右侧的水平距离。
        /// </summary>
        public static readonly string BOLTS_BOLT_EDGE_RIGHT_DISTANCE = "bolts_bolt_edge_right_distance";
        /// <summary>
        /// 水平螺栓数量
        /// </summary>
        public static readonly string BOLTS_NUMBER_OF_HORIZONTAL_BOLTS= "bolts_number_of_horizontal_bolts";
        /// <summary>
        /// 水平螺栓的间距
        /// </summary>
        public static readonly string BOLTS_HORIZONTAL_BOLT_SPACING= "bolts_horizontal_bolt_spacing";
        /// <summary>
        /// 垂直螺栓数量
        /// </summary>
        public static readonly string BOLTS_NUMBER_OF_VERTICAL_BOLTS= "bolts_number_of_vertical_bolts";
        /// <summary>
        /// 垂直螺栓的间距
        /// </summary>
        public static readonly string BOLTS_VERTICAL_BOLT_SPACING= "bolts_vertical_bolt_spacing";
        /// <summary>
        /// 螺栓的排列方式
        /// </summary>
        public static readonly string BOLTS_STAGGERING_OF_BOLTS = "bolts_staggering_of_bolts"; 
        /// <summary>
        /// 螺栓的基本属性
        /// </summary>
        public static readonly string BOLTS_BOLT_BASIC_PROPERTIES = "bolts_bolt_basic_properties";
        /// <summary>
        /// 螺栓的槽孔
        /// </summary>
        public static readonly string BOLTS_SLOTTED_HOLES= "bolts_slotted_holes";
        /// <summary>
        /// 螺栓构件
        /// </summary>
        public static readonly string BOLTS_BOLT_ASSEMBLY= "bolts_bolt_assembly";
        /// <summary>
        /// 螺栓长度增加
        /// </summary>
        public static readonly string BOLTS_BOLT_LENGTH_INCREASE = "bolts_bolt_length_increase";
        /// <summary>
        /// 螺栓的栓接方向
        /// </summary>
        public static readonly string BOLTS_BOLTING_DIRECTION = "bolts_bolting_direction";
        /// <summary>
        /// 忽略的螺栓编号数组
        /// </summary>
        public static readonly string BOLTS_IGNORE_BOLT_INDEX_ARRAY = "bolts_ignore_bolt_index_array";
        /// <summary>
        /// 是否启用中心螺栓忽略
        /// </summary>
        public static readonly string BOLTS_SELECT_CAN_IGNORE_CENTRE_BOLT = "bolts_select_can_ignore_centre_bolt";
        #endregion
        #region STIFFENER 加劲肋选项页 
        //加劲肋选项卡：控制加劲肋的位置和偏移
        /// <summary>
        /// 需要生成的加劲肋位置
        /// </summary>
        public static readonly string STIFFENER_POSITIONS_1TO8 = "stiffener_positions_1to8";
        /// <summary>
        /// 加劲肋1偏移
        /// </summary>
        public static readonly string STIFFENER_1_OFFSET = "stiffener_1_offset";
        /// <summary>
        /// 加劲肋2偏移
        /// </summary>
        public static readonly string STIFFENER_2_OFFSET = "stiffener_2_offset";
        /// <summary>
        /// 加劲肋3偏移
        /// </summary>
        public static readonly string STIFFENER_3_OFFSET = "stiffener_3_offset";
        /// <summary>
        /// 加劲肋4偏移
        /// </summary>
        public static readonly string STIFFENER_4_OFFSET = "stiffener_4_offset";
        /// <summary>
        /// 加劲肋5偏移
        /// </summary>
        public static readonly string STIFFENER_5_OFFSET = "stiffener_5_offset";
        /// <summary>
        /// 加劲肋6偏移
        /// </summary>
        public static readonly string STIFFENER_6_OFFSET = "stiffener_6_offset";
        /// <summary>
        /// 加劲肋7偏移
        /// </summary>
        public static readonly string STIFFENER_7_OFFSET = "stiffener_7_offset";
        /// <summary>
        /// 加劲肋8偏移
        /// </summary>
        public static readonly string STIFFENER_8_OFFSET = "stiffener_8_offset";

        #region 间距、数目配置 
        public static readonly string STIFFENER_3_NUMS= "stiffener_3_nums";
        public static readonly string STIFFENER_3_SPACING= "stiffener_3_spacing";
        public static readonly string STIFFENER_6_NUMS= "stiffener_6_nums";
        public static readonly string STIFFENER_6_SPACING= "stiffener_6_spacing";
        public static readonly string STIFFENER_7_NUMS= "stiffener_7_nums";
        public static readonly string STIFFENER_7_SPACING= "stiffener_7_spacing";
        public static readonly string STIFFENER_8_NUMS= "stiffener_8_nums";
        public static readonly string STIFFENER_8_SPACING= "stiffener_8_spacing";
        #endregion
        #endregion
        #region ANCHOR 锚钉杆标签页 
        // 锚栓干标签页
        /// <summary>
        /// 能否创建锚钉杆
        /// </summary>
        public static readonly string ANCHOR_SELECT_CAN_BUILD = "anchor_select_can_build";
        /// <summary>
        /// 锚钉杆的截面类型
        /// </summary>
        public static readonly string ANCHOR_ROD_PROFILE = "anchor_rod_profile";
        /// <summary>
        /// 螺母的截面类型
        /// </summary>
        public static readonly string ANCHOR_NUT_PROFILE = "anchor_nut_profile";
        /// <summary>
        /// 垫圈的截面类型
        /// </summary>
        public static readonly string ANCHOR_WASHER_PROFILE = "anchor_washer_profile";
        /// <summary>
        /// 板垫片的板属性 
        /// </summary>
        public static readonly string ANCHOR_WASHER_PLATE = "anchor_washer_plate";
        /// <summary>
        /// 铸造板的板属性 
        /// </summary>
        public static readonly string ANCHOR_CAST_PLATE = "anchor_cast_plate"; 
        //编号为面板从上到下的计数
        /// <summary>
        /// 选择是否创建基板上的螺母，编号1
        /// </summary>
        public static readonly string ANCHOR_SELECT_CREATE_NUT_1 = "anchor_select_create_nut_1";
        /// <summary>
        /// 选择是否创建基板上的垫片，编号2
        /// </summary>
        public static readonly string ANCHOR_SELECT_CREATE_WASHER_2= "anchor_select_create_washer_2";
        /// <summary>
        /// 选择是否创建基板上的垫片板，编号3
        /// </summary>
        public static readonly string ANCHOR_SELECT_CREATE_WASHER_PLATE_3= "anchor_select_create_washer_plate_3";
        /// <summary>
        /// 选择是否创建基板下的螺母，编号4
        /// </summary>
        public static readonly string ANCHOR_SELECT_CREATE_NUT_4 = "anchor_select_create_nut_4";
        /// <summary>
        /// 选择是否创建基本上的垫片，编号5
        /// </summary>
        public static readonly string ANCHOR_SELECT_CREATE_WASHER_5= "anchor_select_create_washer_5";
        /// <summary>
        /// 选择是否创建铸造板上方的螺母，编号6
        /// </summary>
        public static readonly string ANCHOR_SELECT_CREATE_NUT_6 = "anchor_select_create_nut_6";
        /// <summary>
        /// 选择是否创建铸造板下方的螺母，编号7
        /// </summary>
        public static readonly string ANCHOR_SELECT_CREATE_NUT_7 = "anchor_select_create_nut_7";
        /// <summary>
        /// 选择是否创建锚段垫片板上方的螺母，编号8
        /// </summary>
        public static readonly string ANCHOR_SELECT_CREATE_NUT_8 = "anchor_select_create_nut_8";
        /// <summary>
        /// 选择是否创建锚端的垫片板，编号9
        /// </summary>
        public static readonly string ANCHOR_SELECT_CREATE_WASHER_PLATE_9= "anchor_select_create_washer_plate_9";
        /// <summary>
        /// 选择是否创建锚段垫片板下方的螺母，编号10
        /// </summary>
        public static readonly string ANCHOR_SELECT_CREATE_NUT_10 = "anchor_select_create_nut_10";
        //焊缝开关
        /// <summary>
        /// 选择是否创建基板上的螺母的焊缝，编号1
        /// </summary>
        public static readonly string ANCHOR_SELECT_WELD_NUT_1 = "anchor_select_weld_nut_1";
        /// <summary>
        /// 选择是否创建基板上的垫片的焊缝，编号2
        /// </summary>
        public static readonly string ANCHOR_SELECT_WELD_WASHER_2= "anchor_select_weld_washer_2";
        /// <summary>
        /// 选择是否创建基板上的垫片板的焊缝，编号3
        /// </summary>
        public static readonly string ANCHOR_SELECT_WELD_WASHER_PLATE_3= "anchor_select_weld_washer_plate_3";
        /// <summary>
        /// 选择是否创建基板下的螺母的焊缝，编号4
        /// </summary>
        public static readonly string ANCHOR_SELECT_WELD_NUT_4 = "anchor_select_weld_nut_4";
        /// <summary>
        /// 选择是否创建基本上的垫片的焊缝，编号5
        /// </summary>
        public static readonly string ANCHOR_SELECT_WELD_WASHER_5= "anchor_select_weld_washer_5";
        /// <summary>
        /// 选择是否创建铸造板上方的螺母的焊缝，编号6
        /// </summary>
        public static readonly string ANCHOR_SELECT_WELD_NUT_6 = "anchor_select_weld_nut_6";
        /// <summary>
        /// 选择是否创建铸造板下方的螺母的焊缝，编号7
        /// </summary>
        public static readonly string ANCHOR_SELECT_WELD_NUT_7 = "anchor_select_weld_nut_7";
        /// <summary>
        /// 选择是否创建锚段垫片板上方的螺母的焊缝，编号8
        /// </summary>
        public static readonly string ANCHOR_SELECT_WELD_NUT_8 = "anchor_select_weld_nut_8";
        /// <summary>
        /// 选择是否创建锚端的垫片板的焊缝，编号9
        /// </summary>
        public static readonly string ANCHOR_SELECT_WELD_WASHER_PLATE_9= "anchor_select_weld_washer_plate_9";
        /// <summary>
        /// 选择是否创建锚段垫片板下方的螺母的焊缝，编号10
        /// </summary>
        public static readonly string ANCHOR_SELECT_WELD_NUT_10 = "anchor_select_weld_nut_10";
        //锚钉杆细节面板
        /// <summary>
        /// 锚钉杆的类别
        /// </summary>
        public static readonly string ANCHOR_ROD_TYPES = "anchor_rod_types";
        /// <summary>
        /// 螺母的长度
        /// </summary>
        public static readonly string ANCHOR_SIZE_OR_LENGTH_OF_THE_NUT = "anchor_size_or_length_of_the_nut";
        /// <summary>
        /// 垫圈的尺寸或厚度
        /// </summary>
        public static readonly string ANCHOR_SIZE_OR_THE_THICKNESS_OF_THE_WASHER = "anchor_size_or_the_thickness_of_the_washer";
        /// <summary>
        /// 锚钉杆的长度
        /// </summary>
        public static readonly string ANCHOR_LENGTH_OF_THE_ANCHOR_ROD = "anchor_length_of_the_anchor_rod";
        /// <summary>
        /// 锚钉杆在基板以上的长度
        /// </summary>
        public static readonly string ANCHOR_LENGTH_OF_THE_ANCHOR_ROD_ABOVE_THE_BASE_PLATE = 
        "anchor_length_of_the_anchor_rod_above_the_base_plate";
        /// <summary>
        /// 浇筑板和基板之间的距离
        /// </summary>
        public static readonly string ANCHOR_DISTANCE_BETWEEN_THE_CAST_PLATE_AND_THE_BASE_PLATE = 
        "anchor_distance_between_the_cast_plate_and_the_base_plate";
        /// <summary>
        /// 上螺纹的长度
        /// </summary>
        public static readonly string ANCHOR_LENGTH_OF_THE_UPPER_THREAD = "anchor_length_of_the_upper_thread";
        //a,b,c,d,e
        /// <summary>
        /// 弯钩的半径,a
        /// </summary>
        public static readonly string ANCHOR_RADIUS_OF_THE_HOOK = "anchor_radius_of_the_hook";
        /// <summary>
        /// 弯钩的宽度,b
        /// </summary>
        public static readonly string ANCHOR_WIDTH_OF_THE_HOOK = "anchor_width_of_the_hook";
        /// <summary>
        /// 弯钩的高度,c
        /// </summary>
        public static readonly string ANCHOR_HEIGHT_OF_THE_HOOK = "anchor_height_of_the_hook";
        /// <summary>
        /// 锚钉杆在附加板以下的长度,d
        /// </summary>
        public static readonly string ANCHOR_LENGTH_OF_THE_ANCHOR_ROD_BELOW_THE_EXTRA_PLATE= 
        "anchor_length_of_the_anchor_rod_below_the_extra_plate";
        /// <summary>
        /// 下螺纹的长度,e
        /// </summary>
        public static readonly string ANCHOR_LENGTH_OF_THE_LOWER_THREAD = "anchor_length_of_the_lower_thread";
        /// <summary>
        ///铸造板孔的容许误差，默认值与基板的容许值相同
        /// </summary>
        public static readonly string ANCHOR_CAST_PLATE_HOLES_TOLERANCE = "anchor_cast_plate_holes_tolerance";
        /// <summary>
        /// 垫圈及垫圈板孔的容许误差
        /// </summary>
        public static readonly string ANCHOR_WASHER_HOLE_TOLERANCE = "anchor_washer_hole_tolerance";
        /// <summary>
        /// 选择是否创建垫片上的孔
        /// </summary>
        public static readonly string ANCHOR_SELECT_CREATE_HOLE_IN_WASHER = "anchor_select_create_hole_in_washer";
        /// <summary>
        /// 弯钩的方向
        /// </summary>
        public static readonly string ANCHOR_HOOK_DIRECTION = "anchor_hook_direction";
        /// <summary>
        /// 定义将锚钉杆的那些零件包括在锚钉杆构件中
        /// </summary>
        public static readonly string ANCHOR_ROD_ASSEMBLY_INCLUDED_SELECT = "anchor_rod_assembly_included_select";
        /// <summary>
        /// 灌浆层的厚度
        /// </summary>
        public static readonly string ANCHOR_GROUTING_THICKNESS = "anchor_grouting_thickness";
        /// <summary>
        /// 灌浆层的零件前缀
        /// </summary>
        public static readonly string ANCHOR_GROUTING_PART_PREFIX = "anchor_grouting_part_prefix";
        /// <summary>
        /// 灌浆层的零件编号
        /// </summary>
        public static readonly string ANCHOR_GROUTING_PART_NUMBER= "anchor_grouting_part_number";
        /// <summary>
        /// 灌浆层的构件前缀
        /// </summary>
        public static readonly string ANCHOR_GROUTING_COMPONENT_PREFIX = "anchor_grouting_component_prefix";
        /// <summary>
        /// 灌浆层的构件编号
        /// </summary>
        public static readonly string ANCHOR_GROUTING_COMPONENT_NUMBER= "anchor_grouting_component_number";
        #endregion
        #region EXTRAPLATES 附加板选项卡
        public static readonly string EXTRA_PLATES_PLATE_PRO_1 = "extra_plates_plate_pro_1";
        public static readonly string EXTRA_PLATES_PLATE_PRO_2 = "extra_plates_plate_pro_2";
        public static readonly string EXTRA_PLATES_PLATE_1_SELECT_POS_TYPE = "extra_plates_plate_1_select_pos_type";
        public static readonly string EXTRA_PLATES_PLATE_1_SELECT_ROTATION= "extra_plates_plate_1_select_rotation";
        public static readonly string EXTRA_PLATES_PLATE_1_DIST= "extra_plates_plate_1_dist";
        /// <summary>
        /// 埋件1上孔的容许误差
        /// </summary>
        public static readonly string EXTRA_PLATES_PLATE_1_HOLE_TOLERANCE = "extra_plates_plate_1_hole_tolerance";
        /// <summary>
        /// 选择是否创建埋件1上的孔
        /// </summary>
        public static readonly string EXTRA_PLATES_PLATE_1_SELECT_CREATE_HOLE_IN_WASHER = "extra_plates_plate_1_select_create_hole_in_washer";
        
        public static readonly string EXTRA_PLATES_PLATE_2_SELECT_TYPE = "extra_plates_plate_2_select_type";
        public static readonly string EXTRA_PLATES_PLATE_2_SELECT_DIR = "extra_plates_plate_2_select_dir";
        public static readonly string EXTRA_PLATES_PLATE_2_SELECT_ROTATION= "extra_plates_plate_2_select_rotation";
        public static readonly string EXTRA_PLATES_PLATE_2_DIST= "extra_plates_plate_2_dist";
        public static readonly string EXTRA_PLATES_PLATE_2_LENGTH= "extra_plates_plate_2_length";
        public static readonly string EXTRA_PLATES_PLATE_2_VERTICAL_OFFSET = "extra_plates_plate_2_vertical_offset";
        #endregion
        #region 临时板开孔
        public static readonly string TEMPORARY_PLATE_OPENING_HOR_LENGTH = "temporary_plate_opening_hor_length";
        public static readonly string TEMPORARY_PLATE_OPENING_VER_LENGTH = "temporary_plate_opening_ver_length";
        public static readonly string TEMPORARY_PLATE_OPENING_HEIGHT= "temporary_plate_opening_height";
        public static readonly string TEMPORARY_PLATE_OPENING_HOR_OFFSET = "temporary_plate_opening_hor_offset";
        public static readonly string TEMPORARY_PLATE_OPENING_VER_OFFSET = "temporary_plate_opening_ver_offset";
        public static readonly string TEMPORARY_PLATE_OPENING_HEIGHT_OFFSET = "temporary_plate_opening_height_offset";
        public static readonly string TEMPORARY_PLATE_OPENING_ROTATION = "temporary_plate_opening_rotation";

        /// <summary>
        /// 是否给临时板开孔
        /// </summary>
        public static readonly string TEMPORARY_PLATE_OPENING_SELECT_CAN_BUILD = "temporary_plate_opening_select_can_build";
        public static readonly string TEMPORARY_PLATE_OPENING_SELECT_CAN_LEVELING_PLATE = "temporary_plate_opening_select_can_leveling_plate";
        public static readonly string TEMPORARY_PLATE_OPENING_SELECT_CAN_FITTING_PLATE_1 = "temporary_plate_opening_select_can_fitting_plate_1";
        public static readonly string TEMPORARY_PLATE_OPENING_SELECT_CAN_FITTING_PLATE_2 = "temporary_plate_opening_select_can_fitting_plate_2";
        public static readonly string TEMPORARY_PLATE_OPENING_SELECT_CAN_FITTING_PLATE_3 = "temporary_plate_opening_select_can_fitting_plate_3";
        public static readonly string TEMPORARY_PLATE_OPENING_SELECT_CAN_CAST_PLATE = "temporary_plate_opening_select_can_cast_plate";
        public static readonly string TEMPORARY_PLATE_OPENING_SELECT_TYPE = "temporary_plate_opening_select_type";
        #endregion
        /// <summary>
        ///焊缝数组 
        /// </summary>
        public static readonly string[] WELD_PROPS_LIST = new string[]
        {
            "weld_props0",
            "weld_props1",
            "weld_props2",
            "weld_props3",
#if Example 
            "weld_props0",
            //"weld_props1",  | 以这种固定的名称形式添加
#endif
        };

    }
}
