﻿using System;
using LoongCAD.UI.Component;
using LoongCAD.Util;

namespace U.S.Base_plate_1047_.Main
{
    public class ParamsHandler:LoongCAD.STC.Plugins.ParamsHandlerBase
    {
        
        private static readonly string NoStartPostfix = "1";
        /// <summary>
        /// 属性空值全局总表
        /// </summary>
        /// <remarks><b>此静态变量可直接复制到其他组件代码中使用</b></remarks>
        protected static DObject g_emptyValues = null;

        /// <summary>
        /// 属性内置默认值全局总表
        /// </summary>
        /// <remarks><b>此静态变量可直接复制到其他组件代码中使用</b></remarks>
        protected static DObject g_builtinDefaults = null;
        
        /// <summary>
        /// 默认构造函数 
        /// </summary>
        public ParamsHandler() :base(EmptyValues,BuiltinDefaults) {}

        private static void AddEmptyDefaultValue(string paramName, object emptyValue, object defaultValue)
        {
            AddEmptyDefaultValue(g_emptyValues,g_builtinDefaults,paramName,emptyValue,defaultValue);
        }

        /// <summary>
        /// 初始化组件所有实例公用的属性空值，属性内置默认值
        /// </summary>
        /// <remarks><c>每个组件需要分别实现此方法</c></remarks>
        private static void InitializeEmptyDefaults()
        {
            g_emptyValues = new DObject();
            g_builtinDefaults= new DObject();

            //需要自适应的默认值值也用空值表示

            #region 图形标签页
            AddEmptyDefaultValue(ParamNames.PIC_TOP_VERTICAL_CHAMFER_FOR_STIFFENERS_1_2_4_5,double.MaxValue,0.0d);
            AddEmptyDefaultValue(ParamNames.PIC_TOP_HORIZONTAL_CHAMFER_FOR_STIFFENERS_1_2_4_5,double.MaxValue,0.0d);
            AddEmptyDefaultValue(ParamNames.PIC_BOTTOM_VERTICAL_CHAMFER_FOR_STIFFENERS_1_2_4_5,double.MaxValue,0.0d);
            AddEmptyDefaultValue(ParamNames.PIC_BOTTOM_HORIZONTAL_CHAMFER_FOR_STIFFENERS_1_2_4_5,double.MaxValue,0.0d);
            AddEmptyDefaultValue(ParamNames.PIC_TOP_VERTICAL_CHAMFER_FOR_STIFFENERS_3_6,double.MaxValue,0.0d);
            AddEmptyDefaultValue(ParamNames.PIC_TOP_HORIZONTAL_CHAMFER_FOR_STIFFENERS_3_6,double.MaxValue,0.0d);
            AddEmptyDefaultValue(ParamNames.PIC_BOTTOM_VERTICAL_CHAMFER_FOR_STIFFENERS_3_6,double.MaxValue,0.0d);
            AddEmptyDefaultValue(ParamNames.PIC_BOTTOM_HORIZONTAL_CHAMFER_FOR_STIFFENERS_3_6,double.MaxValue,0.0d);
            AddEmptyDefaultValue(ParamNames.PIC_TOP_VERTICAL_CHAMFER_FOR_STIFFENERS_7,double.MaxValue,0.0d);
            AddEmptyDefaultValue(ParamNames.PIC_TOP_HORIZONTAL_CHAMFER_FOR_STIFFENERS_7,double.MaxValue,0.0d);
            AddEmptyDefaultValue(ParamNames.PIC_BOTTOM_VERTICAL_CHAMFER_FOR_STIFFENERS_7,double.MaxValue,0.0d);
            AddEmptyDefaultValue(ParamNames.PIC_BOTTOM_HORIZONTAL_CHAMFER_FOR_STIFFENERS_7,double.MaxValue,0.0d);
            AddEmptyDefaultValue(ParamNames.PIC_TOP_VERTICAL_CHAMFER_FOR_STIFFENERS_8,double.MaxValue,0.0d);
            AddEmptyDefaultValue(ParamNames.PIC_TOP_HORIZONTAL_CHAMFER_FOR_STIFFENERS_8,double.MaxValue,0.0d);
            AddEmptyDefaultValue(ParamNames.PIC_BOTTOM_VERTICAL_CHAMFER_FOR_STIFFENERS_8,double.MaxValue,0.0d);
            AddEmptyDefaultValue(ParamNames.PIC_BOTTOM_HORIZONTAL_CHAMFER_FOR_STIFFENERS_8,double.MaxValue,0.0d);
            AddEmptyDefaultValue(ParamNames.PIC_WELD_GAP, double.MaxValue, 0.0d);
            AddEmptyDefaultValue(ParamNames.PIC_WIDTH_OF_BASE_PLATE_CHAMFER_1, double.MaxValue, 0.0d);
            AddEmptyDefaultValue(ParamNames.PIC_HEIGHT_OF_BASE_PLATE_CHAMFER_1, double.MaxValue, 0.0d);
            AddEmptyDefaultValue(ParamNames.PIC_WIDTH_OF_BASE_PLATE_CHAMFER_2, double.MaxValue, 0.0d);
            AddEmptyDefaultValue(ParamNames.PIC_HEIGHT_OF_BASE_PLATE_CHAMFER_2, double.MaxValue, 0.0d);
            AddEmptyDefaultValue(ParamNames.PIC_WIDTH_OF_BASE_PLATE_CHAMFER_3, double.MaxValue, 0.0d);
            AddEmptyDefaultValue(ParamNames.PIC_HEIGHT_OF_BASE_PLATE_CHAMFER_3, double.MaxValue, 0.0d);
            AddEmptyDefaultValue(ParamNames.PIC_WIDTH_OF_BASE_PLATE_CHAMFER_4, double.MaxValue, 0.0d);
            AddEmptyDefaultValue(ParamNames.PIC_HEIGHT_OF_BASE_PLATE_CHAMFER_4, double.MaxValue, 0.0d);
            AddEmptyDefaultValue(ParamNames.PIC_GROUT_HOLE_HORIZONTAL_DISTANCE_FROM_COLUMN_CENTER, double.MaxValue, 0.0d);
            AddEmptyDefaultValue(ParamNames.PIC_GROUT_HOLE_VERTICAL_DISTANCE_FROM_COLUMN_CENTER, double.MaxValue, 0.0d);
            AddEmptyDefaultValue(ParamNames.PIC_DIAMETER_OF_THE_GROUT_HOLE, double.MaxValue, 0.0d);
            #endregion
            #region 零件标签页 
            AddEmptyDefaultValue(ParamNames.PARTS_BASE_PLATE, PlatePropertyPanel.EmptyValue,
                (DObject)new object[]
                {
                    PlatePropertyPanel.ParamNames.Name,"基板",
                    PlatePropertyPanel.ParamNames.Thickness,20.0d,
                    PlatePropertyPanel.ParamNames.Width,double.MaxValue,
                    PlatePropertyPanel.ParamNames.Heigth,double.MaxValue,
                    PlatePropertyPanel.ParamNames.NoPrefix,"",
                    PlatePropertyPanel.ParamNames.NoStartPostfix,NoStartPostfix,
                    PlatePropertyPanel.ParamNames.Material,"Q235B",
                });
            AddEmptyDefaultValue(ParamNames.PARTS_STIFFENERS_1_2_4_5,PlatePropertyPanel.EmptyValue,
                (DObject)new object[]
                {
                    PlatePropertyPanel.ParamNames.Name,"加劲肋1,2,4,5",
                    PlatePropertyPanel.ParamNames.Thickness,double.MaxValue,
                    PlatePropertyPanel.ParamNames.Width,double.MaxValue,
                    PlatePropertyPanel.ParamNames.Heigth,double.MaxValue,
                    PlatePropertyPanel.ParamNames.NoPrefix,"",
                    PlatePropertyPanel.ParamNames.NoStartPostfix,NoStartPostfix,
                    PlatePropertyPanel.ParamNames.Material,"Q235B",
                });
            AddEmptyDefaultValue(ParamNames.PARTS_STIFFENERS_3_6,PlatePropertyPanel.EmptyValue,
                (DObject)new object[]
                {
                    PlatePropertyPanel.ParamNames.Name,"加劲肋3,6",
                    PlatePropertyPanel.ParamNames.Thickness,double.MaxValue,
                    PlatePropertyPanel.ParamNames.Width,double.MaxValue,
                    PlatePropertyPanel.ParamNames.Heigth,double.MaxValue,
                    PlatePropertyPanel.ParamNames.NoPrefix,"",
                    PlatePropertyPanel.ParamNames.NoStartPostfix,NoStartPostfix,
                    PlatePropertyPanel.ParamNames.Material,"Q235B",
                });
            AddEmptyDefaultValue(ParamNames.PARTS_STIFFENERS_7,PlatePropertyPanel.EmptyValue,
                (DObject)new object[]
                {
                    PlatePropertyPanel.ParamNames.Name,"加劲肋7",
                    PlatePropertyPanel.ParamNames.Thickness,double.MaxValue,
                    PlatePropertyPanel.ParamNames.Width,double.MaxValue,
                    PlatePropertyPanel.ParamNames.Heigth,double.MaxValue,
                    PlatePropertyPanel.ParamNames.NoPrefix,"",
                    PlatePropertyPanel.ParamNames.NoStartPostfix,NoStartPostfix,
                    PlatePropertyPanel.ParamNames.Material,"Q235B",
                });
            AddEmptyDefaultValue(ParamNames.PARTS_STIFFENERS_8,PlatePropertyPanel.EmptyValue,
                (DObject)new object[]
                {
                    PlatePropertyPanel.ParamNames.Name,"加劲肋8",
                    PlatePropertyPanel.ParamNames.Thickness,double.MaxValue,
                    PlatePropertyPanel.ParamNames.Width,double.MaxValue,
                    PlatePropertyPanel.ParamNames.Heigth,double.MaxValue,
                    PlatePropertyPanel.ParamNames.NoPrefix,"",
                    PlatePropertyPanel.ParamNames.NoStartPostfix,NoStartPostfix,
                    PlatePropertyPanel.ParamNames.Material,"Q235B",
                });
            AddEmptyDefaultValue(ParamNames.PARTS_KEY_PROFILE,BeamPropertyPanel.EmptyValue,
                (DObject)new object[]
                {
                    BeamPropertyPanel.ParamNames.Name,"抗剪键",
                    BeamPropertyPanel.ParamNames.NoPrefix,"",
                    BeamPropertyPanel.ParamNames.NoStartPostfix,NoStartPostfix,
                    BeamPropertyPanel.ParamNames.Material,"Q235B",
                }
            );
            AddEmptyDefaultValue(ParamNames.PARTS_LEVELING_PLATE, PlatePropertyPanel.EmptyValue,(DObject)new object[]
            {
                PlatePropertyPanel.ParamNames.Name,"层板",
                PlatePropertyPanel.ParamNames.Thickness,0.0d,
                PlatePropertyPanel.ParamNames.Width,double.MaxValue,//自适应
                PlatePropertyPanel.ParamNames.Heigth,double.MaxValue,//自适应
                PlatePropertyPanel.ParamNames.NoPrefix,"",
                PlatePropertyPanel.ParamNames.NoStartPostfix,NoStartPostfix,
                PlatePropertyPanel.ParamNames.Material,"Q235B",
            });
            AddEmptyDefaultValue(ParamNames.PARTS_FITTING_PLATE_1, PlatePropertyPanel.EmptyValue,(DObject)new object[]
            {
                PlatePropertyPanel.ParamNames.Name,"衬板1",
                PlatePropertyPanel.ParamNames.Thickness,0.0d,
                PlatePropertyPanel.ParamNames.Width,double.MaxValue,
                PlatePropertyPanel.ParamNames.Heigth,double.MaxValue,
                PlatePropertyPanel.ParamNames.NoPrefix,"",
                PlatePropertyPanel.ParamNames.NoStartPostfix,NoStartPostfix,
                PlatePropertyPanel.ParamNames.Material,"Q235B",
            });
            AddEmptyDefaultValue(ParamNames.PARTS_FITTING_PLATE_2, PlatePropertyPanel.EmptyValue,(DObject)new object[]
            {
                PlatePropertyPanel.ParamNames.Name,"衬板2",
                PlatePropertyPanel.ParamNames.Thickness,0.0d,
                PlatePropertyPanel.ParamNames.Width,double.MaxValue,
                PlatePropertyPanel.ParamNames.Heigth,double.MaxValue,
                PlatePropertyPanel.ParamNames.NoPrefix,"",
                PlatePropertyPanel.ParamNames.NoStartPostfix,NoStartPostfix,
                PlatePropertyPanel.ParamNames.Material,"Q235B",
            });
            AddEmptyDefaultValue(ParamNames.PARTS_FITTING_PLATE_3, PlatePropertyPanel.EmptyValue,(DObject)new object[]
            {
                PlatePropertyPanel.ParamNames.Name,"衬板3",
                PlatePropertyPanel.ParamNames.Thickness,0.0d,
                PlatePropertyPanel.ParamNames.Width,double.MaxValue,
                PlatePropertyPanel.ParamNames.Heigth,double.MaxValue,
                PlatePropertyPanel.ParamNames.NoPrefix,"",
                PlatePropertyPanel.ParamNames.NoStartPostfix,NoStartPostfix,
                PlatePropertyPanel.ParamNames.Material,"Q235B",
            });
            AddEmptyDefaultValue(ParamNames.PARTS_FITTING_PLATE_1_NUM,int.MaxValue,1);
            AddEmptyDefaultValue(ParamNames.PARTS_FITTING_PLATE_2_NUM,int.MaxValue,1);
            AddEmptyDefaultValue(ParamNames.PARTS_FITTING_PLATE_3_NUM,int.MaxValue,1);
            AddEmptyDefaultValue(ParamNames.PARTS_LEVELING_PLATE_HOLE_DIAMETER, double.MaxValue, 0.0d);
            AddEmptyDefaultValue(ParamNames.PARTS_SHEAR_KEY_PROFILE_WELDED,0,1);
            #endregion
            #region 参数选项卡
            AddEmptyDefaultValue(ParamNames.PARAMETERS_SQUARE_CUT_CORNERS_1TO4, new int[] { }, new int[] { });
            AddEmptyDefaultValue(ParamNames.PARAMETERS_BASE_PLATE_WITH_HOLES_OR_BOLTS, 0, 1);
            AddEmptyDefaultValue(ParamNames.PARAMETERS_BASE_PLATE_HORIZONTAL_OFFSET_FROM_THE_COLUMN_CENTER,double.MaxValue,0.0d);
            AddEmptyDefaultValue(ParamNames.PARAMETERS_BASE_PLATE_VERTICAL_OFFSET_FROM_THE_COLUMN_CENTER,double.MaxValue,0.0d);
            AddEmptyDefaultValue(ParamNames.PARAMETERS_SHEAR_KEY_HORIZONTAL_OFFSET,double.MaxValue,0.0d);
            AddEmptyDefaultValue(ParamNames.PARAMETERS_SHEAR_KEY_VERTICAL_OFFSET,double.MaxValue,0.0d);
            AddEmptyDefaultValue(ParamNames.PARAMETERS_SHEAR_KEY_ROTATION_ANGLE,double.MaxValue,0.0d);
            AddEmptyDefaultValue(ParamNames.PARAMETERS_SHEAR_KEY_LENGTH,double.MaxValue,double.MaxValue);
            AddEmptyDefaultValue(ParamNames.PARAMETERS_BOLT_GROUP_ROTATION_ANGLE, double.MaxValue, 0.0d);
            #endregion
            #region 螺栓选项卡
            AddEmptyDefaultValue(ParamNames.BOLTS_NUMBER_OF_HORIZONTAL_BOLTS,int.MaxValue,2);
            AddEmptyDefaultValue(ParamNames.BOLTS_NUMBER_OF_VERTICAL_BOLTS,int.MaxValue,2);
            AddEmptyDefaultValue(ParamNames.BOLTS_VERTICAL_BOLT_SPACING,new int[]{},new int[]{});
            AddEmptyDefaultValue(ParamNames.BOLTS_HORIZONTAL_BOLT_SPACING,new int[]{},new int[]{});
            AddEmptyDefaultValue(ParamNames.BOLTS_BOLT_EDGE_LEFT_DISTANCE,double.MaxValue,30.0d);
            AddEmptyDefaultValue(ParamNames.BOLTS_BOLT_EDGE_RIGHT_DISTANCE,double.MaxValue,30.0d);
            AddEmptyDefaultValue(ParamNames.BOLTS_BOLT_EDGE_TOP_VERTICAL_DISTANCE,double.MaxValue,30.0d);
            AddEmptyDefaultValue(ParamNames.BOLTS_BOLT_EDGE_BOTTOM_VERTICAL_DISTANCE,double.MaxValue,30.0d);
            AddEmptyDefaultValue(ParamNames.BOLTS_SELECT_HOW_TO_MEASURE_THE_DIMENSIONS_FOR_HORIZONTAL_BOLT_GROUP_POSITION,int.MaxValue,0);
            AddEmptyDefaultValue(ParamNames.BOLTS_SELECT_HOW_TO_MEASURE_THE_DIMENSIONS_FOR_VERTICAL_BOLT_GROUP_POSITION,int.MaxValue,0);
            AddEmptyDefaultValue(ParamNames.BOLTS_DIMENSION_FOR_HORIZONTAL_BOLT_GROUP_POSITION,double.MaxValue,0.0d);
            AddEmptyDefaultValue(ParamNames.BOLTS_DIMENSION_FOR_VERTICAL_BOLT_GROUP_POSITION,double.MaxValue,0.0d);
            AddEmptyDefaultValue(ParamNames.BOLTS_STAGGERING_OF_BOLTS, 0, 1);

            AddEmptyDefaultValue(ParamNames.BOLTS_BOLT_BASIC_PROPERTIES, BoltBasicPropertyPanel.EmptyValue,
                (DObject)new object[] {
                    BoltBasicPropertyPanel.ParamNames.BoltStandard,"TS10.9",
                    BoltBasicPropertyPanel.ParamNames.BoltSize,20.0d,
                    BoltBasicPropertyPanel.ParamNames.ThreadInMtrl,1,
                    BoltBasicPropertyPanel.ParamNames.MadeType0,1,
                });
            AddEmptyDefaultValue(ParamNames.BOLTS_SLOTTED_HOLES, BoltHolePanel.EmptyValue, 
                (DObject)new object[] {
                    BoltHolePanel.ParamNames.HoleX,0.0d,
                    BoltHolePanel.ParamNames.HoleY,0.0d,
                    BoltHolePanel.ParamNames.HoleType,2,
                    BoltHolePanel.ParamNames.RotSlot,3,
                    BoltHolePanel.ParamNames.SlotIn,4,
                });
            AddEmptyDefaultValue(ParamNames.BOLTS_BOLT_ASSEMBLY, null,
                (DObject)new object[] {
                    BoltContentPanel.ParamNames.PartWasherUp,false,
                    BoltContentPanel.ParamNames.PartWasherDown0,false,
                    BoltContentPanel.ParamNames.PartWasherDown1,true,
                    BoltContentPanel.ParamNames.PartNut0,true,
                    BoltContentPanel.ParamNames.PartNut1,false,
                });
            AddEmptyDefaultValue(ParamNames.BOLTS_BOLT_LENGTH_INCREASE, BoltExtendPanel.EmptyValue,
                (DObject)new object[] {
                    BoltExtendPanel.ParamNames.ExtLength,0.0d,
                });
            
            AddEmptyDefaultValue(ParamNames.BOLTS_BOLTING_DIRECTION,0,1); 
            AddEmptyDefaultValue(ParamNames.BOLTS_IGNORE_BOLT_INDEX_ARRAY,new int[]{},new int[]{});
            AddEmptyDefaultValue(ParamNames.BOLTS_SELECT_CAN_IGNORE_CENTRE_BOLT, 0, 1);
            #endregion
            #region 加劲肋选项卡
            AddEmptyDefaultValue(ParamNames.STIFFENER_POSITIONS_1TO8, new int[] { },new int[] { });
            AddEmptyDefaultValue(ParamNames.STIFFENER_1_OFFSET,double.MaxValue,0.0d);
            AddEmptyDefaultValue(ParamNames.STIFFENER_2_OFFSET,double.MaxValue,0.0d);
            AddEmptyDefaultValue(ParamNames.STIFFENER_3_OFFSET,double.MaxValue,0.0d);
            AddEmptyDefaultValue(ParamNames.STIFFENER_4_OFFSET,double.MaxValue,0.0d);
            AddEmptyDefaultValue(ParamNames.STIFFENER_5_OFFSET,double.MaxValue,0.0d);
            AddEmptyDefaultValue(ParamNames.STIFFENER_6_OFFSET,double.MaxValue,0.0d);
            AddEmptyDefaultValue(ParamNames.STIFFENER_7_OFFSET,double.MaxValue,0.0d);
            AddEmptyDefaultValue(ParamNames.STIFFENER_8_OFFSET,double.MaxValue,0.0d);

            #region 间距数目 
            AddEmptyDefaultValue(ParamNames.STIFFENER_3_NUMS,int.MaxValue,1);
            AddEmptyDefaultValue(ParamNames.STIFFENER_3_SPACING,new double[]{},new double[]{});
            AddEmptyDefaultValue(ParamNames.STIFFENER_6_NUMS,int.MaxValue,1);
            AddEmptyDefaultValue(ParamNames.STIFFENER_6_SPACING,new double[]{},new double[]{});
            AddEmptyDefaultValue(ParamNames.STIFFENER_7_NUMS,int.MaxValue,1);
            AddEmptyDefaultValue(ParamNames.STIFFENER_7_SPACING,new double[]{},new double[]{});
            AddEmptyDefaultValue(ParamNames.STIFFENER_8_NUMS,int.MaxValue,1);
            AddEmptyDefaultValue(ParamNames.STIFFENER_8_SPACING,new double[]{},new double[]{});
            #endregion
            #endregion
            #region 锚栓选项卡
            AddEmptyDefaultValue(ParamNames.ANCHOR_SELECT_CAN_BUILD, 0, 1);
            AddEmptyDefaultValue(ParamNames.ANCHOR_ROD_PROFILE, BeamPropertyPanel.EmptyValue,
                (DObject)new object[] {
                    BeamPropertyPanel.ParamNames.Name,"锚栓",
                    BeamPropertyPanel.ParamNames.Profile,"D20",
                    BeamPropertyPanel.ParamNames.NoPrefix,"",
                    BeamPropertyPanel.ParamNames.NoStartPostfix,NoStartPostfix,
                    BeamPropertyPanel.ParamNames.Material,"Q235B",
                });
            AddEmptyDefaultValue(ParamNames.ANCHOR_NUT_PROFILE,BeamPropertyPanel.EmptyValue,
                (DObject)new object[] {
                    BeamPropertyPanel.ParamNames.Name,"螺母",
                    BeamPropertyPanel.ParamNames.Profile,"",
                    BeamPropertyPanel.ParamNames.NoPrefix,"",
                    BeamPropertyPanel.ParamNames.NoStartPostfix,NoStartPostfix,
                    BeamPropertyPanel.ParamNames.Material,"Q235B",
                });
            AddEmptyDefaultValue(ParamNames.ANCHOR_WASHER_PROFILE,BeamPropertyPanel.EmptyValue,
                (DObject)new object[] {
                    BeamPropertyPanel.ParamNames.Name,"垫片",
                    BeamPropertyPanel.ParamNames.Profile,"",
                    BeamPropertyPanel.ParamNames.NoPrefix,"",
                    BeamPropertyPanel.ParamNames.NoStartPostfix,NoStartPostfix,
                    BeamPropertyPanel.ParamNames.Material,"Q235B",
                });
            AddEmptyDefaultValue(ParamNames.ANCHOR_WASHER_PLATE, PlatePropertyPanel.EmptyValue,
                (DObject) new object[]{
                    PlatePropertyPanel.ParamNames.Name,"板垫片",
                    PlatePropertyPanel.ParamNames.Thickness,10.0d,//需要判断是否填写
                    PlatePropertyPanel.ParamNames.Width,100.0d,
                    PlatePropertyPanel.ParamNames.Heigth,100.0d,
                    PlatePropertyPanel.ParamNames.NoPrefix,"",
                    PlatePropertyPanel.ParamNames.NoStartPostfix,NoStartPostfix,
                    PlatePropertyPanel.ParamNames.Material,"Q235B",
                });
            AddEmptyDefaultValue(ParamNames.ANCHOR_CAST_PLATE, PlatePropertyPanel.EmptyValue,
                (DObject) new object[]{
                    PlatePropertyPanel.ParamNames.Name,"锚栓临时固定板",
                    PlatePropertyPanel.ParamNames.Thickness,0.0d,
                    PlatePropertyPanel.ParamNames.Width,double.MaxValue,//自适应
                    PlatePropertyPanel.ParamNames.Heigth,double.MaxValue,//自适应
                    PlatePropertyPanel.ParamNames.NoPrefix,"",
                    PlatePropertyPanel.ParamNames.NoStartPostfix,NoStartPostfix,
                    PlatePropertyPanel.ParamNames.Material,"Q235B",
                });

            AddEmptyDefaultValue(ParamNames.ANCHOR_SELECT_CREATE_NUT_1, 0, 1);
            AddEmptyDefaultValue(ParamNames.ANCHOR_SELECT_CREATE_WASHER_2, 0, 1);
            AddEmptyDefaultValue(ParamNames.ANCHOR_SELECT_CREATE_WASHER_PLATE_3, 0, 1);
            AddEmptyDefaultValue(ParamNames.ANCHOR_SELECT_CREATE_NUT_4, 0, 1);
            AddEmptyDefaultValue(ParamNames.ANCHOR_SELECT_CREATE_WASHER_5, 0, 1);
            AddEmptyDefaultValue(ParamNames.ANCHOR_SELECT_CREATE_NUT_6, 0, 1);
            AddEmptyDefaultValue(ParamNames.ANCHOR_SELECT_CREATE_NUT_7, 0, 1);
            AddEmptyDefaultValue(ParamNames.ANCHOR_SELECT_CREATE_NUT_8, 0, 1);
            AddEmptyDefaultValue(ParamNames.ANCHOR_SELECT_CREATE_WASHER_PLATE_9, 0, 0);
            AddEmptyDefaultValue(ParamNames.ANCHOR_SELECT_CREATE_NUT_10, 0, 1);
            AddEmptyDefaultValue(ParamNames.ANCHOR_SELECT_WELD_NUT_1, 0, 2);
            AddEmptyDefaultValue(ParamNames.ANCHOR_SELECT_WELD_WASHER_2, 0, 2);
            AddEmptyDefaultValue(ParamNames.ANCHOR_SELECT_WELD_WASHER_PLATE_3, 0, 2);
            AddEmptyDefaultValue(ParamNames.ANCHOR_SELECT_WELD_NUT_4, 0, 2);
            AddEmptyDefaultValue(ParamNames.ANCHOR_SELECT_WELD_WASHER_5, 0, 2);
            AddEmptyDefaultValue(ParamNames.ANCHOR_SELECT_WELD_NUT_6, 0, 2);
            AddEmptyDefaultValue(ParamNames.ANCHOR_SELECT_WELD_NUT_7, 0, 2);
            AddEmptyDefaultValue(ParamNames.ANCHOR_SELECT_WELD_NUT_8, 0, 2);
            AddEmptyDefaultValue(ParamNames.ANCHOR_SELECT_WELD_WASHER_PLATE_9, 0, 2);
            AddEmptyDefaultValue(ParamNames.ANCHOR_SELECT_WELD_NUT_10, 0, 2);
            AddEmptyDefaultValue(ParamNames.ANCHOR_ROD_TYPES, 0, 1);
            AddEmptyDefaultValue(ParamNames.ANCHOR_SIZE_OR_LENGTH_OF_THE_NUT, double.MaxValue, double.MaxValue);//自适应
            AddEmptyDefaultValue(ParamNames.ANCHOR_SIZE_OR_THE_THICKNESS_OF_THE_WASHER, double.MaxValue, double.MaxValue);//自适应
            AddEmptyDefaultValue(ParamNames.ANCHOR_LENGTH_OF_THE_ANCHOR_ROD, double.MaxValue, 500.0d);
            AddEmptyDefaultValue(ParamNames.ANCHOR_LENGTH_OF_THE_ANCHOR_ROD_ABOVE_THE_BASE_PLATE, double.MaxValue, 50.0d);
            AddEmptyDefaultValue(ParamNames.ANCHOR_DISTANCE_BETWEEN_THE_CAST_PLATE_AND_THE_BASE_PLATE, double.MaxValue, 100.0d);
            AddEmptyDefaultValue(ParamNames.ANCHOR_LENGTH_OF_THE_UPPER_THREAD, double.MaxValue, 0.0d);
            //a,b,c,d,e
            AddEmptyDefaultValue(ParamNames.ANCHOR_RADIUS_OF_THE_HOOK, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(ParamNames.ANCHOR_WIDTH_OF_THE_HOOK, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(ParamNames.ANCHOR_HEIGHT_OF_THE_HOOK, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(ParamNames.ANCHOR_LENGTH_OF_THE_ANCHOR_ROD_BELOW_THE_EXTRA_PLATE, double.MaxValue, double.MaxValue);
            AddEmptyDefaultValue(ParamNames.ANCHOR_LENGTH_OF_THE_LOWER_THREAD, double.MaxValue, double.MaxValue);
            //孔隙
            AddEmptyDefaultValue(ParamNames.ANCHOR_CAST_PLATE_HOLES_TOLERANCE, double.MaxValue, double.MaxValue);//自适应
            AddEmptyDefaultValue(ParamNames.ANCHOR_WASHER_HOLE_TOLERANCE, double.MaxValue, double.MaxValue);//自适应
            AddEmptyDefaultValue(ParamNames.ANCHOR_SELECT_CREATE_HOLE_IN_WASHER, 0, 1);//自适应
            //弯钩
            AddEmptyDefaultValue(ParamNames.ANCHOR_HOOK_DIRECTION, 0, 1);
            //锚钉杆构件
            AddEmptyDefaultValue(ParamNames.ANCHOR_ROD_ASSEMBLY_INCLUDED_SELECT,0,1);
            //灌浆层厚度
            AddEmptyDefaultValue(ParamNames.ANCHOR_GROUTING_THICKNESS, double.MaxValue, 0.0d);
            //灌浆层前缀、编号
            AddEmptyDefaultValue(ParamNames.ANCHOR_GROUTING_PART_PREFIX,"","");
            AddEmptyDefaultValue(ParamNames.ANCHOR_GROUTING_PART_NUMBER,"",NoStartPostfix);
            AddEmptyDefaultValue(ParamNames.ANCHOR_GROUTING_COMPONENT_PREFIX,"","");
            AddEmptyDefaultValue(ParamNames.ANCHOR_GROUTING_COMPONENT_NUMBER,"",NoStartPostfix);
            #endregion
            #region 附加板选项卡 
            AddEmptyDefaultValue(ParamNames.EXTRA_PLATES_PLATE_PRO_1,BeamPropertyPanel.EmptyValue,
                (DObject) new object[]
            {
                BeamPropertyPanel.ParamNames.Name,"锚栓埋件1",
                BeamPropertyPanel.ParamNames.Profile,"PL10*100",
                BeamPropertyPanel.ParamNames.NoPrefix,"",
                BeamPropertyPanel.ParamNames.NoStartPostfix,NoStartPostfix,
                BeamPropertyPanel.ParamNames.Material,"Q235B",
            });
            
            AddEmptyDefaultValue(ParamNames.EXTRA_PLATES_PLATE_PRO_2,BeamPropertyPanel.EmptyValue,
                (DObject) new object[]
            {
                BeamPropertyPanel.ParamNames.Name,"锚栓埋件2",
                BeamPropertyPanel.ParamNames.Profile,"PL10*100",
                BeamPropertyPanel.ParamNames.NoPrefix,"",
                BeamPropertyPanel.ParamNames.NoStartPostfix,NoStartPostfix,
                BeamPropertyPanel.ParamNames.Material,"Q235B",
            });
            AddEmptyDefaultValue(ParamNames.EXTRA_PLATES_PLATE_1_SELECT_POS_TYPE,0,1);
            AddEmptyDefaultValue(ParamNames.EXTRA_PLATES_PLATE_1_SELECT_ROTATION,0,1);
            AddEmptyDefaultValue(ParamNames.EXTRA_PLATES_PLATE_1_DIST,double.MaxValue,50.0d);
            AddEmptyDefaultValue(ParamNames.EXTRA_PLATES_PLATE_1_HOLE_TOLERANCE,double.MaxValue,double.MaxValue);
            AddEmptyDefaultValue(ParamNames.EXTRA_PLATES_PLATE_1_SELECT_CREATE_HOLE_IN_WASHER,0,1);
            
            AddEmptyDefaultValue(ParamNames.EXTRA_PLATES_PLATE_2_SELECT_TYPE,0,1);
            AddEmptyDefaultValue(ParamNames.EXTRA_PLATES_PLATE_2_SELECT_DIR,0,1);
            AddEmptyDefaultValue(ParamNames.EXTRA_PLATES_PLATE_2_SELECT_ROTATION,0,1);
            AddEmptyDefaultValue(ParamNames.EXTRA_PLATES_PLATE_2_DIST,double.MaxValue,0.0d);
            AddEmptyDefaultValue(ParamNames.EXTRA_PLATES_PLATE_2_LENGTH,double.MaxValue,50.0d);
            AddEmptyDefaultValue(ParamNames.EXTRA_PLATES_PLATE_2_VERTICAL_OFFSET,double.MaxValue,10.0d);
            #endregion
            #region 临时板开孔 
            AddEmptyDefaultValue(ParamNames.TEMPORARY_PLATE_OPENING_HOR_LENGTH,double.MaxValue,200.0d);
            AddEmptyDefaultValue(ParamNames.TEMPORARY_PLATE_OPENING_VER_LENGTH,double.MaxValue,200.0d);
            AddEmptyDefaultValue(ParamNames.TEMPORARY_PLATE_OPENING_HEIGHT,double.MaxValue,200.0d);
            AddEmptyDefaultValue(ParamNames.TEMPORARY_PLATE_OPENING_ROTATION,double.MaxValue,0.0d);
            AddEmptyDefaultValue(ParamNames.TEMPORARY_PLATE_OPENING_VER_OFFSET,double.MaxValue,0.0d);
            AddEmptyDefaultValue(ParamNames.TEMPORARY_PLATE_OPENING_HOR_OFFSET,double.MaxValue,0.0d);
            AddEmptyDefaultValue(ParamNames.TEMPORARY_PLATE_OPENING_HEIGHT_OFFSET,double.MaxValue,0.0d);
            
            AddEmptyDefaultValue(ParamNames.TEMPORARY_PLATE_OPENING_SELECT_CAN_BUILD,0,0);
            AddEmptyDefaultValue(ParamNames.TEMPORARY_PLATE_OPENING_SELECT_CAN_LEVELING_PLATE,0,0);
            AddEmptyDefaultValue(ParamNames.TEMPORARY_PLATE_OPENING_SELECT_CAN_FITTING_PLATE_1,0,0);
            AddEmptyDefaultValue(ParamNames.TEMPORARY_PLATE_OPENING_SELECT_CAN_FITTING_PLATE_2,0,0);
            AddEmptyDefaultValue(ParamNames.TEMPORARY_PLATE_OPENING_SELECT_CAN_FITTING_PLATE_3,0,0);
            AddEmptyDefaultValue(ParamNames.TEMPORARY_PLATE_OPENING_SELECT_CAN_CAST_PLATE,0,0);
            AddEmptyDefaultValue(ParamNames.TEMPORARY_PLATE_OPENING_SELECT_TYPE,0,1);
            #endregion
            #region 焊缝 
            for (int i = 0; i < ParamNames.WELD_PROPS_LIST.Length; ++i)
            {
                AddEmptyDefaultValue(ParamNames.WELD_PROPS_LIST[i], WeldPropertyPanel.EmptyValue, new DObject {
                    { WeldPropertyPanel.ParamNames.SizeUp, 6.0 },
                    { WeldPropertyPanel.ParamNames.WeldTypeUp, 11 }, // Fillet
                    { WeldPropertyPanel.ParamNames.GrooveAngleUp, 0.0 },
                    { WeldPropertyPanel.ParamNames.WeldContourUp,  1}, // None
                    { WeldPropertyPanel.ParamNames.WeldFinishUp, 1 }, // None
                    { WeldPropertyPanel.ParamNames.LengthUp, 0.0 },
                    { WeldPropertyPanel.ParamNames.PitchUp, 0.0 },
                    { WeldPropertyPanel.ParamNames.RootFaceUp, 0.0 },
                    { WeldPropertyPanel.ParamNames.EffectiveThroatUp, 0.0 },
                    { WeldPropertyPanel.ParamNames.RootGapUp, 0.0 },

                    { WeldPropertyPanel.ParamNames.SizeDown, 6.0 },
                    { WeldPropertyPanel.ParamNames.WeldTypeDown, 11 }, // Fillet
                    { WeldPropertyPanel.ParamNames.GrooveAngleDown, 0.0 },
                    { WeldPropertyPanel.ParamNames.WeldContourDown,  1}, // None
                    { WeldPropertyPanel.ParamNames.WeldFinishDown, 1 }, // None
                    { WeldPropertyPanel.ParamNames.LengthDown, 0.0 },
                    { WeldPropertyPanel.ParamNames.PitchDown, 0.0 },
                    { WeldPropertyPanel.ParamNames.RootFaceDown, 0.0 },
                    { WeldPropertyPanel.ParamNames.EffectiveThroatDown, 0.0 },
                    { WeldPropertyPanel.ParamNames.RootGapDown, 0.0 },

                    { WeldPropertyPanel.ParamNames.EdgeAround, 1 }, // Edge
                    { WeldPropertyPanel.ParamNames.MadeType, 2 }, // Workshop
                    { WeldPropertyPanel.ParamNames.StitchWeld, 1 }, // false
                    { WeldPropertyPanel.ParamNames.RefText, "" }
                });
            }
            #endregion
        }


        /// <summary>
        /// 组件公用属性空值表
        /// </summary>
        /// <remarks><b>此方法可直接复制到其他组件代码中使用</b></remarks>
        public static DObject EmptyValues
        {
            get
            {
                if(g_emptyValues == null)
                {
                    InitializeEmptyDefaults();
                }
                return g_emptyValues;
            }
        }

        /// <summary>
        /// 组件公用内置默认值接口
        /// </summary>
        /// <remarks><b>此方法可直接复制到其他组件代码中使用</b></remarks>
        public static DObject BuiltinDefaults
        {
            get
            {
                if (g_builtinDefaults == null)
                {
                    InitializeEmptyDefaults();
                }
                return g_builtinDefaults;
            }
        }

        /// <summary>
        /// 初始化默认值
        /// </summary>
        /// <param name="defaultConfig">从默认值配置加载的默认值</param>
        /// <remarks><b>此方法可直接复制到其他组件代码中使用</b></remarks> 
        public override DObject InitializeDefaultValues(DObject defaultConfig)
        {
            m_defaultValues = new DObject();
            m_defaultValues.CopyFrom(defaultConfig);

            var emptyValues = ParamsHandler.EmptyValues;
            var builtinDefaults = ParamsHandler.BuiltinDefaults;
            if(emptyValues == null || builtinDefaults == null)
            {
                Console.WriteLine(@"ParamsHandler.InitializeDefaultValues:[Warning] EmptyValue/BuiltinDefault is null!");
                return m_defaultValues;
            }
            this.TryCompleteDObjectValues(m_defaultValues, builtinDefaults, emptyValues);
            return m_defaultValues;
        }
    }
}