﻿using LoongCAD.Geometry;

namespace U.S.Base_plate_1047_.Tool
{
    public class CoordinateSystem
    {
        public Vec3 Origin { get; set; }
        public Vec3 XAxis { get; set; }
        public Vec3 YAxis { get; set; }
        public Vec3 ZAxis { get; set; }

        public CoordinateSystem(Vec3 origin, Vec3 xAxis, Vec3 yAxis, Vec3 zAxis)
        {
            Origin = origin;
            XAxis = xAxis.Normalize();
            YAxis = yAxis.Normalize();
            ZAxis = zAxis.Normalize();
        }

        public Vec3 GeneratePoint(double xOffset, double yOffset, double zOffset)
        {
            // 计算偏移
            Vec3 xOffsetVec = new Vec3(XAxis.X * xOffset, XAxis.Y * xOffset, XAxis.Z * xOffset);
            Vec3 yOffsetVec = new Vec3(YAxis.X * yOffset, YAxis.Y * yOffset, YAxis.Z * yOffset);
            Vec3 zOffsetVec = new Vec3(ZAxis.X * zOffset, ZAxis.Y * zOffset, ZAxis.Z * zOffset);

            // 应用偏移，并返回世界坐标
            return Origin + xOffsetVec + yOffsetVec + zOffsetVec;
        }
    }
}
