﻿namespace WindBraceConnection110.Common
{
    public class ParamNames
    {
        /**
         * 图形页参数名称
         * --- 主零件X轴正方向为左侧
         */
        ///<summary>
        ///左侧支撑到主零件的距离
        ///</summary>
        public static readonly string PIC_LEFT_BRACE_DISTANCE_TO_PART = "pic_left_brace_distance_to_part";
        /// <summary>
        /// 左侧最后点击的支撑附近节点板边缘长度
        /// </summary>
        public static readonly string PIC_LEFT_LAST_BRACE_GUSSET_LENGTH = "pic_left_last_brace_gusset_length";
        /// <summary>
        /// 左侧最后点击的支撑附近节点板拐角
        /// </summary>
        public static readonly string PIC_LEFT_LAST_BRACE_GUSSET_CORNER = "pic_left_last_brace_gusset_corner";
        /// <summary>
        /// 左侧支撑之间的节点板边缘长度
        /// </summary>
        public static readonly string PIC_LEFT_BETWEEN_BRACE_GUSSET_LENGTH = "pic_left_between_brace_gusset_length";
        /// <summary>
        /// 左侧第一个点击的支撑附近节点板边缘长度
        /// </summary>
        public static readonly string PIC_LEFT_FIRST_BRACE_GUSSET_LENGTH = "pic_left_first_brace_gusset_length";
        /// <summary>
        /// 左侧第一个点击的支撑附近节点板拐角
        /// </summary>
        public static readonly string PIC_LEFT_FIRST_BRACE_GUSSET_CORNER = "pic_left_first_brace_gusset_corner";
        /// <summary>
        /// 左侧支撑间的位置关系
        /// </summary>
        public static readonly string PIC_LEFT_BRACE_POSITION = "pic_left_brace_position";
        /// <summary>
        /// 左侧支撑间的距离
        /// </summary>
        public static readonly string PIC_LEFT_DISTANCE_TO_BRACE = "pic_left_distance_to_brace";


        ///<summary>
        ///右侧支撑到主零件的距离
        ///</summary>
        public static readonly string PIC_RIGHT_BRACE_DISTANCE_TO_PART = "pic_right_brace_distance_to_part";
        /// <summary>
        /// 右侧最后点击的支撑附近节点板边缘长度
        /// </summary>
        public static readonly string PIC_RIGHT_LAST_BRACE_GUSSET_LENGTH = "pic_right_last_brace_gusset_length";
        /// <summary>
        /// 右侧最后点击的支撑附近节点板拐角
        /// </summary>
        public static readonly string PIC_RIGHT_LAST_BRACE_GUSSET_CORNER = "pic_right_last_brace_gusset_corner";
        /// <summary>
        /// 右侧支撑之间的节点板边缘长度
        /// </summary>
        public static readonly string PIC_RIGHT_BETWEEN_BRACE_GUSSET_LENGTH = "pic_right_between_brace_gusset_length";
        /// <summary>
        /// 右侧第一个点击的支撑附近节点板边缘长度
        /// </summary>
        public static readonly string PIC_RIGHT_FIRST_BRACE_GUSSET_LENGTH = "pic_right_first_brace_gusset_length";
        /// <summary>
        /// 右侧第一个点击的支撑附近节点板拐角
        /// </summary>
        public static readonly string PIC_RIGHT_FIRST_BRACE_GUSSET_CORNER = "pic_right_first_brace_gusset_corner";
        /// <summary>
        /// 右侧支撑间的位置关系
        /// </summary>
        public static readonly string PIC_RIGHT_BRACE_POSITION = "pic_right_brace_position";
        /// <summary>
        /// 右侧支撑间的距离
        /// </summary>
        public static readonly string PIC_RIGHT_DISTANCE_TO_BRACE = "pic_right_distance_to_brace";

        /// <summary>
        /// 节点板到主零件的距离
        /// </summary>
        public static readonly string PIC_GUSSET_DISTANCE_TO_PART = "pic_gusset_distance_to_part";


        /**
         * 节点板页参数名称
         */

        ///<summary>
        ///节点板属性
        ///</summary>
        public static readonly string GUSSET_PLATE_PROPS = "gusset_plate_props";
        /// <summary>
        /// 节点板形状
        /// </summary>
        public static readonly string GUSSET_PLATE_OVERALL_SHAPE = "gusset_plate_overall_shape";
        /// <summary>
        /// 支撑顺序
        /// </summary>
        public static readonly string GUSSET_BRACE_ORDER = "gusset_brace_order";
        /// <summary>
        /// 节点板上侧形状
        /// </summary>
        public static readonly string GUSSET_PLATE_UP_SHAPE = "gusset_plate_up_shape";
        /// <summary>
        /// 节点板下侧形状
        /// </summary>
        public static readonly string GUSSET_PLATE_DOWN_SHAPE = "gusset_plate_down_shape";
        /// <summary>
        /// 节点板位置
        /// </summary>
        public static readonly string GUSSET_PLATE_POSITION = "gusset_plate_position";
        /// <summary>
        /// 节点板在Z轴方向移动的距离
        /// </summary>
        public static readonly string GUSSET_PLATE_MOVE_Z = "gusset_plate_move_z";
        /// <summary>
        /// 是否启用支撑的焊接
        /// </summary>
        public static readonly string GUSSET_BRACE_WELD_ENABLED = "gusset_brace_weld_enabled";
        /// <summary>
        /// 节点板打孔位置
        /// </summary>
        public static readonly string GUSSET_PLATE_HOLE_POSITION = "gusset_plate_hole_position";
        /// <summary>
        /// 节点板孔直径
        /// </summary>
        public static readonly string GUSSET_PLATE_HOLE_DIAMETER = "gusset_plate_hole_diameter";
        /// <summary>
        /// 节点板孔到节点板边缘的距离
        /// </summary>
        public static readonly string GUSSER_PLATE_HOLE_EDGE_GAP = "gusset_plate_hole_edge_gap";
        /// <summary>
        /// 支撑槽口类型
        /// </summary>
        public static readonly string GUSSET_BRACE_NOTCH = "gusset_brace_notch";
        /// <summary>
        /// 支撑开槽折角尺寸
        /// </summary>
        public static readonly string GUSSET_BRACE_CHAMFER_LENGTH = "gusset_brace_chamfer_length";
        /// <summary>
        /// 支撑开槽折角角度
        /// </summary>
        public static readonly string GUSSET_BRACE_CHAMFER_ANGLE = "gusset_brace_chamfer_angle";
        /// <summary>
        /// 支撑垂直开槽尺寸
        /// </summary>
        public static readonly string GUSSET_BRACE_VERT_NOTCH_LENGTH = "gusset_brace_vert_notch_length";
        /// <summary>
        /// 支撑水平开槽尺寸
        /// </summary>
        public static readonly string GUSSET_BRACE_HORI_NOTCH_LENGTH = "gusset_brace_hori_notch_length";

        /**
         * 节点板螺栓页
         */

        public static readonly string GUSSET_BOLT_BASIC_PROPS = "gusset_bolt_basic_props";
        public static readonly string GUSSET_BOLT_ENABLED= "gusset_bolt_enabled";
        public static readonly string GUSSET_BOLT_SHAPE = "gusset_bolt_shape";
        public static readonly string GUSSET_BOLT_HORI_COUNT = "gusset_bolt_hori_count";
        public static readonly string GUSSET_BOLT_VERT_COUNT = "gusset_bolt_vert_count";
        public static readonly string GUSSET_BOLT_HORI_STRIDE = "gusset_bolt_hori_stride";
        public static readonly string GUSSET_BOLT_VERT_STRIDE = "gusset_bolt_vert_stride";
        public static readonly string GUSSET_BOLT_VERT_OFFSET_MODE = "gusset_bolt_vert_offset_mode";
        public static readonly string GUSSET_BOLT_VERT_OFFSET = "gusset_bolt_vert_offset";
        public static readonly string GUSSET_BOLT_HORI_OFFSET_MODE = "gusset_bolt_hori_offset_mode";
        public static readonly string GUSSET_BOLT_HORI_OFFSET = "gusset_bolt_hori_offset";

        /**
         * 螺栓参数页
         *  螺栓组基本属性
         *  槽孔属性
         *  构件属性
         *  螺栓延申长度属性
         *  螺栓组排列形状
         *  螺栓距离
         *  螺栓组在水平方向到支撑对齐面的边距
         *  螺栓组水平方向到节点板的边距
         *  垂直螺栓组位置尺寸的测量方式
         *  垂直螺栓组位置的尺寸
         *  水平方向螺栓数量
         *  垂直方向螺栓数量
         *  水平方向螺栓间距
         *  垂直方向螺栓间距
         */

        //支柱螺栓1
        public static readonly string BOLT1_BASIC_PROPS = "bolt1_basic_props";
        public static readonly string BOLT1_HOLE_PROPS = "bolt1_hole_props";
        public static readonly string BOLT1_CONTENT_PROPS = "bolt1_content_props";
        public static readonly string BOLT1_EXTEND_PROPS = "bolt1_extend_props";
        public static readonly string BOLT1_SHAPE = "bolt1_shape";
        /// <summary>
        /// 螺栓距离
        /// </summary>
        public static readonly string BOLT1_DISTANCE = "bolt1_distance";
        /// <summary>
        /// 螺栓组在水平方向到支撑对齐面的边距
        /// </summary>
        public static readonly string BOLT1_HORI_BRACE_MARGIN = "bolt1_hori_brace_margin";
        /// <summary>
        /// 螺栓组水平方向到节点板的边距
        /// </summary>
        public static readonly string BOLT1_HORI_GUSSET_MARGIN = "bolt1_hori_gusset_margin";
        public static readonly string BOLT1_VERT_OFFSET_MODE = "bolt1_vert_offset_mode";
        public static readonly string BOLT1_VERT_OFFSET = "bolt1_vert_offset";
        public static readonly string BOLT1_HORI_COUNT = "bolt1_hori_count";
        public static readonly string BOLT1_VERT_COUNT = "bolt1_vert_count";
        public static readonly string BOLT1_HORI_STRIDE = "bolt1_hori_stride";
        public static readonly string BOLT1_VERT_STRIDE = "bolt1_vert_stride";

        //支柱螺栓2
        public static readonly string BOLT2_BASIC_PROPS = "bolt2_basic_props";
        public static readonly string BOLT2_HOLE_PROPS = "bolt2_hole_props";
        public static readonly string BOLT2_CONTENT_PROPS = "bolt2_content_props";
        public static readonly string BOLT2_EXTEND_PROPS = "bolt2_extend_props";
        public static readonly string BOLT2_SHAPE = "bolt2_shape";
        /// <summary>
        /// 螺栓距离
        /// </summary>
        public static readonly string BOLT2_DISTANCE = "bolt2_distance";
        /// <summary>
        /// 螺栓组在水平方向到支撑对齐面的边距
        /// </summary>
        public static readonly string BOLT2_HORI_BRACE_MARGIN = "bolt2_hori_brace_margin";
        /// <summary>
        /// 螺栓组水平方向到节点板的边距
        /// </summary>
        public static readonly string BOLT2_HORI_GUSSET_MARGIN = "bolt2_hori_gusset_margin";
        public static readonly string BOLT2_VERT_OFFSET_MODE = "bolt2_vert_offset_mode";
        public static readonly string BOLT2_VERT_OFFSET = "bolt2_vert_offset";
        public static readonly string BOLT2_HORI_COUNT = "bolt2_hori_count";
        public static readonly string BOLT2_VERT_COUNT = "bolt2_vert_count";
        public static readonly string BOLT2_HORI_STRIDE = "bolt2_hori_stride";
        public static readonly string BOLT2_VERT_STRIDE = "bolt2_vert_stride";

        /**
         * 焊缝属性名称
         */
        public static readonly string[] WELD_PROPS_LIST = new string[]
        {
            "weld_props0",
            "weld_props1",
            "weld_props2",
        };
    }
}
