﻿using LoongCAD.Geometry;
using stiffeners1030.Main;

namespace stiffeners1030.Running
{
    public class BuildCutMain:RunningBaseClass
    {
        public BuildCutMain(ComponentInstanceContext context) : base(context)
        {
        }

        private ParamData AllParamData = new ParamData();

        private class ParamData
        {
            internal int m_selectCut;
        }

        private bool m_bCanCut = false;

        public override bool Init()
        {
            var handler = m_context.ParamsHandler;
            AllParamData.m_selectCut = handler.GetIntValue(ParamNames.PARAMETERS_BEAM_FITTING_OPTION);
            m_bCanCut = AllParamData.m_selectCut == 2;
            return true;
        }

        public override bool Execute()
        {
            if (!m_bCanCut) {return true;}
            var cutPlane = new Plane(m_context.DetailPt,m_context.FarToDetail);
            m_context.TargetComp.CreateAlignPlane(m_context.MainPart, cutPlane, true);
            
            return true;
        }
    }
}